/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x3) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x3) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x3) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x3) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x3) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x3) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x3) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x3) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x3) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              return 180; /* *addhi3_zero_extend_split */

            case 1:
              return 226; /* *addpsi3.zero_extend.qi_split */

            case 2:
              return 230; /* *addpsi3.zero_extend.hi_split */

            case 3:
              return 228; /* *addsi3.zero_extend.qi_split */

            case 4:
              return 232; /* *addsi3.zero_extend.hi_split */

            case 5:
              return 234; /* *addsi3.zero_extend.psi_split */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST:
        case SYMBOL_REF:
          operands[2] = x3;
          if (pattern189 (x2) != 0)
            return -1;
          if (const_m255_to_m1_operand (operands[2], E_HImode))
            return 184; /* *addhi3_zero_extend.const_split */
          if (!const_0mod256_operand (operands[2], E_HImode))
            return -1;
          return 186; /* *aligned_add_symbol */

        case ZERO_EXTEND:
          if (pattern161 (x2) != 0)
            return -1;
          return 189; /* *usum_widenqihi3_split */

        default:
          return -1;
        }

    case 2:
      return 187; /* *addhi3_zero_extend.ashift1.split */

    case 3:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1369; /* *shl.ext.and1-to-skip.hi */

    case 4:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1375; /* *shl.ext.and1-to-skip.psi */

    case 5:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1387; /* *shl.ext.and1-to-skip.psi */

    case 6:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1381; /* *shl.ext.and1-to-skip.si */

    case 7:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1393; /* *shl.ext.and1-to-skip.si */

    case 8:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1399; /* *shl.ext.and1-to-skip.si */

    case 9:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1368; /* *shl.ext.and1-to-skip.hi */

    case 10:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1374; /* *shl.ext.and1-to-skip.psi */

    case 11:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1386; /* *shl.ext.and1-to-skip.psi */

    case 12:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1380; /* *shl.ext.and1-to-skip.si */

    case 13:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1392; /* *shl.ext.and1-to-skip.si */

    case 14:
      if (!
#line 10794 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1398; /* *shl.ext.and1-to-skip.si */

    case 15:
      return 224; /* *addhi3.sign_extend.qi_split */

    case 16:
      return 225; /* *addpsi3.sign_extend.qi_split */

    case 17:
      return 229; /* *addpsi3.sign_extend.hi_split */

    case 18:
      return 227; /* *addsi3.sign_extend.qi_split */

    case 19:
      return 231; /* *addsi3.sign_extend.hi_split */

    case 20:
      return 233; /* *addsi3.sign_extend.psi_split */

    case 21:
      return 316; /* *addqi3.msbit_split */

    case 22:
      return 318; /* *addhi3.msbit_split */

    case 23:
      return 320; /* *addpsi3.msbit_split */

    case 24:
      return 322; /* *addsi3.msbit_split */

    case 25:
      return 324; /* *addhi3.sex.msbit_split */

    case 26:
      return 326; /* *addpsi3.sex.msbit_split */

    case 27:
      return 330; /* *addpsi3.sex.msbit_split */

    case 28:
      return 328; /* *addsi3.sex.msbit_split */

    case 29:
      return 332; /* *addsi3.sex.msbit_split */

    case 30:
      return 334; /* *addsi3.sex.msbit_split */

    case 31:
      return 317; /* *addqi3.msbit_split */

    case 32:
      return 319; /* *addhi3.msbit_split */

    case 33:
      return 321; /* *addpsi3.msbit_split */

    case 34:
      return 323; /* *addsi3.msbit_split */

    case 35:
      return 325; /* *addhi3.sex.msbit_split */

    case 36:
      return 327; /* *addpsi3.sex.msbit_split */

    case 37:
      return 331; /* *addpsi3.sex.msbit_split */

    case 38:
      return 329; /* *addsi3.sex.msbit_split */

    case 39:
      return 333; /* *addsi3.sex.msbit_split */

    case 40:
      return 335; /* *addsi3.sex.msbit_split */

    case 41:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 380; /* *addqi3.ge0 */
        }
      return 412; /* *addqi3.ge0_split */

    case 42:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 388; /* *addqi3.ge0 */
        }
      return 420; /* *addqi3.ge0_split */

    case 43:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 396; /* *addqi3.ge0 */
        }
      return 428; /* *addqi3.ge0_split */

    case 44:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 404; /* *addqi3.ge0 */
        }
      return 436; /* *addqi3.ge0_split */

    case 45:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 382; /* *addhi3.ge0 */
        }
      return 414; /* *addhi3.ge0_split */

    case 46:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 390; /* *addhi3.ge0 */
        }
      return 422; /* *addhi3.ge0_split */

    case 47:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 398; /* *addhi3.ge0 */
        }
      return 430; /* *addhi3.ge0_split */

    case 48:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 406; /* *addhi3.ge0 */
        }
      return 438; /* *addhi3.ge0_split */

    case 49:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 384; /* *addpsi3.ge0 */
        }
      return 416; /* *addpsi3.ge0_split */

    case 50:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 392; /* *addpsi3.ge0 */
        }
      return 424; /* *addpsi3.ge0_split */

    case 51:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 400; /* *addpsi3.ge0 */
        }
      return 432; /* *addpsi3.ge0_split */

    case 52:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 408; /* *addpsi3.ge0 */
        }
      return 440; /* *addpsi3.ge0_split */

    case 53:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 386; /* *addsi3.ge0 */
        }
      return 418; /* *addsi3.ge0_split */

    case 54:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 394; /* *addsi3.ge0 */
        }
      return 426; /* *addsi3.ge0_split */

    case 55:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 402; /* *addsi3.ge0 */
        }
      return 434; /* *addsi3.ge0_split */

    case 56:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 410; /* *addsi3.ge0 */
        }
      return 442; /* *addsi3.ge0_split */

    case 57:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 381; /* *addqi3.lt0 */
        }
      return 413; /* *addqi3.lt0_split */

    case 58:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 389; /* *addqi3.lt0 */
        }
      return 421; /* *addqi3.lt0_split */

    case 59:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 397; /* *addqi3.lt0 */
        }
      return 429; /* *addqi3.lt0_split */

    case 60:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 405; /* *addqi3.lt0 */
        }
      return 437; /* *addqi3.lt0_split */

    case 61:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 383; /* *addhi3.lt0 */
        }
      return 415; /* *addhi3.lt0_split */

    case 62:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 391; /* *addhi3.lt0 */
        }
      return 423; /* *addhi3.lt0_split */

    case 63:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 399; /* *addhi3.lt0 */
        }
      return 431; /* *addhi3.lt0_split */

    case 64:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 407; /* *addhi3.lt0 */
        }
      return 439; /* *addhi3.lt0_split */

    case 65:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 385; /* *addpsi3.lt0 */
        }
      return 417; /* *addpsi3.lt0_split */

    case 66:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 393; /* *addpsi3.lt0 */
        }
      return 425; /* *addpsi3.lt0_split */

    case 67:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 401; /* *addpsi3.lt0 */
        }
      return 433; /* *addpsi3.lt0_split */

    case 68:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 409; /* *addpsi3.lt0 */
        }
      return 441; /* *addpsi3.lt0_split */

    case 69:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 387; /* *addsi3.lt0 */
        }
      return 419; /* *addsi3.lt0_split */

    case 70:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 395; /* *addsi3.lt0 */
        }
      return 427; /* *addsi3.lt0_split */

    case 71:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 403; /* *addsi3.lt0 */
        }
      return 435; /* *addsi3.lt0_split */

    case 72:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 411; /* *addsi3.lt0 */
        }
      return 443; /* *addsi3.lt0_split */

    case 73:
      x2 = XEXP (x1, 1);
      if (pattern125 (x2, 
E_QImode) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          if (
#line 2592 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 490; /* *maddqi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2607 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *maddqi4 */

        case CONST_INT:
          if (pnum_clobbers == NULL
              || !const_int_operand (operands[2], E_QImode)
              || !
#line 2645 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *maddqi4.const */

        default:
          return -1;
        }

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern127 (x2))
        {
        case 0:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          x4 = XEXP (x2, 0);
          x5 = XEXP (x4, 1);
          switch (GET_CODE (x5))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x5) != E_HImode)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2701 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 496; /* *maddqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2716 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (GET_MODE (x5) != E_HImode)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return 505; /* *sumsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2776 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 513; /* *maddqihi4.sconst */
                }
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2947 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1332; /* *mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1338; /* *mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1350; /* *mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1344; /* *mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1356; /* *mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1362; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern128 (x2))
        {
        case 0:
          if (
#line 2701 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 497; /* *umaddqihi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2716 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 499; /* *umaddqihi4 */

        case 1:
          if (
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
            return 504; /* *usmsubqihi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2776 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
            return -1;
          *pnum_clobbers = 1;
          return 506; /* *usmsubqihi4 */

        case 2:
          x4 = XEXP (x2, 0);
          x5 = XEXP (x4, 1);
          if (XWINT (x5, 0) == 2L)
            {
              x3 = XEXP (x2, 1);
              operands[2] = x3;
              if (
#line 2832 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
                return 512; /* *umaddqihi4.2 */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          if (!u8_operand (operands[2], E_HImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[3] = x3;
          if (!
#line 2855 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 514; /* *umaddqihi4.uconst */

        case 3:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1333; /* *mul.ext.and1-to-skip.hi */

        case 4:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1339; /* *mul.ext.and1-to-skip.psi */

        case 5:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1351; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1345; /* *mul.ext.and1-to-skip.si */

        case 7:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1357; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10774 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1363; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern129 (x2))
        {
        case 0:
          if (!
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1320; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1323; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1326; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10757 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1329; /* *mul.and1-to-skip.si */

        default:
          return -1;
        }

    case 77:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1272; /* *pixop-to-skip.qi */

    case 78:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1284; /* *pixop-to-skip.qi */

    case 79:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1296; /* *pixop-to-skip.qi */

    case 80:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1308; /* *pixop-to-skip.qi */

    case 81:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1275; /* *pixop-to-skip.hi */

    case 82:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1287; /* *pixop-to-skip.hi */

    case 83:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1299; /* *pixop-to-skip.hi */

    case 84:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1311; /* *pixop-to-skip.hi */

    case 85:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1278; /* *pixop-to-skip.psi */

    case 86:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1290; /* *pixop-to-skip.psi */

    case 87:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1302; /* *pixop-to-skip.psi */

    case 88:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1314; /* *pixop-to-skip.psi */

    case 89:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1281; /* *pixop-to-skip.si */

    case 90:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1293; /* *pixop-to-skip.si */

    case 91:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1305; /* *pixop-to-skip.si */

    case 92:
      if (!
#line 10732 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1317; /* *pixop-to-skip.si */

    case 93:
      if (!
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1404; /* *shl.and-to-skip.hi */

    case 94:
      if (!
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1407; /* *shl.and-to-skip.psi */

    case 95:
      if (!
#line 10813 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1410; /* *shl.and-to-skip.si */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !nonmemory_operand (operands[1], E_HImode)
          || !
#line 6819 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 864; /* cmphi3 */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !nonmemory_operand (operands[1], E_HQmode)
          || !
#line 6819 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 865; /* cmphq3 */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !nonmemory_operand (operands[1], E_UHQmode)
          || !
#line 6819 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 866; /* cmpuhq3 */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !nonmemory_operand (operands[1], E_HAmode)
          || !
#line 6819 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 867; /* cmpha3 */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !nonmemory_operand (operands[1], E_UHAmode)
          || !
#line 6819 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 868; /* cmpuha3 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !nonmemory_operand (operands[1], E_PSImode)
          || !
#line 6854 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 869; /* *cmppsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode)
          || !
#line 6886 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 870; /* *cmpsi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !nonmemory_operand (operands[1], E_SQmode)
          || !
#line 6886 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 871; /* *cmpsq */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !nonmemory_operand (operands[1], E_USQmode)
          || !
#line 6886 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 872; /* *cmpusq */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !nonmemory_operand (operands[1], E_SAmode)
          || !
#line 6886 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 873; /* *cmpsa */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !nonmemory_operand (operands[1], E_USAmode)
          || !
#line 6886 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 874; /* *cmpusa */

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 36
          && GET_MODE (x6) == E_CCmode)
        {
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern321 (x4, 
E_QImode) == 0
                  && 
#line 2218 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 301; /* *mulqi3_enh */
              break;

            case E_HImode:
              if (pattern321 (x4, 
E_HImode) == 0
                  && 
#line 3286 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 538; /* *mulhi3_enh */
              break;

            case E_QQmode:
              if (pattern321 (x4, 
E_QQmode) == 0
                  && 
#line 309 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3077; /* *mulqq3_enh */
              break;

            case E_UQQmode:
              if (pattern321 (x4, 
E_UQQmode) == 0
                  && 
#line 330 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3079; /* *muluqq3_enh */
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x5) != REG)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG
          || GET_CODE (x6) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          if (pattern281 (x1) != 0
              || !
#line 2239 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 302; /* *mulqi3_call_split */

        case 22:
          if (pattern282 (x1) != 0
              || !
#line 3715 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 564; /* *mulsi3_call_split */

        case 18:
          switch (pattern283 (x1))
            {
            case 0:
              if (!
#line 425 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3082; /* *mulhq3.call_split */

            case 1:
              if (!
#line 425 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3083; /* *muluhq3.call_split */

            case 2:
              if (!
#line 425 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3084; /* *mulha3.call_split */

            case 3:
              if (!
#line 425 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3085; /* *muluha3.call_split */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x8) != 20
              || REGNO (x7) != 24
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern272 (x3))
            {
            case 0:
              if (!
#line 481 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3092; /* *mulsa3.call */

            case 1:
              if (!
#line 481 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3093; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) == E_HImode)
        {
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          if (pattern298 (x4, 
E_HImode, 
26, 
E_SImode) != 0
              || pattern299 (x3, 
E_SImode, 
22) != 0
              || !
#line 3788 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 570; /* *mulhisi3_call */

        case 26:
          if (pattern300 (x3, 
E_SImode, 
22, 
18, 
E_HImode) != 0
              || !
#line 3859 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 580; /* *mulshisi3_call */

        case 25:
          if (pattern300 (x3, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
              || !
#line 4238 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 603; /* *mulsqipsi3.libgcc */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG
          || pattern183 (x1, 
E_SImode, 
22) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      if (REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x9) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3788 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 571; /* *umulhisi3_call */

            case SIGN_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3838 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 577; /* *usmulhisi3_call */

            default:
              return -1;
            }

        case 26:
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 18
              || !
#line 3859 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 581; /* *muluhisi3_call */

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND)
        return -1;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != NOT)
        return -1;
      if (GET_MODE (x11) == E_QImode)
        {
          res = recog_46 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 18
          || GET_MODE (x8) != E_SImode
          || pattern155 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x9) != E_SImode
          || !
#line 3880 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 583; /* *mulohisi3_call */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case LSHIFTRT:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MULT)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern286 (x1, 
SIGN_EXTEND) == 0
              && 
#line 2282 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 306; /* *smulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern287 (x1, 
SIGN_EXTEND) != 0
              || !
#line 3800 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 572; /* *smulhi3_highpart_call_split */

        case ZERO_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern286 (x1, 
ZERO_EXTEND) == 0
              && 
#line 2282 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 307; /* *umulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern287 (x1, 
ZERO_EXTEND) != 0
              || !
#line 3800 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 573; /* *umulhi3_highpart_call_split */

        default:
          return -1;
        }

    case PARITY:
      if (pattern206 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9243 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1030; /* *paritysihi2.libgcc */

    case POPCOUNT:
      if (pattern206 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9319 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1035; /* *popcountsi2.libgcc */

    case CLZ:
      if (pattern206 (x1, 
E_QImode, 
26) != 0)
        return -1;
      return 1041; /* *clzsihi2.libgcc_split */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern99 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode)
          || !
#line 6452 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 807; /* *extendqihi2 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6473 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 809; /* *extendqipsi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6515 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 813; /* *extendhipsi2 */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6494 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 811; /* *extendqisi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6536 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 815; /* *extendhisi2 */

        case E_PSImode:
          if (!combine_pseudo_register_operand (operands[1], E_PSImode)
              || !
#line 6557 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 817; /* *extendpsisi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_HImode))
    return -1;
  if (
#line 7929 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL))
    return 974; /* *tablejump_split */
  if (pnum_clobbers == NULL
      || !
#line 7950 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
    return -1;
  *pnum_clobbers = 1;
  return 975; /* *tablejump */
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 881 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 119; /* *reload_inqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 881 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 120; /* *reload_inqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 881 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 121; /* *reload_inuqq */

    case E_HImode:
      if (!l_register_operand (operands[0], E_HImode)
          || !immediate_operand (operands[1], E_HImode)
          || !
#line 946 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 123; /* *reload_inhi */

    case E_HQmode:
      if (!l_register_operand (operands[0], E_HQmode)
          || !immediate_operand (operands[1], E_HQmode)
          || !
#line 946 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 124; /* *reload_inhq */

    case E_UHQmode:
      if (!l_register_operand (operands[0], E_UHQmode)
          || !immediate_operand (operands[1], E_UHQmode)
          || !
#line 946 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 125; /* *reload_inuhq */

    case E_HAmode:
      if (!l_register_operand (operands[0], E_HAmode)
          || !immediate_operand (operands[1], E_HAmode)
          || !
#line 946 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 126; /* *reload_inha */

    case E_UHAmode:
      if (!l_register_operand (operands[0], E_UHAmode)
          || !immediate_operand (operands[1], E_UHAmode)
          || !
#line 946 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 127; /* *reload_inuha */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 138; /* *reload_inpsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 141; /* *reload_insi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 142; /* *reload_insi */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 143; /* *reload_insi */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 144; /* *reload_insi */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 145; /* *reload_insi */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1279 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 159; /* *reload_insf */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          switch (pattern288 (x1))
            {
            case 0:
              return 168; /* *clrmemqi_split */

            case 1:
              return 170; /* *clrmemhi_split */

            default:
              return -1;
            }

        case MULT:
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || pattern150 (x2) != 0
              || pattern106 (x1) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x10 = XEXP (x7, 0);
          if (GET_CODE (x10) != REG
              || GET_MODE (x10) != E_HImode)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (pattern176 (x8) != 0)
            return -1;
          switch (pattern360 (x1))
            {
            case 0:
              if (!
#line 3762 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && reload_completed))
                return -1;
              return 567; /* *mulsi3_call_pr118012 */

            case 1:
              if (!
#line 4268 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 605; /* *mulpsi3.libgcc */

            default:
              return -1;
            }

        case DIV:
          switch (pattern118 (x1, 
MOD))
            {
            case 0:
              x11 = XEXP (x3, 1);
              if (REGNO (x11) != 22)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x5, 1);
              x13 = XEXP (x12, 0);
              if (REGNO (x13) != 24)
                return -1;
              x14 = XEXP (x12, 1);
              if (REGNO (x14) != 22)
                return -1;
              x8 = XVECEXP (x1, 0, 4);
              x15 = XEXP (x8, 0);
              if (REGNO (x15) != 36
                  || GET_MODE (x15) != E_CCmode)
                return -1;
              switch (pattern374 (x1))
                {
                case 0:
                  if (!
#line 3936 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 586; /* *divmodqi4_call */

                case 1:
                  if (!
#line 4024 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 592; /* *divmodhi4_call */

                default:
                  return -1;
                }

            case 1:
              switch (pattern368 (x1))
                {
                case 0:
                  return 607; /* *divmodpsi4_call_split */

                case 1:
                  if (!
#line 4422 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 614; /* *divmodsi4_call */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UDIV:
          switch (pattern118 (x1, 
UMOD))
            {
            case 0:
              if (pattern361 (x1, 
E_HImode, 
22, 
24) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x16 = XEXP (x5, 0);
              if (REGNO (x16) != 24
                  || GET_MODE (x16) != E_HImode)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              x17 = XEXP (x6, 0);
              if (REGNO (x17) != 26
                  || GET_MODE (x17) != E_HImode)
                return -1;
              x7 = XVECEXP (x1, 0, 3);
              x10 = XEXP (x7, 0);
              if (REGNO (x10) != 21
                  || GET_MODE (x10) != E_QImode)
                return -1;
              x8 = XVECEXP (x1, 0, 4);
              x15 = XEXP (x8, 0);
              if (REGNO (x15) != 36
                  || GET_MODE (x15) != E_CCmode
                  || GET_MODE (x3) != E_HImode)
                return -1;
              x12 = XEXP (x5, 1);
              if (GET_MODE (x12) != E_HImode
                  || !
#line 4071 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 595; /* *udivmodhi4_call */

            case 1:
              switch (pattern368 (x1))
                {
                case 0:
                  return 610; /* *udivmodpsi4_call_split */

                case 1:
                  if (!
#line 4469 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 617; /* *udivmodsi4_call */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern119 (x1) != 0
              || pattern177 (x1, 
CLOBBER) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          x10 = XEXP (x7, 0);
          if (x10 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x18 = XVECEXP (x3, 0, 0);
              operands[0] = x18;
              if (register_operand (operands[0], E_HImode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x16 = XEXP (x5, 0);
                  x19 = XEXP (x16, 0);
                  operands[1] = x19;
                  x6 = XVECEXP (x1, 0, 2);
                  x17 = XEXP (x6, 0);
                  operands[2] = x17;
                  if (scratch_operand (operands[2], E_HImode)
                      && 
#line 7950 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
                    return 975; /* *tablejump */
                }
            }
          x18 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x18) != REG
              || pattern325 (x1) != 0
              || !
#line 7987 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL && reload_completed))
            return -1;
          return 977; /* *tablejump.3byte-pc */

        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[10] = x3;
          if (!extend_operator (operands[10], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != PARALLEL
              || XVECLEN (x5, 0) != 2)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x20) != SET)
            return -1;
          x21 = XEXP (x20, 1);
          if (GET_CODE (x21) != PLUS
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x22) != CLOBBER)
            return -1;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != SCRATCH
              || GET_MODE (x23) != E_QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 2)
            return -1;
          x24 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x24) != SET)
            return -1;
          x25 = XEXP (x24, 1);
          if (GET_CODE (x25) != IF_THEN_ELSE)
            return -1;
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != GTU)
            return -1;
          x27 = XEXP (x25, 1);
          if (GET_CODE (x27) != LABEL_REF)
            return -1;
          x28 = XEXP (x25, 2);
          if (GET_CODE (x28) != PC)
            return -1;
          x29 = XEXP (x24, 0);
          if (GET_CODE (x29) != PC)
            return -1;
          x30 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x30) != CLOBBER)
            return -1;
          x31 = XEXP (x30, 0);
          if (GET_CODE (x31) != SCRATCH
              || GET_MODE (x31) != E_QImode)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 4)
            return -1;
          x32 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x32) != SET)
            return -1;
          x33 = XEXP (x32, 1);
          if (GET_CODE (x33) != UNSPEC
              || XVECLEN (x33, 0) != 1
              || XINT (x33, 1) != 2
              || GET_MODE (x33) != E_HImode)
            return -1;
          x34 = XEXP (x32, 0);
          if (GET_CODE (x34) != PC)
            return -1;
          x35 = XVECEXP (x8, 0, 1);
          if (GET_CODE (x35) != USE)
            return -1;
          x36 = XEXP (x35, 0);
          if (GET_CODE (x36) != LABEL_REF)
            return -1;
          x37 = XVECEXP (x8, 0, 2);
          if (GET_CODE (x37) != CLOBBER)
            return -1;
          x38 = XVECEXP (x8, 0, 3);
          if (GET_CODE (x38) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[11] = x9;
          x39 = XEXP (x20, 0);
          operands[5] = x39;
          if (!register_operand (operands[5], E_SImode))
            return -1;
          x40 = XEXP (x21, 1);
          operands[1] = x40;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x41 = XEXP (x26, 1);
          operands[2] = x41;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x42 = XEXP (x27, 0);
          operands[4] = x42;
          x10 = XEXP (x7, 0);
          operands[7] = x10;
          if (!register_operand (operands[7], E_HImode))
            return -1;
          x43 = XEXP (x7, 1);
          operands[6] = x43;
          x44 = XEXP (x36, 0);
          operands[3] = x44;
          x45 = XEXP (x37, 0);
          operands[8] = x45;
          x46 = XEXP (x38, 0);
          operands[9] = x46;
          x47 = XEXP (x21, 0);
          if (!rtx_equal_p (x47, operands[0]))
            return -1;
          x48 = XEXP (x26, 0);
          if (!rtx_equal_p (x48, operands[5]))
            return -1;
          x49 = XVECEXP (x33, 0, 0);
          if (!rtx_equal_p (x49, operands[7]))
            return -1;
          switch (GET_MODE (operands[11]))
            {
            case E_QImode:
              if (!register_operand (operands[11], E_QImode)
                  || !
#line 8100 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && avr_casei_sequence_check_operands (operands)))
                return -1;
              return 978; /* casesi_qi_sequence */

            case E_HImode:
              if (!register_operand (operands[11], E_HImode)
                  || !
#line 8100 "../../gcc-15.1.1-20250425/gcc/config/avr/avr.md"
(optimize
   && avr_casei_sequence_check_operands (operands)))
                return -1;
              return 979; /* casesi_hi_sequence */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pattern175 (x1) != 0
              || pattern187 (x1, 
E_CCmode, 
36, 
30) != 0)
            return -1;
          x12 = XEXP (x5, 1);
          x14 = XEXP (x12, 1);
          operands[0] = x14;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x50 = XEXP (x6, 1);
          x51 = XEXP (x50, 1);
          if (!rtx_equal_p (x51, operands[0]))
            return -1;
          return 997; /* epilogue_restores */

        case 2:
          if (XINT (x2, 1) != 10)
            return -1;
          x52 = XVECEXP (x2, 0, 1);
          if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern248 (x1) != 0)
            return -1;
          return 1007; /* delay_cycles_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1031 (insn, operands);

    case 1:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1032 (insn, operands);

    case 2:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1033 (insn, operands);

    case 3:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1034 (insn, operands);

    case 4:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1035 (insn, operands);

    case 5:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1036 (insn, operands);

    case 6:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1037 (insn, operands);

    case 7:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1038 (insn, operands);

    case 8:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1039 (insn, operands);

    case 9:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1040 (insn, operands);

    case 10:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1041 (insn, operands);

    case 11:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1042 (insn, operands);

    case 12:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1043 (insn, operands);

    case 13:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1044 (insn, operands);

    case 14:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1045 (insn, operands);

    case 15:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1046 (insn, operands);

    case 16:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1047 (insn, operands);

    case 17:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1048 (insn, operands);

    case 18:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != QQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1049 (insn, operands);

    case 19:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1050 (insn, operands);

    case 20:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1051 (insn, operands);

    case 21:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1052 (insn, operands);

    case 22:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1053 (insn, operands);

    case 23:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1054 (insn, operands);

    case 24:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1055 (insn, operands);

    case 25:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1056 (insn, operands);

    case 26:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1057 (insn, operands);

    case 27:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1058 (insn, operands);

    case 28:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1059 (insn, operands);

    case 29:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1060 (insn, operands);

    case 30:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1061 (insn, operands);

    case 31:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1062 (insn, operands);

    case 32:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1063 (insn, operands);

    case 33:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1064 (insn, operands);

    case 34:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1065 (insn, operands);

    case 35:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1066 (insn, operands);

    case 36:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1067 (insn, operands);

    case 37:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != UQQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1068 (insn, operands);

    case 38:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1069 (insn, operands);

    case 39:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1070 (insn, operands);

    case 40:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1071 (insn, operands);

    case 41:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1072 (insn, operands);

    case 42:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1073 (insn, operands);

    case 43:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1074 (insn, operands);

    case 44:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1075 (insn, operands);

    case 45:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1076 (insn, operands);

    case 46:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1077 (insn, operands);

    case 47:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1078 (insn, operands);

    case 48:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1079 (insn, operands);

    case 49:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1080 (insn, operands);

    case 50:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1081 (insn, operands);

    case 51:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1082 (insn, operands);

    case 52:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1083 (insn, operands);

    case 53:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1084 (insn, operands);

    case 54:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1085 (insn, operands);

    case 55:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1086 (insn, operands);

    case 56:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != HQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1087 (insn, operands);

    case 57:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1088 (insn, operands);

    case 58:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1089 (insn, operands);

    case 59:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1090 (insn, operands);

    case 60:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1091 (insn, operands);

    case 61:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1092 (insn, operands);

    case 62:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1093 (insn, operands);

    case 63:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1094 (insn, operands);

    case 64:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1095 (insn, operands);

    case 65:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1096 (insn, operands);

    case 66:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1097 (insn, operands);

    case 67:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1098 (insn, operands);

    case 68:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1099 (insn, operands);

    case 69:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1100 (insn, operands);

    case 70:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1101 (insn, operands);

    case 71:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1102 (insn, operands);

    case 72:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1103 (insn, operands);

    case 73:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1104 (insn, operands);

    case 74:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1105 (insn, operands);

    case 75:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != UHQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1106 (insn, operands);

    case 76:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1107 (insn, operands);

    case 77:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1108 (insn, operands);

    case 78:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1109 (insn, operands);

    case 79:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1110 (insn, operands);

    case 80:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1111 (insn, operands);

    case 81:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1112 (insn, operands);

    case 82:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1113 (insn, operands);

    case 83:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1114 (insn, operands);

    case 84:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1115 (insn, operands);

    case 85:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1116 (insn, operands);

    case 86:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1117 (insn, operands);

    case 87:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1118 (insn, operands);

    case 88:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1119 (insn, operands);

    case 89:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1120 (insn, operands);

    case 90:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1121 (insn, operands);

    case 91:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1122 (insn, operands);

    case 92:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1123 (insn, operands);

    case 93:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1124 (insn, operands);

    case 94:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != HAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1125 (insn, operands);

    case 95:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1126 (insn, operands);

    case 96:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1127 (insn, operands);

    case 97:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1128 (insn, operands);

    case 98:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1129 (insn, operands);

    case 99:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1130 (insn, operands);

    case 100:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1131 (insn, operands);

    case 101:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1132 (insn, operands);

    case 102:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1133 (insn, operands);

    case 103:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1134 (insn, operands);

    case 104:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1135 (insn, operands);

    case 105:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1136 (insn, operands);

    case 106:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1137 (insn, operands);

    case 107:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1138 (insn, operands);

    case 108:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1139 (insn, operands);

    case 109:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1140 (insn, operands);

    case 110:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1141 (insn, operands);

    case 111:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1142 (insn, operands);

    case 112:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1143 (insn, operands);

    case 113:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != UHAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1144 (insn, operands);

    case 114:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1145 (insn, operands);

    case 115:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1146 (insn, operands);

    case 116:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1147 (insn, operands);

    case 117:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1148 (insn, operands);

    case 118:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1149 (insn, operands);

    case 119:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1150 (insn, operands);

    case 120:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1151 (insn, operands);

    case 121:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1152 (insn, operands);

    case 122:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1153 (insn, operands);

    case 123:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1154 (insn, operands);

    case 124:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1155 (insn, operands);

    case 125:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1156 (insn, operands);

    case 126:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1157 (insn, operands);

    case 127:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1158 (insn, operands);

    case 128:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1159 (insn, operands);

    case 129:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1160 (insn, operands);

    case 130:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1161 (insn, operands);

    case 131:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1162 (insn, operands);

    case 132:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != SQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1163 (insn, operands);

    case 133:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1164 (insn, operands);

    case 134:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1165 (insn, operands);

    case 135:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1166 (insn, operands);

    case 136:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1167 (insn, operands);

    case 137:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1168 (insn, operands);

    case 138:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1169 (insn, operands);

    case 139:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1170 (insn, operands);

    case 140:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1171 (insn, operands);

    case 141:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1172 (insn, operands);

    case 142:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1173 (insn, operands);

    case 143:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1174 (insn, operands);

    case 144:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1175 (insn, operands);

    case 145:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1176 (insn, operands);

    case 146:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1177 (insn, operands);

    case 147:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1178 (insn, operands);

    case 148:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1179 (insn, operands);

    case 149:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1180 (insn, operands);

    case 150:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1181 (insn, operands);

    case 151:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != USQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1182 (insn, operands);

    case 152:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1183 (insn, operands);

    case 153:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1184 (insn, operands);

    case 154:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1185 (insn, operands);

    case 155:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1186 (insn, operands);

    case 156:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1187 (insn, operands);

    case 157:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1188 (insn, operands);

    case 158:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1189 (insn, operands);

    case 159:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1190 (insn, operands);

    case 160:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1191 (insn, operands);

    case 161:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1192 (insn, operands);

    case 162:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1193 (insn, operands);

    case 163:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1194 (insn, operands);

    case 164:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1195 (insn, operands);

    case 165:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1196 (insn, operands);

    case 166:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1197 (insn, operands);

    case 167:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1198 (insn, operands);

    case 168:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1199 (insn, operands);

    case 169:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1200 (insn, operands);

    case 170:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != SAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1201 (insn, operands);

    case 171:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1202 (insn, operands);

    case 172:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1203 (insn, operands);

    case 173:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1204 (insn, operands);

    case 174:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1205 (insn, operands);

    case 175:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1206 (insn, operands);

    case 176:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1207 (insn, operands);

    case 177:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1208 (insn, operands);

    case 178:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1209 (insn, operands);

    case 179:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1210 (insn, operands);

    case 180:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1211 (insn, operands);

    case 181:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1212 (insn, operands);

    case 182:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1213 (insn, operands);

    case 183:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1214 (insn, operands);

    case 184:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1215 (insn, operands);

    case 185:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1216 (insn, operands);

    case 186:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1217 (insn, operands);

    case 187:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1218 (insn, operands);

    case 188:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1219 (insn, operands);

    case 189:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != USAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1220 (insn, operands);

    case 190:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1221 (insn, operands);

    case 191:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1222 (insn, operands);

    case 192:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1223 (insn, operands);

    case 193:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1224 (insn, operands);

    case 194:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1225 (insn, operands);

    case 195:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1226 (insn, operands);

    case 196:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1227 (insn, operands);

    case 197:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1228 (insn, operands);

    case 198:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1229 (insn, operands);

    case 199:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1230 (insn, operands);

    case 200:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1231 (insn, operands);

    case 201:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1232 (insn, operands);

    case 202:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1233 (insn, operands);

    case 203:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1234 (insn, operands);

    case 204:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1235 (insn, operands);

    case 205:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1236 (insn, operands);

    case 206:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1237 (insn, operands);

    case 207:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1238 (insn, operands);

    case 208:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != DQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1239 (insn, operands);

    case 209:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1240 (insn, operands);

    case 210:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1241 (insn, operands);

    case 211:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1242 (insn, operands);

    case 212:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1243 (insn, operands);

    case 213:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1244 (insn, operands);

    case 214:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1245 (insn, operands);

    case 215:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1246 (insn, operands);

    case 216:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1247 (insn, operands);

    case 217:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1248 (insn, operands);

    case 218:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1249 (insn, operands);

    case 219:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1250 (insn, operands);

    case 220:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1251 (insn, operands);

    case 221:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1252 (insn, operands);

    case 222:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1253 (insn, operands);

    case 223:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1254 (insn, operands);

    case 224:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1255 (insn, operands);

    case 225:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1256 (insn, operands);

    case 226:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1257 (insn, operands);

    case 227:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != UDQmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1258 (insn, operands);

    case 228:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1259 (insn, operands);

    case 229:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1260 (insn, operands);

    case 230:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1261 (insn, operands);

    case 231:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1262 (insn, operands);

    case 232:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1263 (insn, operands);

    case 233:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1264 (insn, operands);

    case 234:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1265 (insn, operands);

    case 235:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1266 (insn, operands);

    case 236:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1267 (insn, operands);

    case 237:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1268 (insn, operands);

    case 238:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1269 (insn, operands);

    case 239:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1270 (insn, operands);

    case 240:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1271 (insn, operands);

    case 241:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1272 (insn, operands);

    case 242:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1273 (insn, operands);

    case 243:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1274 (insn, operands);

    case 244:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1275 (insn, operands);

    case 245:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1276 (insn, operands);

    case 246:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != DAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1277 (insn, operands);

    case 247:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1278 (insn, operands);

    case 248:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1279 (insn, operands);

    case 249:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1280 (insn, operands);

    case 250:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1281 (insn, operands);

    case 251:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1282 (insn, operands);

    case 252:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1283 (insn, operands);

    case 253:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1284 (insn, operands);

    case 254:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1285 (insn, operands);

    case 255:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1286 (insn, operands);

    case 256:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1287 (insn, operands);

    case 257:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1288 (insn, operands);

    case 258:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1289 (insn, operands);

    case 259:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1290 (insn, operands);

    case 260:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1291 (insn, operands);

    case 261:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1292 (insn, operands);

    case 262:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1293 (insn, operands);

    case 263:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1294 (insn, operands);

    case 264:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1295 (insn, operands);

    case 265:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != UDAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1296 (insn, operands);

    case 266:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1297 (insn, operands);

    case 267:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1298 (insn, operands);

    case 268:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1299 (insn, operands);

    case 269:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1300 (insn, operands);

    case 270:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1301 (insn, operands);

    case 271:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1302 (insn, operands);

    case 272:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1303 (insn, operands);

    case 273:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1304 (insn, operands);

    case 274:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1305 (insn, operands);

    case 275:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1306 (insn, operands);

    case 276:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1307 (insn, operands);

    case 277:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1308 (insn, operands);

    case 278:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1309 (insn, operands);

    case 279:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1310 (insn, operands);

    case 280:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1311 (insn, operands);

    case 281:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1312 (insn, operands);

    case 282:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1313 (insn, operands);

    case 283:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1314 (insn, operands);

    case 284:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != TAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1315 (insn, operands);

    case 285:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1316 (insn, operands);

    case 286:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1317 (insn, operands);

    case 287:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1318 (insn, operands);

    case 288:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1319 (insn, operands);

    case 289:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1320 (insn, operands);

    case 290:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1321 (insn, operands);

    case 291:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1322 (insn, operands);

    case 292:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1323 (insn, operands);

    case 293:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1324 (insn, operands);

    case 294:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1325 (insn, operands);

    case 295:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1326 (insn, operands);

    case 296:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1327 (insn, operands);

    case 297:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1328 (insn, operands);

    case 298:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1329 (insn, operands);

    case 299:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1330 (insn, operands);

    case 300:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1331 (insn, operands);

    case 301:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1332 (insn, operands);

    case 302:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1333 (insn, operands);

    case 303:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != UTAmode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1334 (insn, operands);

    case 304:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1335 (insn, operands);

    case 305:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1336 (insn, operands);

    case 306:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1337 (insn, operands);

    case 307:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1338 (insn, operands);

    case 308:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1339 (insn, operands);

    case 309:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1340 (insn, operands);

    case 310:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1341 (insn, operands);

    case 311:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1342 (insn, operands);

    case 312:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1343 (insn, operands);

    case 313:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1344 (insn, operands);

    case 314:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1345 (insn, operands);

    case 315:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1346 (insn, operands);

    case 316:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1347 (insn, operands);

    case 317:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1348 (insn, operands);

    case 318:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1349 (insn, operands);

    case 319:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1350 (insn, operands);

    case 320:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1351 (insn, operands);

    case 321:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1352 (insn, operands);

    case 322:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != QImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1353 (insn, operands);

    case 323:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1354 (insn, operands);

    case 324:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1355 (insn, operands);

    case 325:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1356 (insn, operands);

    case 326:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1357 (insn, operands);

    case 327:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1358 (insn, operands);

    case 328:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1359 (insn, operands);

    case 329:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1360 (insn, operands);

    case 330:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1361 (insn, operands);

    case 331:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1362 (insn, operands);

    case 332:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1363 (insn, operands);

    case 333:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1364 (insn, operands);

    case 334:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1365 (insn, operands);

    case 335:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1366 (insn, operands);

    case 336:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1367 (insn, operands);

    case 337:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1368 (insn, operands);

    case 338:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1369 (insn, operands);

    case 339:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1370 (insn, operands);

    case 340:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1371 (insn, operands);

    case 341:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != HImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1372 (insn, operands);

    case 342:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1373 (insn, operands);

    case 343:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1374 (insn, operands);

    case 344:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1375 (insn, operands);

    case 345:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1376 (insn, operands);

    case 346:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1377 (insn, operands);

    case 347:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1378 (insn, operands);

    case 348:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1379 (insn, operands);

    case 349:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1380 (insn, operands);

    case 350:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1381 (insn, operands);

    case 351:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1382 (insn, operands);

    case 352:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1383 (insn, operands);

    case 353:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1384 (insn, operands);

    case 354:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1385 (insn, operands);

    case 355:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1386 (insn, operands);

    case 356:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1387 (insn, operands);

    case 357:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1388 (insn, operands);

    case 358:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1389 (insn, operands);

    case 359:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1390 (insn, operands);

    case 360:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DImode != SImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1391 (insn, operands);

    case 361:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QQmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1392 (insn, operands);

    case 362:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UQQmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1393 (insn, operands);

    case 363:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HQmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1394 (insn, operands);

    case 364:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHQmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1395 (insn, operands);

    case 365:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HAmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1396 (insn, operands);

    case 366:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UHAmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1397 (insn, operands);

    case 367:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SQmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1398 (insn, operands);

    case 368:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USQmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1399 (insn, operands);

    case 369:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SAmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1400 (insn, operands);

    case 370:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(USAmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1401 (insn, operands);

    case 371:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DQmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1402 (insn, operands);

    case 372:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDQmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1403 (insn, operands);

    case 373:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(DAmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1404 (insn, operands);

    case 374:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UDAmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1405 (insn, operands);

    case 375:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(TAmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1406 (insn, operands);

    case 376:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(UTAmode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1407 (insn, operands);

    case 377:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(QImode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1408 (insn, operands);

    case 378:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(HImode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1409 (insn, operands);

    case 379:
      if (!(
#line 62 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
(SImode != DImode) && 
#line 64 "../../gcc-15.1.1-20250425/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1410 (insn, operands);

    default:
      return NULL;
    }
}
