/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern0 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 4;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 6;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 7;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 8;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 9;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 10;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 11;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 16;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 17;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 18;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 19;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 22;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 23;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 24;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 26;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 27;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 28;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 29;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 30;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 31;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 32;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 33;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 34;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 35;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 36;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 37;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 38;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 39;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 40;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 41;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 42;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 43;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 44;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 45;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 46;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 47;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 48;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 49;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 50;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 51;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 52;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 53;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 54;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 55;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 56;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 57;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 58;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 59;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 60;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 61;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 62;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 63;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 64;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 65;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 66;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 67;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 68;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 69;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 70;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 71;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 72;

    case E_RVVM8HFmode:
      if (pattern0 (x3, 
E_RVVM8HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM4HFmode:
      if (pattern0 (x3, 
E_RVVM4HFmode) != 0)
        return -1;
      return 74;

    case E_RVVM2HFmode:
      if (pattern0 (x3, 
E_RVVM2HFmode) != 0)
        return -1;
      return 75;

    case E_RVVM1HFmode:
      if (pattern0 (x3, 
E_RVVM1HFmode) != 0)
        return -1;
      return 76;

    case E_RVVMF2HFmode:
      if (pattern0 (x3, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF4HFmode:
      if (pattern0 (x3, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8SFmode:
      if (pattern0 (x3, 
E_RVVM8SFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4SFmode:
      if (pattern0 (x3, 
E_RVVM4SFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2SFmode:
      if (pattern0 (x3, 
E_RVVM2SFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1SFmode:
      if (pattern0 (x3, 
E_RVVM1SFmode) != 0)
        return -1;
      return 82;

    case E_RVVMF2SFmode:
      if (pattern0 (x3, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 83;

    case E_RVVM8DFmode:
      if (pattern0 (x3, 
E_RVVM8DFmode) != 0)
        return -1;
      return 84;

    case E_RVVM4DFmode:
      if (pattern0 (x3, 
E_RVVM4DFmode) != 0)
        return -1;
      return 85;

    case E_RVVM2DFmode:
      if (pattern0 (x3, 
E_RVVM2DFmode) != 0)
        return -1;
      return 86;

    case E_RVVM1DFmode:
      if (pattern0 (x3, 
E_RVVM1DFmode) != 0)
        return -1;
      return 87;

    case E_V1HFmode:
      if (pattern0 (x3, 
E_V1HFmode) != 0)
        return -1;
      return 88;

    case E_V2HFmode:
      if (pattern0 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 89;

    case E_V4HFmode:
      if (pattern0 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 90;

    case E_V8HFmode:
      if (pattern0 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 91;

    case E_V16HFmode:
      if (pattern0 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 92;

    case E_V32HFmode:
      if (pattern0 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 93;

    case E_V64HFmode:
      if (pattern0 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 94;

    case E_V128HFmode:
      if (pattern0 (x3, 
E_V128HFmode) != 0)
        return -1;
      return 95;

    case E_V256HFmode:
      if (pattern0 (x3, 
E_V256HFmode) != 0)
        return -1;
      return 96;

    case E_V512HFmode:
      if (pattern0 (x3, 
E_V512HFmode) != 0)
        return -1;
      return 97;

    case E_V1024HFmode:
      if (pattern0 (x3, 
E_V1024HFmode) != 0)
        return -1;
      return 98;

    case E_V2048HFmode:
      if (pattern0 (x3, 
E_V2048HFmode) != 0)
        return -1;
      return 99;

    case E_V1SFmode:
      if (pattern0 (x3, 
E_V1SFmode) != 0)
        return -1;
      return 100;

    case E_V2SFmode:
      if (pattern0 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 101;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 102;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 103;

    case E_V16SFmode:
      if (pattern0 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 104;

    case E_V32SFmode:
      if (pattern0 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 105;

    case E_V64SFmode:
      if (pattern0 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 106;

    case E_V128SFmode:
      if (pattern0 (x3, 
E_V128SFmode) != 0)
        return -1;
      return 107;

    case E_V256SFmode:
      if (pattern0 (x3, 
E_V256SFmode) != 0)
        return -1;
      return 108;

    case E_V512SFmode:
      if (pattern0 (x3, 
E_V512SFmode) != 0)
        return -1;
      return 109;

    case E_V1024SFmode:
      if (pattern0 (x3, 
E_V1024SFmode) != 0)
        return -1;
      return 110;

    case E_V1DFmode:
      if (pattern0 (x3, 
E_V1DFmode) != 0)
        return -1;
      return 111;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 112;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 113;

    case E_V8DFmode:
      if (pattern0 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 114;

    case E_V16DFmode:
      if (pattern0 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 115;

    case E_V32DFmode:
      if (pattern0 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 116;

    case E_V64DFmode:
      if (pattern0 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 117;

    case E_V128DFmode:
      if (pattern0 (x3, 
E_V128DFmode) != 0)
        return -1;
      return 118;

    case E_V256DFmode:
      if (pattern0 (x3, 
E_V256DFmode) != 0)
        return -1;
      return 119;

    case E_V512DFmode:
      if (pattern0 (x3, 
E_V512DFmode) != 0)
        return -1;
      return 120;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i5)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != i4)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x18) != SET)
    return -1;
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != i3)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x24) != SET)
    return -1;
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != i2)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x30) != SET)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern53 (x1); /* [-1, 1] */

    case E_RVVM4HFmode:
      res = pattern54 (x1);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern55 (x1);
      if (res >= 0)
        return res + 5; /* [5, 7] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern56 (x1);
      if (res >= 0)
        return res + 8; /* [8, 10] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 11; /* [11, 13] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern59 (x1);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern60 (x1);
      if (res >= 0)
        return res + 19; /* [19, 21] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern61 (x1);
      if (res >= 0)
        return res + 22; /* [22, 24] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 25; /* [25, 27] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern63 (x1);
      if (res >= 0)
        return res + 28; /* [28, 30] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern64 (x1);
      if (res >= 0)
        return res + 31; /* [31, 32] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern65 (x1);
      if (res >= 0)
        return res + 33; /* [33, 34] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern66 (x1);
      if (res >= 0)
        return res + 35; /* [35, 36] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern67 (x1);
      if (res >= 0)
        return res + 37; /* [37, 38] */
      return -1;

    case E_V1HFmode:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 39; /* [39, 41] */
      return -1;

    case E_V2HFmode:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 42; /* [42, 44] */
      return -1;

    case E_V4HFmode:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 45; /* [45, 47] */
      return -1;

    case E_V8HFmode:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 48; /* [48, 50] */
      return -1;

    case E_V16HFmode:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 51; /* [51, 53] */
      return -1;

    case E_V32HFmode:
      res = pattern73 (x1);
      if (res >= 0)
        return res + 54; /* [54, 56] */
      return -1;

    case E_V64HFmode:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 57; /* [57, 59] */
      return -1;

    case E_V128HFmode:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 60; /* [60, 62] */
      return -1;

    case E_V256HFmode:
      res = pattern76 (x1);
      if (res >= 0)
        return res + 63; /* [63, 65] */
      return -1;

    case E_V512HFmode:
      res = pattern77 (x1);
      if (res >= 0)
        return res + 66; /* [66, 68] */
      return -1;

    case E_V1024HFmode:
      res = pattern78 (x1);
      if (res >= 0)
        return res + 69; /* [69, 71] */
      return -1;

    case E_V2048HFmode:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V1SFmode:
      res = pattern80 (x1);
      if (res >= 0)
        return res + 74; /* [74, 76] */
      return -1;

    case E_V2SFmode:
      res = pattern81 (x1);
      if (res >= 0)
        return res + 77; /* [77, 79] */
      return -1;

    case E_V4SFmode:
      res = pattern82 (x1);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_V8SFmode:
      res = pattern83 (x1);
      if (res >= 0)
        return res + 83; /* [83, 85] */
      return -1;

    case E_V16SFmode:
      res = pattern84 (x1);
      if (res >= 0)
        return res + 86; /* [86, 88] */
      return -1;

    case E_V32SFmode:
      res = pattern85 (x1);
      if (res >= 0)
        return res + 89; /* [89, 91] */
      return -1;

    case E_V64SFmode:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 92; /* [92, 94] */
      return -1;

    case E_V128SFmode:
      res = pattern87 (x1);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V256SFmode:
      res = pattern88 (x1);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V512SFmode:
      res = pattern89 (x1);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V1024SFmode:
      res = pattern90 (x1);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V1DFmode:
      res = pattern91 (x1);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V2DFmode:
      res = pattern92 (x1);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V4DFmode:
      res = pattern93 (x1);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V8DFmode:
      res = pattern94 (x1);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V16DFmode:
      res = pattern95 (x1);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V32DFmode:
      res = pattern96 (x1);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V64DFmode:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V128DFmode:
      res = pattern98 (x1);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V256DFmode:
      res = pattern99 (x1);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V512DFmode:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern143 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern143 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern143 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern143 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern143 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern143 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern143 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern143 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern143 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern143 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern143 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern143 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern143 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern143 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern143 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern143 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern143 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern143 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern143 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern143 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern143 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern143 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern143 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern143 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern143 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern143 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern143 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern143 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern143 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern143 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern143 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern143 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern143 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern143 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern143 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern143 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern143 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern143 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern143 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern143 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern143 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern143 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern143 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern143 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern143 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern143 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern143 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern143 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      return pattern145 (x1); /* [-1, 47] */

    case REG:
    case SUBREG:
      res = pattern153 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern154 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode) != 0)
            return -1;
          return 96;

        case E_RVVM4HImode:
          if (pattern154 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 97;

        case E_RVVM2HImode:
          if (pattern154 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 98;

        case E_RVVM1HImode:
          if (pattern154 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 99;

        case E_RVVMF2HImode:
          if (pattern154 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 100;

        case E_RVVMF4HImode:
          if (pattern154 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 101;

        case E_RVVM8SImode:
          if (pattern154 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode) != 0)
            return -1;
          return 102;

        case E_RVVM4SImode:
          if (pattern154 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 103;

        case E_RVVM2SImode:
          if (pattern154 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 104;

        case E_RVVM1SImode:
          if (pattern154 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 105;

        case E_RVVMF2SImode:
          if (pattern154 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 106;

        case E_RVVM8DImode:
          if (pattern154 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode) != 0)
            return -1;
          return 107;

        case E_RVVM4DImode:
          if (pattern154 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode) != 0)
            return -1;
          return 108;

        case E_RVVM2DImode:
          if (pattern154 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode) != 0)
            return -1;
          return 109;

        case E_RVVM1DImode:
          if (pattern154 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode) != 0)
            return -1;
          return 110;

        case E_V1HImode:
          if (pattern154 (x1, 
E_V1QImode, 
E_V1HImode) != 0)
            return -1;
          return 111;

        case E_V2HImode:
          if (pattern154 (x1, 
E_V2QImode, 
E_V2HImode) != 0)
            return -1;
          return 112;

        case E_V4HImode:
          if (pattern154 (x1, 
E_V4QImode, 
E_V4HImode) != 0)
            return -1;
          return 113;

        case E_V8HImode:
          if (pattern154 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 114;

        case E_V16HImode:
          if (pattern154 (x1, 
E_V16QImode, 
E_V16HImode) != 0)
            return -1;
          return 115;

        case E_V32HImode:
          if (pattern154 (x1, 
E_V32QImode, 
E_V32HImode) != 0)
            return -1;
          return 116;

        case E_V64HImode:
          if (pattern154 (x1, 
E_V64QImode, 
E_V64HImode) != 0)
            return -1;
          return 117;

        case E_V128HImode:
          if (pattern154 (x1, 
E_V128QImode, 
E_V128HImode) != 0)
            return -1;
          return 118;

        case E_V256HImode:
          if (pattern154 (x1, 
E_V256QImode, 
E_V256HImode) != 0)
            return -1;
          return 119;

        case E_V512HImode:
          if (pattern154 (x1, 
E_V512QImode, 
E_V512HImode) != 0)
            return -1;
          return 120;

        case E_V1024HImode:
          if (pattern154 (x1, 
E_V1024QImode, 
E_V1024HImode) != 0)
            return -1;
          return 121;

        case E_V2048HImode:
          if (pattern154 (x1, 
E_V2048QImode, 
E_V2048HImode) != 0)
            return -1;
          return 122;

        case E_V1SImode:
          if (pattern154 (x1, 
E_V1HImode, 
E_V1SImode) != 0)
            return -1;
          return 123;

        case E_V2SImode:
          if (pattern154 (x1, 
E_V2HImode, 
E_V2SImode) != 0)
            return -1;
          return 124;

        case E_V4SImode:
          if (pattern154 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 125;

        case E_V8SImode:
          if (pattern154 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 126;

        case E_V16SImode:
          if (pattern154 (x1, 
E_V16HImode, 
E_V16SImode) != 0)
            return -1;
          return 127;

        case E_V32SImode:
          if (pattern154 (x1, 
E_V32HImode, 
E_V32SImode) != 0)
            return -1;
          return 128;

        case E_V64SImode:
          if (pattern154 (x1, 
E_V64HImode, 
E_V64SImode) != 0)
            return -1;
          return 129;

        case E_V128SImode:
          if (pattern154 (x1, 
E_V128HImode, 
E_V128SImode) != 0)
            return -1;
          return 130;

        case E_V256SImode:
          if (pattern154 (x1, 
E_V256HImode, 
E_V256SImode) != 0)
            return -1;
          return 131;

        case E_V512SImode:
          if (pattern154 (x1, 
E_V512HImode, 
E_V512SImode) != 0)
            return -1;
          return 132;

        case E_V1024SImode:
          if (pattern154 (x1, 
E_V1024HImode, 
E_V1024SImode) != 0)
            return -1;
          return 133;

        case E_V1DImode:
          if (pattern154 (x1, 
E_V1SImode, 
E_V1DImode) != 0)
            return -1;
          return 134;

        case E_V2DImode:
          if (pattern154 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 135;

        case E_V4DImode:
          if (pattern154 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 136;

        case E_V8DImode:
          if (pattern154 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
            return -1;
          return 137;

        case E_V16DImode:
          if (pattern154 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
            return -1;
          return 138;

        case E_V32DImode:
          if (pattern154 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
            return -1;
          return 139;

        case E_V64DImode:
          if (pattern154 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
            return -1;
          return 140;

        case E_V128DImode:
          if (pattern154 (x1, 
E_V128SImode, 
E_V128DImode) != 0)
            return -1;
          return 141;

        case E_V256DImode:
          if (pattern154 (x1, 
E_V256SImode, 
E_V256DImode) != 0)
            return -1;
          return 142;

        case E_V512DImode:
          if (pattern154 (x1, 
E_V512SImode, 
E_V512DImode) != 0)
            return -1;
          return 143;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern188 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 3;

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_RVVM2BFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM4SFmode:
      if (!register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      return 6;

    case E_RVVM8DFmode:
      if (!register_operand (operands[3], E_RVVM8DFmode))
        return -1;
      return 7;

    case E_RVVM1x2QImode:
      if (!register_operand (operands[3], E_RVVM1x2QImode))
        return -1;
      return 8;

    case E_RVVM1x3QImode:
      if (!register_operand (operands[3], E_RVVM1x3QImode))
        return -1;
      return 9;

    case E_RVVM1x4QImode:
      if (!register_operand (operands[3], E_RVVM1x4QImode))
        return -1;
      return 10;

    case E_RVVM1x5QImode:
      if (!register_operand (operands[3], E_RVVM1x5QImode))
        return -1;
      return 11;

    case E_RVVM1x6QImode:
      if (!register_operand (operands[3], E_RVVM1x6QImode))
        return -1;
      return 12;

    case E_RVVM1x7QImode:
      if (!register_operand (operands[3], E_RVVM1x7QImode))
        return -1;
      return 13;

    case E_RVVM1x8QImode:
      if (!register_operand (operands[3], E_RVVM1x8QImode))
        return -1;
      return 14;

    case E_RVVM2x2HImode:
      if (!register_operand (operands[3], E_RVVM2x2HImode))
        return -1;
      return 15;

    case E_RVVM2x3HImode:
      if (!register_operand (operands[3], E_RVVM2x3HImode))
        return -1;
      return 16;

    case E_RVVM2x4HImode:
      if (!register_operand (operands[3], E_RVVM2x4HImode))
        return -1;
      return 17;

    case E_RVVM4x2SImode:
      if (!register_operand (operands[3], E_RVVM4x2SImode))
        return -1;
      return 18;

    case E_RVVM2x2BFmode:
      if (!register_operand (operands[3], E_RVVM2x2BFmode))
        return -1;
      return 19;

    case E_RVVM2x3BFmode:
      if (!register_operand (operands[3], E_RVVM2x3BFmode))
        return -1;
      return 20;

    case E_RVVM2x4BFmode:
      if (!register_operand (operands[3], E_RVVM2x4BFmode))
        return -1;
      return 21;

    case E_RVVM2x2HFmode:
      if (!register_operand (operands[3], E_RVVM2x2HFmode))
        return -1;
      return 22;

    case E_RVVM2x3HFmode:
      if (!register_operand (operands[3], E_RVVM2x3HFmode))
        return -1;
      return 23;

    case E_RVVM2x4HFmode:
      if (!register_operand (operands[3], E_RVVM2x4HFmode))
        return -1;
      return 24;

    case E_RVVM4x2SFmode:
      if (!register_operand (operands[3], E_RVVM4x2SFmode))
        return -1;
      return 25;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern196 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern196 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern196 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern196 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern196 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern196 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern196 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern196 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern196 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern196 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern196 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern196 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern196 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern196 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern196 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern196 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern196 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern196 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern196 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern196 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern196 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern196 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern196 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern196 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern196 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern196 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern196 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern196 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern196 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern196 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern196 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern196 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern196 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern196 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern196 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern196 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern196 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern196 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern196 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern196 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern196 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern196 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern196 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern196 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern196 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern196 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern196 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern196 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 2);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern206 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern206 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern206 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern206 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern206 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern206 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern206 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern206 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern206 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern206 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern206 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern206 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern206 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern206 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern206 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern206 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern206 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern206 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern206 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern206 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern206 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern206 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_RVVM8BFmode:
          if (pattern206 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 22;

        case E_RVVM4BFmode:
          if (pattern206 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 23;

        case E_RVVM2BFmode:
          if (pattern206 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 24;

        case E_RVVM1BFmode:
          if (pattern206 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 25;

        case E_RVVMF2BFmode:
          if (pattern206 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 26;

        case E_RVVMF4BFmode:
          if (pattern206 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 27;

        case E_RVVM8HFmode:
          if (pattern206 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 28;

        case E_RVVM4HFmode:
          if (pattern206 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 29;

        case E_RVVM2HFmode:
          if (pattern206 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 30;

        case E_RVVM1HFmode:
          if (pattern206 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 31;

        case E_RVVMF2HFmode:
          if (pattern206 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 32;

        case E_RVVMF4HFmode:
          if (pattern206 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 33;

        case E_RVVM8SFmode:
          if (pattern206 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SFmode:
          if (pattern206 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SFmode:
          if (pattern206 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SFmode:
          if (pattern206 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SFmode:
          if (pattern206 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 38;

        case E_RVVM8DFmode:
          if (pattern206 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 39;

        case E_RVVM4DFmode:
          if (pattern206 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 40;

        case E_RVVM2DFmode:
          if (pattern206 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 41;

        case E_RVVM1DFmode:
          if (pattern206 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 42;

        case E_V1QImode:
          if (pattern206 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2QImode:
          if (pattern206 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4QImode:
          if (pattern206 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8QImode:
          if (pattern206 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16QImode:
          if (pattern206 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32QImode:
          if (pattern206 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64QImode:
          if (pattern206 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128QImode:
          if (pattern206 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256QImode:
          if (pattern206 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512QImode:
          if (pattern206 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024QImode:
          if (pattern206 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_V2048QImode:
          if (pattern206 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 54;

        case E_V4096QImode:
          if (pattern206 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 55;

        case E_V1HImode:
          if (pattern206 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 56;

        case E_V2HImode:
          if (pattern206 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 57;

        case E_V4HImode:
          if (pattern206 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 58;

        case E_V8HImode:
          if (pattern206 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 59;

        case E_V16HImode:
          if (pattern206 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 60;

        case E_V32HImode:
          if (pattern206 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 61;

        case E_V64HImode:
          if (pattern206 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 62;

        case E_V128HImode:
          if (pattern206 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 63;

        case E_V256HImode:
          if (pattern206 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 64;

        case E_V512HImode:
          if (pattern206 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 65;

        case E_V1024HImode:
          if (pattern206 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 66;

        case E_V2048HImode:
          if (pattern206 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 67;

        case E_V1SImode:
          if (pattern206 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 68;

        case E_V2SImode:
          if (pattern206 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 69;

        case E_V4SImode:
          if (pattern206 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 70;

        case E_V8SImode:
          if (pattern206 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 71;

        case E_V16SImode:
          if (pattern206 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 72;

        case E_V32SImode:
          if (pattern206 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 73;

        case E_V64SImode:
          if (pattern206 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 74;

        case E_V128SImode:
          if (pattern206 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 75;

        case E_V256SImode:
          if (pattern206 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 76;

        case E_V512SImode:
          if (pattern206 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 77;

        case E_V1024SImode:
          if (pattern206 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 78;

        case E_V1DImode:
          if (pattern206 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 79;

        case E_V2DImode:
          if (pattern206 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 80;

        case E_V4DImode:
          if (pattern206 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 81;

        case E_V8DImode:
          if (pattern206 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 82;

        case E_V16DImode:
          if (pattern206 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 83;

        case E_V32DImode:
          if (pattern206 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 84;

        case E_V64DImode:
          if (pattern206 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 85;

        case E_V128DImode:
          if (pattern206 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 86;

        case E_V256DImode:
          if (pattern206 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 87;

        case E_V512DImode:
          if (pattern206 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 88;

        case E_V1HFmode:
          if (pattern206 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 89;

        case E_V2HFmode:
          if (pattern206 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 90;

        case E_V4HFmode:
          if (pattern206 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 91;

        case E_V8HFmode:
          if (pattern206 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 92;

        case E_V16HFmode:
          if (pattern206 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 93;

        case E_V32HFmode:
          if (pattern206 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 94;

        case E_V64HFmode:
          if (pattern206 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 95;

        case E_V128HFmode:
          if (pattern206 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 96;

        case E_V256HFmode:
          if (pattern206 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 97;

        case E_V512HFmode:
          if (pattern206 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 98;

        case E_V1024HFmode:
          if (pattern206 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 99;

        case E_V2048HFmode:
          if (pattern206 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 100;

        case E_V1SFmode:
          if (pattern206 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 101;

        case E_V2SFmode:
          if (pattern206 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 102;

        case E_V4SFmode:
          if (pattern206 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 103;

        case E_V8SFmode:
          if (pattern206 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 104;

        case E_V16SFmode:
          if (pattern206 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 105;

        case E_V32SFmode:
          if (pattern206 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 106;

        case E_V64SFmode:
          if (pattern206 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 107;

        case E_V128SFmode:
          if (pattern206 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 108;

        case E_V256SFmode:
          if (pattern206 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 109;

        case E_V512SFmode:
          if (pattern206 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 110;

        case E_V1024SFmode:
          if (pattern206 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 111;

        case E_V1DFmode:
          if (pattern206 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 112;

        case E_V2DFmode:
          if (pattern206 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 113;

        case E_V4DFmode:
          if (pattern206 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 114;

        case E_V8DFmode:
          if (pattern206 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 115;

        case E_V16DFmode:
          if (pattern206 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 116;

        case E_V32DFmode:
          if (pattern206 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 117;

        case E_V64DFmode:
          if (pattern206 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 118;

        case E_V128DFmode:
          if (pattern206 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 119;

        case E_V256DFmode:
          if (pattern206 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 120;

        case E_V512DFmode:
          if (pattern206 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 121;

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern207 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 122;

        case E_RVVM4HFmode:
          if (pattern207 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 123;

        case E_RVVM2HFmode:
          if (pattern207 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 124;

        case E_RVVM1HFmode:
          if (pattern207 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 125;

        case E_RVVMF2HFmode:
          if (pattern207 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 126;

        case E_RVVMF4HFmode:
          if (pattern207 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 127;

        case E_RVVM8SFmode:
          if (pattern207 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 128;

        case E_RVVM4SFmode:
          if (pattern207 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 129;

        case E_RVVM2SFmode:
          if (pattern207 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 130;

        case E_RVVM1SFmode:
          if (pattern207 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 131;

        case E_RVVMF2SFmode:
          if (pattern207 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 132;

        case E_RVVM8DFmode:
          if (pattern207 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 133;

        case E_RVVM4DFmode:
          if (pattern207 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 134;

        case E_RVVM2DFmode:
          if (pattern207 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 135;

        case E_RVVM1DFmode:
          if (pattern207 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 136;

        case E_V1HFmode:
          if (pattern207 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 137;

        case E_V2HFmode:
          if (pattern207 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 138;

        case E_V4HFmode:
          if (pattern207 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 139;

        case E_V8HFmode:
          if (pattern207 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 140;

        case E_V16HFmode:
          if (pattern207 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 141;

        case E_V32HFmode:
          if (pattern207 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 142;

        case E_V64HFmode:
          if (pattern207 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 143;

        case E_V128HFmode:
          if (pattern207 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 144;

        case E_V256HFmode:
          if (pattern207 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 145;

        case E_V512HFmode:
          if (pattern207 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 146;

        case E_V1024HFmode:
          if (pattern207 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 147;

        case E_V2048HFmode:
          if (pattern207 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 148;

        case E_V1SFmode:
          if (pattern207 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 149;

        case E_V2SFmode:
          if (pattern207 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 150;

        case E_V4SFmode:
          if (pattern207 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 151;

        case E_V8SFmode:
          if (pattern207 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 152;

        case E_V16SFmode:
          if (pattern207 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 153;

        case E_V32SFmode:
          if (pattern207 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 154;

        case E_V64SFmode:
          if (pattern207 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 155;

        case E_V128SFmode:
          if (pattern207 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 156;

        case E_V256SFmode:
          if (pattern207 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 157;

        case E_V512SFmode:
          if (pattern207 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 158;

        case E_V1024SFmode:
          if (pattern207 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 159;

        case E_V1DFmode:
          if (pattern207 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 160;

        case E_V2DFmode:
          if (pattern207 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 161;

        case E_V4DFmode:
          if (pattern207 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 162;

        case E_V8DFmode:
          if (pattern207 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 163;

        case E_V16DFmode:
          if (pattern207 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 164;

        case E_V32DFmode:
          if (pattern207 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 165;

        case E_V64DFmode:
          if (pattern207 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 166;

        case E_V128DFmode:
          if (pattern207 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 167;

        case E_V256DFmode:
          if (pattern207 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 168;

        case E_V512DFmode:
          if (pattern207 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 169;

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern208 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 170;

        case E_RVVM4HFmode:
          if (pattern208 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 171;

        case E_RVVM2HFmode:
          if (pattern208 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 172;

        case E_RVVM1HFmode:
          if (pattern208 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 173;

        case E_RVVMF2HFmode:
          if (pattern208 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 174;

        case E_RVVMF4HFmode:
          if (pattern208 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 175;

        case E_RVVM8SFmode:
          if (pattern208 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 176;

        case E_RVVM4SFmode:
          if (pattern208 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 177;

        case E_RVVM2SFmode:
          if (pattern208 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 178;

        case E_RVVM1SFmode:
          if (pattern208 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 179;

        case E_RVVMF2SFmode:
          if (pattern208 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 180;

        case E_RVVM8DFmode:
          if (pattern208 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 181;

        case E_RVVM4DFmode:
          if (pattern208 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 182;

        case E_RVVM2DFmode:
          if (pattern208 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 183;

        case E_RVVM1DFmode:
          if (pattern208 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 184;

        case E_V1HFmode:
          if (pattern208 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 185;

        case E_V2HFmode:
          if (pattern208 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 186;

        case E_V4HFmode:
          if (pattern208 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 187;

        case E_V8HFmode:
          if (pattern208 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 188;

        case E_V16HFmode:
          if (pattern208 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 189;

        case E_V32HFmode:
          if (pattern208 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 190;

        case E_V64HFmode:
          if (pattern208 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 191;

        case E_V128HFmode:
          if (pattern208 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 192;

        case E_V256HFmode:
          if (pattern208 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 193;

        case E_V512HFmode:
          if (pattern208 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 194;

        case E_V1024HFmode:
          if (pattern208 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 195;

        case E_V2048HFmode:
          if (pattern208 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 196;

        case E_V1SFmode:
          if (pattern208 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 197;

        case E_V2SFmode:
          if (pattern208 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 198;

        case E_V4SFmode:
          if (pattern208 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 199;

        case E_V8SFmode:
          if (pattern208 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 200;

        case E_V16SFmode:
          if (pattern208 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 201;

        case E_V32SFmode:
          if (pattern208 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 202;

        case E_V64SFmode:
          if (pattern208 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 203;

        case E_V128SFmode:
          if (pattern208 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 204;

        case E_V256SFmode:
          if (pattern208 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 205;

        case E_V512SFmode:
          if (pattern208 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 206;

        case E_V1024SFmode:
          if (pattern208 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 207;

        case E_V1DFmode:
          if (pattern208 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 208;

        case E_V2DFmode:
          if (pattern208 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 209;

        case E_V4DFmode:
          if (pattern208 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 210;

        case E_V8DFmode:
          if (pattern208 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 211;

        case E_V16DFmode:
          if (pattern208 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 212;

        case E_V32DFmode:
          if (pattern208 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 213;

        case E_V64DFmode:
          if (pattern208 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 214;

        case E_V128DFmode:
          if (pattern208 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 215;

        case E_V256DFmode:
          if (pattern208 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 216;

        case E_V512DFmode:
          if (pattern208 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 217;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 218; /* [218, 309] */
      return -1;

    case ZERO_EXTEND:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 310; /* [310, 401] */
      return -1;

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x4 = XEXP (x1, 2);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM4QImode:
              if (pattern209 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 402;

            case E_RVVM2QImode:
              if (pattern209 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 403;

            case E_RVVM1QImode:
              if (pattern209 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 404;

            case E_RVVMF2QImode:
              if (pattern209 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 405;

            case E_RVVMF4QImode:
              if (pattern209 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 406;

            case E_RVVMF8QImode:
              if (pattern209 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 407;

            case E_RVVM4HImode:
              if (pattern209 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 408;

            case E_RVVM2HImode:
              if (pattern209 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 409;

            case E_RVVM1HImode:
              if (pattern209 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 410;

            case E_RVVMF2HImode:
              if (pattern209 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 411;

            case E_RVVMF4HImode:
              if (pattern209 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 412;

            case E_RVVM4SImode:
              if (pattern209 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 413;

            case E_RVVM2SImode:
              if (pattern209 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 414;

            case E_RVVM1SImode:
              if (pattern209 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 415;

            case E_RVVMF2SImode:
              if (pattern209 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 416;

            case E_V1QImode:
              if (pattern209 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
                return -1;
              return 417;

            case E_V2QImode:
              if (pattern209 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
                return -1;
              return 418;

            case E_V4QImode:
              if (pattern209 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
                return -1;
              return 419;

            case E_V8QImode:
              if (pattern209 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
                return -1;
              return 420;

            case E_V16QImode:
              if (pattern209 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
                return -1;
              return 421;

            case E_V32QImode:
              if (pattern209 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
                return -1;
              return 422;

            case E_V64QImode:
              if (pattern209 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
                return -1;
              return 423;

            case E_V128QImode:
              if (pattern209 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
                return -1;
              return 424;

            case E_V256QImode:
              if (pattern209 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
                return -1;
              return 425;

            case E_V512QImode:
              if (pattern209 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
                return -1;
              return 426;

            case E_V1024QImode:
              if (pattern209 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
                return -1;
              return 427;

            case E_V2048QImode:
              if (pattern209 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
                return -1;
              return 428;

            case E_V1HImode:
              if (pattern209 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
                return -1;
              return 429;

            case E_V2HImode:
              if (pattern209 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
                return -1;
              return 430;

            case E_V4HImode:
              if (pattern209 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
                return -1;
              return 431;

            case E_V8HImode:
              if (pattern209 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
                return -1;
              return 432;

            case E_V16HImode:
              if (pattern209 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
                return -1;
              return 433;

            case E_V32HImode:
              if (pattern209 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
                return -1;
              return 434;

            case E_V64HImode:
              if (pattern209 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
                return -1;
              return 435;

            case E_V128HImode:
              if (pattern209 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
                return -1;
              return 436;

            case E_V256HImode:
              if (pattern209 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
                return -1;
              return 437;

            case E_V512HImode:
              if (pattern209 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
                return -1;
              return 438;

            case E_V1024HImode:
              if (pattern209 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
                return -1;
              return 439;

            case E_V1SImode:
              if (pattern209 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 440;

            case E_V2SImode:
              if (pattern209 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 441;

            case E_V4SImode:
              if (pattern209 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 442;

            case E_V8SImode:
              if (pattern209 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 443;

            case E_V16SImode:
              if (pattern209 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 444;

            case E_V32SImode:
              if (pattern209 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 445;

            case E_V64SImode:
              if (pattern209 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 446;

            case E_V128SImode:
              if (pattern209 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 447;

            case E_V256SImode:
              if (pattern209 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 448;

            case E_V512SImode:
              if (pattern209 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 449;

            default:
              return -1;
            }

        case ASHIFTRT:
          res = pattern214 (x1);
          if (res >= 0)
            return res + 450; /* [450, 593] */
          return -1;

        case LSHIFTRT:
          res = pattern214 (x1);
          if (res >= 0)
            return res + 594; /* [594, 737] */
          return -1;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern209 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 738;

        case E_RVVM4SFmode:
          if (pattern209 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 739;

        case E_RVVM2SFmode:
          if (pattern209 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 740;

        case E_RVVM1SFmode:
          if (pattern209 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 741;

        case E_RVVMF2SFmode:
          if (pattern209 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 742;

        case E_RVVM8DFmode:
          if (pattern209 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 743;

        case E_RVVM4DFmode:
          if (pattern209 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 744;

        case E_RVVM2DFmode:
          if (pattern209 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 745;

        case E_RVVM1DFmode:
          if (pattern209 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 746;

        case E_V1SFmode:
          if (pattern209 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 747;

        case E_V2SFmode:
          if (pattern209 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 748;

        case E_V4SFmode:
          if (pattern209 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 749;

        case E_V8SFmode:
          if (pattern209 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 750;

        case E_V16SFmode:
          if (pattern209 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 751;

        case E_V32SFmode:
          if (pattern209 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 752;

        case E_V64SFmode:
          if (pattern209 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 753;

        case E_V128SFmode:
          if (pattern209 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 754;

        case E_V256SFmode:
          if (pattern209 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 755;

        case E_V512SFmode:
          if (pattern209 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 756;

        case E_V1024SFmode:
          if (pattern209 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 757;

        case E_V1DFmode:
          if (pattern209 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 758;

        case E_V2DFmode:
          if (pattern209 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 759;

        case E_V4DFmode:
          if (pattern209 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 760;

        case E_V8DFmode:
          if (pattern209 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 761;

        case E_V16DFmode:
          if (pattern209 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 762;

        case E_V32DFmode:
          if (pattern209 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 763;

        case E_V64DFmode:
          if (pattern209 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 764;

        case E_V128DFmode:
          if (pattern209 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 765;

        case E_V256DFmode:
          if (pattern209 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 766;

        case E_V512DFmode:
          if (pattern209 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 767;

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern209 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 768;

        case E_RVVM2HFmode:
          if (pattern209 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 769;

        case E_RVVM1HFmode:
          if (pattern209 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 770;

        case E_RVVMF2HFmode:
          if (pattern209 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 771;

        case E_RVVMF4HFmode:
          if (pattern209 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 772;

        case E_RVVM4SFmode:
          if (pattern209 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 773;

        case E_RVVM2SFmode:
          if (pattern209 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 774;

        case E_RVVM1SFmode:
          if (pattern209 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 775;

        case E_RVVMF2SFmode:
          if (pattern209 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 776;

        case E_V1HFmode:
          if (pattern209 (x1, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 777;

        case E_V2HFmode:
          if (pattern209 (x1, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 778;

        case E_V4HFmode:
          if (pattern209 (x1, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 779;

        case E_V8HFmode:
          if (pattern209 (x1, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 780;

        case E_V16HFmode:
          if (pattern209 (x1, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 781;

        case E_V32HFmode:
          if (pattern209 (x1, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 782;

        case E_V64HFmode:
          if (pattern209 (x1, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 783;

        case E_V128HFmode:
          if (pattern209 (x1, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 784;

        case E_V256HFmode:
          if (pattern209 (x1, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 785;

        case E_V512HFmode:
          if (pattern209 (x1, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 786;

        case E_V1024HFmode:
          if (pattern209 (x1, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 787;

        case E_V1SFmode:
          if (pattern209 (x1, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 788;

        case E_V2SFmode:
          if (pattern209 (x1, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 789;

        case E_V4SFmode:
          if (pattern209 (x1, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 790;

        case E_V8SFmode:
          if (pattern209 (x1, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 791;

        case E_V16SFmode:
          if (pattern209 (x1, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 792;

        case E_V32SFmode:
          if (pattern209 (x1, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 793;

        case E_V64SFmode:
          if (pattern209 (x1, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 794;

        case E_V128SFmode:
          if (pattern209 (x1, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 795;

        case E_V256SFmode:
          if (pattern209 (x1, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 796;

        case E_V512SFmode:
          if (pattern209 (x1, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 797;

        default:
          return -1;
        }

    case FIX:
      res = pattern215 (x1);
      if (res >= 0)
        return res + 798; /* [798, 923] */
      return -1;

    case UNSIGNED_FIX:
      res = pattern215 (x1);
      if (res >= 0)
        return res + 924; /* [924, 1049] */
      return -1;

    case FLOAT:
      res = pattern216 (x1);
      if (res >= 0)
        return res + 1050; /* [1050, 1175] */
      return -1;

    case UNSIGNED_FLOAT:
      res = pattern216 (x1);
      if (res >= 0)
        return res + 1176; /* [1176, 1301] */
      return -1;

    case SMUL_HIGHPART:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 1302; /* [1302, 1369] */
      return -1;

    case UMUL_HIGHPART:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 1370; /* [1370, 1437] */
      return -1;

    default:
      return -1;
    }
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern439 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern341 (x6); /* [-1, 3] */
}

int
pattern446 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[1], E_V1SImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 9;

    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 10;

    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 11;

    case E_V128SImode:
      if (!register_operand (operands[1], E_V128SImode))
        return -1;
      return 12;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 13;

    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 14;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x2, 0, 1);
  operands[6] = x9;
  if (!autovec_length_operand (operands[6], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern455 (x1, 
E_SImode); /* [-1, 19] */

    case E_DImode:
      res = pattern455 (x1, 
E_DImode);
      if (res >= 0)
        return res + 20; /* [20, 39] */
      return -1;

    default:
      return -1;
    }
}

int
pattern466 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!branch_on_bit_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern464 (x1); /* [-1, 1] */
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i3)
      || !vector_merge_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern473 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern473 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern473 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern473 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern473 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern473 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern473 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern473 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern473 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern473 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern473 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern473 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern473 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern473 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern473 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern473 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern473 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern473 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern473 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern473 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern473 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern473 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern473 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern473 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern473 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern473 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern473 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern473 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern473 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern473 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern473 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern473 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern473 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern473 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern473 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern473 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern473 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern473 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern473 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern473 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern473 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern473 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern473 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern473 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern473 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern473 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern473 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern473 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern473 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern473 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern473 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern473 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern473 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern473 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern473 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern473 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern473 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern473 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern473 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern473 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern473 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern473 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern473 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern473 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern473 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern473 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern473 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern473 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern473 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern473 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern473 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern473 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern473 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern473 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern473 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern473 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern473 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern473 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern473 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern473 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern473 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern473 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern473 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern473 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern473 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern473 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern473 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern473 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern473 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern473 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern473 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern473 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern473 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern473 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern473 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern473 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern473 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern473 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern473 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern473 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern473 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern473 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern473 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern473 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern473 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern473 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern473 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern473 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern473 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern473 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern473 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern473 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern473 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern473 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern473 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern473 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern473 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern473 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern473 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern473 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern473 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern473 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern511 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern516 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF8QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V32QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V256QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 0;

    case E_V256HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 1;

    case E_V256SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V2048QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2048QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V2048QImode))
        return -1;
      return 0;

    case E_V2048HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2048HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern532 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          return pattern531 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern531 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern531 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern531 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern531 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern531 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SImode:
          if (pattern531 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (pattern531 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SImode:
          if (pattern531 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SImode:
          if (pattern531 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (pattern531 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DImode:
          if (pattern531 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DImode:
          if (pattern531 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DImode:
          if (pattern531 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DImode:
          if (pattern531 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HImode:
          if (pattern531 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HImode:
          if (pattern531 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HImode:
          if (pattern531 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HImode:
          if (pattern531 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern531 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HImode:
          if (pattern531 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HImode:
          if (pattern531 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HImode:
          if (pattern531 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HImode:
          if (pattern531 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HImode:
          if (pattern531 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HImode:
          if (pattern531 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HImode:
          if (pattern531 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SImode:
          if (pattern531 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SImode:
          if (pattern531 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SImode:
          if (pattern531 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SImode:
          if (pattern531 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SImode:
          if (pattern531 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SImode:
          if (pattern531 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SImode:
          if (pattern531 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SImode:
          if (pattern531 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SImode:
          if (pattern531 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SImode:
          if (pattern531 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SImode:
          if (pattern531 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DImode:
          if (pattern531 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DImode:
          if (pattern531 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DImode:
          if (pattern531 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DImode:
          if (pattern531 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DImode:
          if (pattern531 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DImode:
          if (pattern531 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DImode:
          if (pattern531 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DImode:
          if (pattern531 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DImode:
          if (pattern531 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DImode:
          if (pattern531 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern533 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
            return -1;
          return 48;

        case E_RVVM4HImode:
          if (pattern533 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
            return -1;
          return 49;

        case E_RVVM2HImode:
          if (pattern533 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
            return -1;
          return 50;

        case E_RVVM1HImode:
          if (pattern533 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HImode:
          if (pattern533 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HImode:
          if (pattern533 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
            return -1;
          return 53;

        case E_RVVM8SImode:
          if (pattern533 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
            return -1;
          return 54;

        case E_RVVM4SImode:
          if (pattern533 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
            return -1;
          return 55;

        case E_RVVM2SImode:
          if (pattern533 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
            return -1;
          return 56;

        case E_RVVM1SImode:
          if (pattern533 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SImode:
          if (pattern533 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
            return -1;
          return 58;

        case E_RVVM8DImode:
          if (pattern533 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
            return -1;
          return 59;

        case E_RVVM4DImode:
          if (pattern533 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
            return -1;
          return 60;

        case E_RVVM2DImode:
          if (pattern533 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
            return -1;
          return 61;

        case E_RVVM1DImode:
          if (pattern533 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
            return -1;
          return 62;

        case E_V1HImode:
          if (pattern533 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
            return -1;
          return 63;

        case E_V2HImode:
          if (pattern533 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
            return -1;
          return 64;

        case E_V4HImode:
          if (pattern533 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
            return -1;
          return 65;

        case E_V8HImode:
          if (pattern533 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
            return -1;
          return 66;

        case E_V16HImode:
          if (pattern533 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
            return -1;
          return 67;

        case E_V32HImode:
          if (pattern533 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
            return -1;
          return 68;

        case E_V64HImode:
          if (pattern533 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
            return -1;
          return 69;

        case E_V128HImode:
          if (pattern533 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
            return -1;
          return 70;

        case E_V256HImode:
          if (pattern533 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
            return -1;
          return 71;

        case E_V512HImode:
          if (pattern533 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
            return -1;
          return 72;

        case E_V1024HImode:
          if (pattern533 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
            return -1;
          return 73;

        case E_V2048HImode:
          if (pattern533 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
            return -1;
          return 74;

        case E_V1SImode:
          if (pattern533 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
            return -1;
          return 75;

        case E_V2SImode:
          if (pattern533 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
            return -1;
          return 76;

        case E_V4SImode:
          if (pattern533 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
            return -1;
          return 77;

        case E_V8SImode:
          if (pattern533 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
            return -1;
          return 78;

        case E_V16SImode:
          if (pattern533 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
            return -1;
          return 79;

        case E_V32SImode:
          if (pattern533 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
            return -1;
          return 80;

        case E_V64SImode:
          if (pattern533 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
            return -1;
          return 81;

        case E_V128SImode:
          if (pattern533 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
            return -1;
          return 82;

        case E_V256SImode:
          if (pattern533 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
            return -1;
          return 83;

        case E_V512SImode:
          if (pattern533 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
            return -1;
          return 84;

        case E_V1024SImode:
          if (pattern533 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
            return -1;
          return 85;

        case E_V1DImode:
          if (pattern533 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
            return -1;
          return 86;

        case E_V2DImode:
          if (pattern533 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
            return -1;
          return 87;

        case E_V4DImode:
          if (pattern533 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
            return -1;
          return 88;

        case E_V8DImode:
          if (pattern533 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
            return -1;
          return 89;

        case E_V16DImode:
          if (pattern533 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
            return -1;
          return 90;

        case E_V32DImode:
          if (pattern533 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
            return -1;
          return 91;

        case E_V64DImode:
          if (pattern533 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
            return -1;
          return 92;

        case E_V128DImode:
          if (pattern533 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
            return -1;
          return 93;

        case E_V256DImode:
          if (pattern533 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
            return -1;
          return 94;

        case E_V512DImode:
          if (pattern533 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  return pattern534 (x1); /* [-1, 95] */
}

int
pattern568 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i4
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern571 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!comparison_except_ge_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern573 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern493 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern493 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern493 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern493 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern493 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern493 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern493 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern493 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern493 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern493 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern493 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern493 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern493 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern493 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern493 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern493 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern493 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern493 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern493 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern493 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern493 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern493 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern493 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern493 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern493 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern493 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern493 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern493 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern493 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern493 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern493 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern493 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern493 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern493 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern493 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern493 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern493 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern493 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern493 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern493 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern493 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern493 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern493 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern493 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern493 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern493 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern493 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern493 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!vector_neg_arith_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern603 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern606 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[4], E_RVVM2HFmode)
          || !register_operand (operands[5], E_RVVM2HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[4], E_RVVM4SFmode)
          || !register_operand (operands[5], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVM8DFmode:
      if (!register_operand (operands[4], E_RVVM8DFmode)
          || !register_operand (operands[5], E_RVVM8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[4], E_RVVMF2HFmode)
          || !register_operand (operands[5], E_RVVMF2HFmode))
        return -1;
      return 0;

    case E_RVVM1SFmode:
      if (!register_operand (operands[4], E_RVVM1SFmode)
          || !register_operand (operands[5], E_RVVM1SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[4], E_RVVM2DFmode)
          || !register_operand (operands[5], E_RVVM2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V2BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V2BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[4], E_V2HFmode)
          || !register_operand (operands[5], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!register_operand (operands[4], E_V2SFmode)
          || !register_operand (operands[5], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[4], E_V2DFmode)
          || !register_operand (operands[5], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || !register_operand (operands[5], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || !register_operand (operands[5], E_V16SFmode))
        return -1;
      return 1;

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || !register_operand (operands[5], E_V16DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[4], E_V128HFmode)
          || !register_operand (operands[5], E_V128HFmode))
        return -1;
      return 0;

    case E_V128SFmode:
      if (!register_operand (operands[4], E_V128SFmode)
          || !register_operand (operands[5], E_V128SFmode))
        return -1;
      return 1;

    case E_V128DFmode:
      if (!register_operand (operands[4], E_V128DFmode)
          || !register_operand (operands[5], E_V128DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern625 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!register_operand (operands[4], i3))
    return -1;
  x10 = XEXP (x1, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  return 0;
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[1], E_RVVM4QImode)
          || !vector_arith_operand (operands[2], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      if (!register_operand (operands[1], E_RVVM8HImode)
          || !vector_arith_operand (operands[2], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode)
          || !vector_arith_operand (operands[2], E_RVVM1SImode))
        return -1;
      return 0;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode)
          || !vector_arith_operand (operands[2], E_RVVM2DImode))
        return -1;
      return 1;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode)
          || !vector_arith_operand (operands[2], E_RVVMF4QImode))
        return -1;
      return 2;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode)
          || !vector_arith_operand (operands[2], E_RVVMF2HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode)
          || !register_operand (operands[2], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode)
          || !register_operand (operands[2], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode)
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode)
          || !register_operand (operands[2], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew16_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern645 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i3)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern659 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern663 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern670 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern675 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern680 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_RVVM1DImode
      || !register_operand (operands[4], E_RVVM1DImode)
      || !vector_merge_operand (operands[2], E_RVVM1DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      return 4;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      return 5;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      return 6;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      return 7;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      return 8;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      return 9;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      return 10;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      return 11;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      return 12;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern684 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern688 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern695 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern704 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i4))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern711 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern714 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern717 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew16_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern721 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern726 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern725 (x5, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern728 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern542 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern542 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern542 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern542 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern542 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern542 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern542 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern542 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern542 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern542 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern542 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern542 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern542 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern542 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern542 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern729 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern671 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4HImode
          || !vector_merge_operand (operands[2], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2HImode
          || !vector_merge_operand (operands[2], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1HImode
          || !vector_merge_operand (operands[2], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2HImode
          || !vector_merge_operand (operands[2], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF4HImode
          || !vector_merge_operand (operands[2], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1HImode
          || !vector_merge_operand (operands[2], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2HImode
          || !vector_merge_operand (operands[2], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4HImode
          || !vector_merge_operand (operands[2], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8HImode
          || !vector_merge_operand (operands[2], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16HImode
          || !vector_merge_operand (operands[2], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32HImode
          || !vector_merge_operand (operands[2], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64HImode
          || !vector_merge_operand (operands[2], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128HImode
          || !vector_merge_operand (operands[2], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256HImode
          || !vector_merge_operand (operands[2], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512HImode
          || !vector_merge_operand (operands[2], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024HImode
          || !vector_merge_operand (operands[2], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern671 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern671 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern671 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern671 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern671 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern671 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern671 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern671 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern671 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern671 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern671 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern671 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern671 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern671 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern671 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern671 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern671 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern671 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern671 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 23:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2186 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 179; /* lrintsfsi2_sext */

            case 1:
              if (!(
#line 2186 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 180; /* lrintdfsi2_sext */

            case 2:
              if (!(
#line 2186 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 181; /* lrinthfsi2_sext */

            default:
              return -1;
            }

        case 17:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 203; /* lroundsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 209; /* lrounddfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 215; /* lroundhfsi2_sext */

            default:
              return -1;
            }

        case 18:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 204; /* lfloorsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 210; /* lfloordfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 216; /* lfloorhfsi2_sext */

            default:
              return -1;
            }

        case 19:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 205; /* lceilsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 211; /* lceildfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 217; /* lceilhfsi2_sext */

            default:
              return -1;
            }

        case 20:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 206; /* lbtruncsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 212; /* lbtruncdfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 218; /* lbtrunchfsi2_sext */

            default:
              return -1;
            }

        case 21:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 207; /* lroundevensfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 213; /* lroundevendfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 219; /* lroundevenhfsi2_sext */

            default:
              return -1;
            }

        case 22:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 208; /* lnearbyintsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 214; /* lnearbyintdfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 220; /* lnearbyinthfsi2_sext */

            default:
              return -1;
            }

        case 62:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 698; /* riscv_sha256sig0_di_extended */

        case 63:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 699; /* riscv_sha256sig1_di_extended */

        case 64:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 700; /* riscv_sha256sum0_di_extended */

        case 65:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 701; /* riscv_sha256sum1_di_extended */

        case 76:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 465 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKSH && TARGET_64BIT))
            return -1;
          return 714; /* riscv_sm3p0_di_extended */

        case 77:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 465 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKSH && TARGET_64BIT))
            return -1;
          return 715; /* riscv_sm3p1_di_extended */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_3_operand (operands[3], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 78:
          if (!
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKSED && TARGET_64BIT))
            return -1;
          return 718; /* riscv_sm4ed_di_extended */

        case 79:
          if (!
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/crypto.md"
(TARGET_ZKSED && TARGET_64BIT))
            return -1;
          return 719; /* riscv_sm4ks_di_extended */

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_SImode) != 0)
        return -1;
      if ((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 907; /* *th_mulssi */
      if (
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
        return 910; /* *th_mulswsi2 */
      if (!
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
        return -1;
      return 33906; /* riscv_cv_mac_msu */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_DImode) != 0
          || !(
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 908; /* *th_mulsdi */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8QImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27247; /* fnmarvvm8qi4 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4QImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27248; /* fnmarvvm4qi4 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2QImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27249; /* fnmarvvm2qi4 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1QImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27250; /* fnmarvvm1qi4 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27251; /* fnmarvvm8hi4 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27252; /* fnmarvvm4hi4 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27253; /* fnmarvvm2hi4 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27254; /* fnmarvvm1hi4 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27255; /* fnmarvvm8si4 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27256; /* fnmarvvm4si4 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27257; /* fnmarvvm2si4 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SImode) != 0
          || !
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27258; /* fnmarvvm1si4 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27259; /* fnmarvvm8di4 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27260; /* fnmarvvm4di4 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27261; /* fnmarvvm2di4 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27262; /* fnmarvvm1di4 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27263; /* fnmarvvmf2qi4 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27264; /* fnmarvvmf4qi4 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27265; /* fnmarvvmf8qi4 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27266; /* fnmarvvmf2hi4 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27267; /* fnmarvvmf4hi4 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27268; /* fnmarvvmf2si4 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27269; /* fnmav1qi4 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27270; /* fnmav2qi4 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27271; /* fnmav4qi4 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27272; /* fnmav8qi4 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27273; /* fnmav16qi4 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27274; /* fnmav32qi4 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27275; /* fnmav64qi4 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27276; /* fnmav128qi4 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27277; /* fnmav256qi4 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27278; /* fnmav512qi4 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27279; /* fnmav1024qi4 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27280; /* fnmav2048qi4 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4096QImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27281; /* fnmav4096qi4 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27282; /* fnmav1hi4 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27283; /* fnmav2hi4 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27284; /* fnmav4hi4 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27285; /* fnmav8hi4 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27286; /* fnmav16hi4 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27287; /* fnmav32hi4 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27288; /* fnmav64hi4 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27289; /* fnmav128hi4 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27290; /* fnmav256hi4 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27291; /* fnmav512hi4 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27292; /* fnmav1024hi4 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27293; /* fnmav2048hi4 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27294; /* fnmav1si4 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27295; /* fnmav2si4 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27296; /* fnmav4si4 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27297; /* fnmav8si4 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27298; /* fnmav16si4 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27299; /* fnmav32si4 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27300; /* fnmav64si4 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27301; /* fnmav128si4 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27302; /* fnmav256si4 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27303; /* fnmav512si4 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27304; /* fnmav1024si4 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27305; /* fnmav1di4 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27306; /* fnmav2di4 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27307; /* fnmav4di4 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27308; /* fnmav8di4 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27309; /* fnmav16di4 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27310; /* fnmav32di4 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27311; /* fnmav64di4 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27312; /* fnmav128di4 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27313; /* fnmav256di4 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DImode) != 0
          || !(
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27314; /* fnmav512di4 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27363; /* fnmarvvm8hf4 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27364; /* fnmarvvm4hf4 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27365; /* fnmarvvm2hf4 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27366; /* fnmarvvm1hf4 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27367; /* fnmarvvmf2hf4 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27368; /* fnmarvvmf4hf4 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27369; /* fnmarvvm8sf4 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27370; /* fnmarvvm4sf4 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27371; /* fnmarvvm2sf4 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27372; /* fnmarvvm1sf4 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27373; /* fnmarvvmf2sf4 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27374; /* fnmarvvm8df4 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27375; /* fnmarvvm4df4 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27376; /* fnmarvvm2df4 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27377; /* fnmarvvm1df4 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27378; /* fnmav1hf4 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27379; /* fnmav2hf4 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27380; /* fnmav4hf4 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27381; /* fnmav8hf4 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27382; /* fnmav16hf4 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27383; /* fnmav32hf4 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27384; /* fnmav64hf4 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27385; /* fnmav128hf4 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27386; /* fnmav256hf4 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27387; /* fnmav512hf4 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27388; /* fnmav1024hf4 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27389; /* fnmav2048hf4 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27390; /* fnmav1sf4 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27391; /* fnmav2sf4 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27392; /* fnmav4sf4 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27393; /* fnmav8sf4 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27394; /* fnmav16sf4 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27395; /* fnmav32sf4 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27396; /* fnmav64sf4 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27397; /* fnmav128sf4 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27398; /* fnmav256sf4 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27399; /* fnmav512sf4 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27400; /* fnmav1024sf4 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27401; /* fnmav1df4 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27402; /* fnmav2df4 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27403; /* fnmav4df4 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27404; /* fnmav8df4 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27405; /* fnmav16df4 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27406; /* fnmav32df4 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27407; /* fnmav64df4 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27408; /* fnmav128df4 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27409; /* fnmav256df4 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DFmode) != 0
          || !(
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27410; /* fnmav512df4 */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern160 (x2))
    {
    case 0:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29858; /* *narrow_ashrextendrvvm8hi */

    case 1:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29862; /* *narrow_ashrextendrvvm4hi */

    case 2:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29866; /* *narrow_ashrextendrvvm2hi */

    case 3:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29870; /* *narrow_ashrextendrvvm1hi */

    case 4:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29874; /* *narrow_ashrextendrvvmf2hi */

    case 5:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29878; /* *narrow_ashrextendrvvmf4hi */

    case 6:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29882; /* *narrow_ashrextendrvvm8si */

    case 7:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29886; /* *narrow_ashrextendrvvm4si */

    case 8:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29890; /* *narrow_ashrextendrvvm2si */

    case 9:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29894; /* *narrow_ashrextendrvvm1si */

    case 10:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29898; /* *narrow_ashrextendrvvmf2si */

    case 11:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29902; /* *narrow_ashrextendrvvm8di */

    case 12:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29906; /* *narrow_ashrextendrvvm4di */

    case 13:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29910; /* *narrow_ashrextendrvvm2di */

    case 14:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29914; /* *narrow_ashrextendrvvm1di */

    case 15:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29918; /* *narrow_ashrextendv1hi */

    case 16:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29922; /* *narrow_ashrextendv2hi */

    case 17:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29926; /* *narrow_ashrextendv4hi */

    case 18:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29930; /* *narrow_ashrextendv8hi */

    case 19:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29934; /* *narrow_ashrextendv16hi */

    case 20:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29938; /* *narrow_ashrextendv32hi */

    case 21:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29942; /* *narrow_ashrextendv64hi */

    case 22:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29946; /* *narrow_ashrextendv128hi */

    case 23:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29950; /* *narrow_ashrextendv256hi */

    case 24:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29954; /* *narrow_ashrextendv512hi */

    case 25:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29958; /* *narrow_ashrextendv1024hi */

    case 26:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29962; /* *narrow_ashrextendv2048hi */

    case 27:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29966; /* *narrow_ashrextendv1si */

    case 28:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29970; /* *narrow_ashrextendv2si */

    case 29:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29974; /* *narrow_ashrextendv4si */

    case 30:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29978; /* *narrow_ashrextendv8si */

    case 31:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29982; /* *narrow_ashrextendv16si */

    case 32:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29986; /* *narrow_ashrextendv32si */

    case 33:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29990; /* *narrow_ashrextendv64si */

    case 34:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29994; /* *narrow_ashrextendv128si */

    case 35:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29998; /* *narrow_ashrextendv256si */

    case 36:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30002; /* *narrow_ashrextendv512si */

    case 37:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30006; /* *narrow_ashrextendv1024si */

    case 38:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30010; /* *narrow_ashrextendv1di */

    case 39:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30014; /* *narrow_ashrextendv2di */

    case 40:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30018; /* *narrow_ashrextendv4di */

    case 41:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30022; /* *narrow_ashrextendv8di */

    case 42:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30026; /* *narrow_ashrextendv16di */

    case 43:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30030; /* *narrow_ashrextendv32di */

    case 44:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30034; /* *narrow_ashrextendv64di */

    case 45:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30038; /* *narrow_ashrextendv128di */

    case 46:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30042; /* *narrow_ashrextendv256di */

    case 47:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30046; /* *narrow_ashrextendv512di */

    case 48:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29860; /* *narrow_ashrzero_extendrvvm8hi */

    case 49:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29864; /* *narrow_ashrzero_extendrvvm4hi */

    case 50:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29868; /* *narrow_ashrzero_extendrvvm2hi */

    case 51:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29872; /* *narrow_ashrzero_extendrvvm1hi */

    case 52:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29876; /* *narrow_ashrzero_extendrvvmf2hi */

    case 53:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29880; /* *narrow_ashrzero_extendrvvmf4hi */

    case 54:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29884; /* *narrow_ashrzero_extendrvvm8si */

    case 55:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29888; /* *narrow_ashrzero_extendrvvm4si */

    case 56:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29892; /* *narrow_ashrzero_extendrvvm2si */

    case 57:
      if (!
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29896; /* *narrow_ashrzero_extendrvvm1si */

    case 58:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29900; /* *narrow_ashrzero_extendrvvmf2si */

    case 59:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29904; /* *narrow_ashrzero_extendrvvm8di */

    case 60:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29908; /* *narrow_ashrzero_extendrvvm4di */

    case 61:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29912; /* *narrow_ashrzero_extendrvvm2di */

    case 62:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29916; /* *narrow_ashrzero_extendrvvm1di */

    case 63:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29920; /* *narrow_ashrzero_extendv1hi */

    case 64:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29924; /* *narrow_ashrzero_extendv2hi */

    case 65:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29928; /* *narrow_ashrzero_extendv4hi */

    case 66:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29932; /* *narrow_ashrzero_extendv8hi */

    case 67:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29936; /* *narrow_ashrzero_extendv16hi */

    case 68:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29940; /* *narrow_ashrzero_extendv32hi */

    case 69:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29944; /* *narrow_ashrzero_extendv64hi */

    case 70:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29948; /* *narrow_ashrzero_extendv128hi */

    case 71:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29952; /* *narrow_ashrzero_extendv256hi */

    case 72:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29956; /* *narrow_ashrzero_extendv512hi */

    case 73:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29960; /* *narrow_ashrzero_extendv1024hi */

    case 74:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29964; /* *narrow_ashrzero_extendv2048hi */

    case 75:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29968; /* *narrow_ashrzero_extendv1si */

    case 76:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29972; /* *narrow_ashrzero_extendv2si */

    case 77:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29976; /* *narrow_ashrzero_extendv4si */

    case 78:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29980; /* *narrow_ashrzero_extendv8si */

    case 79:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29984; /* *narrow_ashrzero_extendv16si */

    case 80:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29988; /* *narrow_ashrzero_extendv32si */

    case 81:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29992; /* *narrow_ashrzero_extendv64si */

    case 82:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29996; /* *narrow_ashrzero_extendv128si */

    case 83:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30000; /* *narrow_ashrzero_extendv256si */

    case 84:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30004; /* *narrow_ashrzero_extendv512si */

    case 85:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30008; /* *narrow_ashrzero_extendv1024si */

    case 86:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30012; /* *narrow_ashrzero_extendv1di */

    case 87:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30016; /* *narrow_ashrzero_extendv2di */

    case 88:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30020; /* *narrow_ashrzero_extendv4di */

    case 89:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30024; /* *narrow_ashrzero_extendv8di */

    case 90:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30028; /* *narrow_ashrzero_extendv16di */

    case 91:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30032; /* *narrow_ashrzero_extendv32di */

    case 92:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30036; /* *narrow_ashrzero_extendv64di */

    case 93:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30040; /* *narrow_ashrzero_extendv128di */

    case 94:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30044; /* *narrow_ashrzero_extendv256di */

    case 95:
      if (!(
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30048; /* *narrow_ashrzero_extendv512di */

    case 96:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30050; /* *narrow_ashrrvvm8hi_scalar */

    case 97:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30052; /* *narrow_ashrrvvm4hi_scalar */

    case 98:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30054; /* *narrow_ashrrvvm2hi_scalar */

    case 99:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30056; /* *narrow_ashrrvvm1hi_scalar */

    case 100:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30058; /* *narrow_ashrrvvmf2hi_scalar */

    case 101:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30060; /* *narrow_ashrrvvmf4hi_scalar */

    case 102:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30062; /* *narrow_ashrrvvm8si_scalar */

    case 103:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30064; /* *narrow_ashrrvvm4si_scalar */

    case 104:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30066; /* *narrow_ashrrvvm2si_scalar */

    case 105:
      if (!
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30068; /* *narrow_ashrrvvm1si_scalar */

    case 106:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30070; /* *narrow_ashrrvvmf2si_scalar */

    case 107:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30072; /* *narrow_ashrrvvm8di_scalar */

    case 108:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30074; /* *narrow_ashrrvvm4di_scalar */

    case 109:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30076; /* *narrow_ashrrvvm2di_scalar */

    case 110:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30078; /* *narrow_ashrrvvm1di_scalar */

    case 111:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30080; /* *narrow_ashrv1hi_scalar */

    case 112:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30082; /* *narrow_ashrv2hi_scalar */

    case 113:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30084; /* *narrow_ashrv4hi_scalar */

    case 114:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30086; /* *narrow_ashrv8hi_scalar */

    case 115:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30088; /* *narrow_ashrv16hi_scalar */

    case 116:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30090; /* *narrow_ashrv32hi_scalar */

    case 117:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30092; /* *narrow_ashrv64hi_scalar */

    case 118:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30094; /* *narrow_ashrv128hi_scalar */

    case 119:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30096; /* *narrow_ashrv256hi_scalar */

    case 120:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30098; /* *narrow_ashrv512hi_scalar */

    case 121:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30100; /* *narrow_ashrv1024hi_scalar */

    case 122:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30102; /* *narrow_ashrv2048hi_scalar */

    case 123:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30104; /* *narrow_ashrv1si_scalar */

    case 124:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30106; /* *narrow_ashrv2si_scalar */

    case 125:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30108; /* *narrow_ashrv4si_scalar */

    case 126:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30110; /* *narrow_ashrv8si_scalar */

    case 127:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30112; /* *narrow_ashrv16si_scalar */

    case 128:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30114; /* *narrow_ashrv32si_scalar */

    case 129:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30116; /* *narrow_ashrv64si_scalar */

    case 130:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30118; /* *narrow_ashrv128si_scalar */

    case 131:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30120; /* *narrow_ashrv256si_scalar */

    case 132:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30122; /* *narrow_ashrv512si_scalar */

    case 133:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30124; /* *narrow_ashrv1024si_scalar */

    case 134:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30126; /* *narrow_ashrv1di_scalar */

    case 135:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30128; /* *narrow_ashrv2di_scalar */

    case 136:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30130; /* *narrow_ashrv4di_scalar */

    case 137:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30132; /* *narrow_ashrv8di_scalar */

    case 138:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30134; /* *narrow_ashrv16di_scalar */

    case 139:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30136; /* *narrow_ashrv32di_scalar */

    case 140:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30138; /* *narrow_ashrv64di_scalar */

    case 141:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30140; /* *narrow_ashrv128di_scalar */

    case 142:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30142; /* *narrow_ashrv256di_scalar */

    case 143:
      if (!(
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30144; /* *narrow_ashrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (pattern168 (x3, 
E_SFmode) != 0
          || !
#line 1620 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 81; /* copysignsf3 */

    case E_DFmode:
      if (pattern168 (x3, 
E_DFmode) != 0
          || !(
#line 1620 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 82; /* copysigndf3 */

    case E_HFmode:
      if (pattern168 (x3, 
E_HFmode) != 0
          || !(
#line 1620 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 83; /* copysignhf3 */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern388 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 477; /* stack_protect_test_si */

    case E_DImode:
      if (pattern388 (x3, 
E_DImode) != 0
          || !
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 478; /* stack_protect_test_di */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern176 ())
        {
        case 0:
          if (!(
#line 3595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 405; /* fclasssfsi */

        case 1:
          if (!(
#line 3595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 407; /* fclassdfsi */

        case 2:
          if (!(
#line 3595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 409; /* fclasshfsi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      switch (pattern176 ())
        {
        case 0:
          if (!(
#line 3595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 406; /* fclasssfdi */

        case 1:
          if (!(
#line 3595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 408; /* fclassdfdi */

        case 2:
          if (!(
#line 3595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 410; /* fclasshfdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !register_operand (operands[3], E_RVVMF4BImode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_RVVMF4BImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x4))
    {
    case E_RVVM2QImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM2QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8691; /* pred_madcrvvm2qi_scalar */

    case E_RVVM4HImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM4HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8697; /* pred_madcrvvm4hi_scalar */

    case E_RVVM8SImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM8SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 3496 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8702; /* pred_madcrvvm8si_scalar */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18129; /* pred_redminrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18137; /* pred_redminrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18145; /* pred_redminrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18153; /* pred_redminrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18257; /* pred_redminrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18265; /* pred_redminrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18273; /* pred_redminrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18305; /* pred_redminv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18313; /* pred_redminv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18321; /* pred_redminv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18329; /* pred_redminv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18337; /* pred_redminv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18345; /* pred_redminv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18353; /* pred_redminv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18361; /* pred_redminv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18369; /* pred_redminv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18377; /* pred_redminv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18385; /* pred_redminv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18393; /* pred_redminv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18401; /* pred_redminv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18161; /* pred_redminrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18169; /* pred_redminrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18177; /* pred_redminrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18185; /* pred_redminrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18281; /* pred_redminrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18289; /* pred_redminrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18409; /* pred_redminv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18417; /* pred_redminv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18425; /* pred_redminv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18433; /* pred_redminv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18441; /* pred_redminv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18449; /* pred_redminv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18457; /* pred_redminv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18465; /* pred_redminv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18473; /* pred_redminv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18481; /* pred_redminv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18489; /* pred_redminv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18497; /* pred_redminv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18193; /* pred_redminrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18201; /* pred_redminrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18209; /* pred_redminrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18217; /* pred_redminrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18297; /* pred_redminrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18505; /* pred_redminv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18513; /* pred_redminv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18521; /* pred_redminv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18529; /* pred_redminv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18537; /* pred_redminv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18545; /* pred_redminv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18553; /* pred_redminv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18561; /* pred_redminv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18569; /* pred_redminv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18577; /* pred_redminv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18585; /* pred_redminv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18225; /* pred_redminrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18233; /* pred_redminrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18241; /* pred_redminrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18249; /* pred_redminrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18593; /* pred_redminv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18601; /* pred_redminv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18609; /* pred_redminv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18617; /* pred_redminv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18625; /* pred_redminv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18633; /* pred_redminv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18641; /* pred_redminv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18649; /* pred_redminv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18657; /* pred_redminv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18665; /* pred_redminv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19430; /* pred_redminrvvm8hf */

        case 1:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19432; /* pred_redminrvvm4hf */

        case 2:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19434; /* pred_redminrvvm2hf */

        case 3:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19436; /* pred_redminrvvm1hf */

        case 4:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19438; /* pred_redminrvvmf2hf */

        case 5:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19440; /* pred_redminrvvmf4hf */

        case 6:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19460; /* pred_redminv1hf */

        case 7:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19462; /* pred_redminv2hf */

        case 8:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19464; /* pred_redminv4hf */

        case 9:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19466; /* pred_redminv8hf */

        case 10:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19468; /* pred_redminv16hf */

        case 11:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19470; /* pred_redminv32hf */

        case 12:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19472; /* pred_redminv64hf */

        case 13:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19474; /* pred_redminv128hf */

        case 14:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19476; /* pred_redminv256hf */

        case 15:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19478; /* pred_redminv512hf */

        case 16:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19480; /* pred_redminv1024hf */

        case 17:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19482; /* pred_redminv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19442; /* pred_redminrvvm8sf */

        case 1:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19444; /* pred_redminrvvm4sf */

        case 2:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19446; /* pred_redminrvvm2sf */

        case 3:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19448; /* pred_redminrvvm1sf */

        case 4:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19450; /* pred_redminrvvmf2sf */

        case 5:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19484; /* pred_redminv1sf */

        case 6:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19486; /* pred_redminv2sf */

        case 7:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19488; /* pred_redminv4sf */

        case 8:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19490; /* pred_redminv8sf */

        case 9:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19492; /* pred_redminv16sf */

        case 10:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19494; /* pred_redminv32sf */

        case 11:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19496; /* pred_redminv64sf */

        case 12:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19498; /* pred_redminv128sf */

        case 13:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19500; /* pred_redminv256sf */

        case 14:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19502; /* pred_redminv512sf */

        case 15:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19504; /* pred_redminv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19452; /* pred_redminrvvm8df */

        case 1:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19454; /* pred_redminrvvm4df */

        case 2:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19456; /* pred_redminrvvm2df */

        case 3:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19458; /* pred_redminrvvm1df */

        case 4:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19506; /* pred_redminv1df */

        case 5:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19508; /* pred_redminv2df */

        case 6:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19510; /* pred_redminv4df */

        case 7:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19512; /* pred_redminv8df */

        case 8:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19514; /* pred_redminv16df */

        case 9:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19516; /* pred_redminv32df */

        case 10:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19518; /* pred_redminv64df */

        case 11:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19520; /* pred_redminv128df */

        case 12:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19522; /* pred_redminv256df */

        case 13:
          if (!(
#line 7867 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19524; /* pred_redminv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18130; /* pred_redandrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18138; /* pred_redandrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18146; /* pred_redandrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18154; /* pred_redandrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18258; /* pred_redandrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18266; /* pred_redandrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18274; /* pred_redandrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18306; /* pred_redandv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18314; /* pred_redandv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18322; /* pred_redandv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18330; /* pred_redandv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18338; /* pred_redandv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18346; /* pred_redandv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18354; /* pred_redandv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18362; /* pred_redandv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18370; /* pred_redandv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18378; /* pred_redandv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18386; /* pred_redandv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18394; /* pred_redandv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18402; /* pred_redandv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18162; /* pred_redandrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18170; /* pred_redandrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18178; /* pred_redandrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18186; /* pred_redandrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18282; /* pred_redandrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18290; /* pred_redandrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18410; /* pred_redandv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18418; /* pred_redandv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18426; /* pred_redandv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18434; /* pred_redandv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18442; /* pred_redandv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18450; /* pred_redandv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18458; /* pred_redandv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18466; /* pred_redandv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18474; /* pred_redandv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18482; /* pred_redandv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18490; /* pred_redandv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18498; /* pred_redandv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18194; /* pred_redandrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18202; /* pred_redandrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18210; /* pred_redandrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18218; /* pred_redandrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18298; /* pred_redandrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18506; /* pred_redandv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18514; /* pred_redandv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18522; /* pred_redandv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18530; /* pred_redandv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18538; /* pred_redandv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18546; /* pred_redandv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18554; /* pred_redandv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18562; /* pred_redandv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18570; /* pred_redandv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18578; /* pred_redandv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18586; /* pred_redandv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18226; /* pred_redandrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18234; /* pred_redandrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18242; /* pred_redandrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18250; /* pred_redandrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18594; /* pred_redandv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18602; /* pred_redandv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18610; /* pred_redandv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18618; /* pred_redandv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18626; /* pred_redandv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18634; /* pred_redandv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18642; /* pred_redandv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18650; /* pred_redandv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18658; /* pred_redandv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18666; /* pred_redandv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19621; /* pred_redosumrvvm8hf */

        case 1:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19623; /* pred_redosumrvvm4hf */

        case 2:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19625; /* pred_redosumrvvm2hf */

        case 3:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19627; /* pred_redosumrvvm1hf */

        case 4:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19629; /* pred_redosumrvvmf2hf */

        case 5:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19631; /* pred_redosumrvvmf4hf */

        case 6:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19651; /* pred_redosumv1hf */

        case 7:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19653; /* pred_redosumv2hf */

        case 8:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19655; /* pred_redosumv4hf */

        case 9:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19657; /* pred_redosumv8hf */

        case 10:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19659; /* pred_redosumv16hf */

        case 11:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19661; /* pred_redosumv32hf */

        case 12:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19663; /* pred_redosumv64hf */

        case 13:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19665; /* pred_redosumv128hf */

        case 14:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19667; /* pred_redosumv256hf */

        case 15:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19669; /* pred_redosumv512hf */

        case 16:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19671; /* pred_redosumv1024hf */

        case 17:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19673; /* pred_redosumv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19633; /* pred_redosumrvvm8sf */

        case 1:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19635; /* pred_redosumrvvm4sf */

        case 2:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19637; /* pred_redosumrvvm2sf */

        case 3:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19639; /* pred_redosumrvvm1sf */

        case 4:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19641; /* pred_redosumrvvmf2sf */

        case 5:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19675; /* pred_redosumv1sf */

        case 6:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19677; /* pred_redosumv2sf */

        case 7:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19679; /* pred_redosumv4sf */

        case 8:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19681; /* pred_redosumv8sf */

        case 9:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19683; /* pred_redosumv16sf */

        case 10:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19685; /* pred_redosumv32sf */

        case 11:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19687; /* pred_redosumv64sf */

        case 12:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19689; /* pred_redosumv128sf */

        case 13:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19691; /* pred_redosumv256sf */

        case 14:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19693; /* pred_redosumv512sf */

        case 15:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19695; /* pred_redosumv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19643; /* pred_redosumrvvm8df */

        case 1:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19645; /* pred_redosumrvvm4df */

        case 2:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19647; /* pred_redosumrvvm2df */

        case 3:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19649; /* pred_redosumrvvm1df */

        case 4:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19697; /* pred_redosumv1df */

        case 5:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19699; /* pred_redosumv2df */

        case 6:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19701; /* pred_redosumv4df */

        case 7:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19703; /* pred_redosumv8df */

        case 8:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19705; /* pred_redosumv16df */

        case 9:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19707; /* pred_redosumv32df */

        case 10:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19709; /* pred_redosumv64df */

        case 11:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19711; /* pred_redosumv128df */

        case 12:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19713; /* pred_redosumv256df */

        case 13:
          if (!(
#line 7912 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19715; /* pred_redosumv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF8x2QImode:
      if (!register_operand (operands[3], E_RVVMF8x2QImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21603; /* pred_strided_storervvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[3], E_RVVMF8x3QImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21604; /* pred_strided_storervvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[3], E_RVVMF8x4QImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21605; /* pred_strided_storervvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[3], E_RVVMF8x5QImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21606; /* pred_strided_storervvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[3], E_RVVMF8x6QImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21607; /* pred_strided_storervvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[3], E_RVVMF8x7QImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21608; /* pred_strided_storervvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[3], E_RVVMF8x8QImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21609; /* pred_strided_storervvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[3], E_RVVMF4x2HImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21610; /* pred_strided_storervvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[3], E_RVVMF4x3HImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21611; /* pred_strided_storervvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[3], E_RVVMF4x4HImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21612; /* pred_strided_storervvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[3], E_RVVMF4x5HImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21613; /* pred_strided_storervvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[3], E_RVVMF4x6HImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21614; /* pred_strided_storervvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[3], E_RVVMF4x7HImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21615; /* pred_strided_storervvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[3], E_RVVMF4x8HImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21616; /* pred_strided_storervvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[3], E_RVVMF2x2SImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21617; /* pred_strided_storervvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[3], E_RVVMF2x3SImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21618; /* pred_strided_storervvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[3], E_RVVMF2x4SImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21619; /* pred_strided_storervvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[3], E_RVVMF2x5SImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21620; /* pred_strided_storervvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[3], E_RVVMF2x6SImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21621; /* pred_strided_storervvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[3], E_RVVMF2x7SImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21622; /* pred_strided_storervvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[3], E_RVVMF2x8SImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21623; /* pred_strided_storervvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[3], E_RVVM1x2DImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21624; /* pred_strided_storervvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[3], E_RVVM1x3DImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21625; /* pred_strided_storervvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[3], E_RVVM1x4DImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21626; /* pred_strided_storervvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[3], E_RVVM1x5DImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21627; /* pred_strided_storervvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[3], E_RVVM1x6DImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21628; /* pred_strided_storervvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[3], E_RVVM1x7DImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21629; /* pred_strided_storervvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[3], E_RVVM1x8DImode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21630; /* pred_strided_storervvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[3], E_RVVMF4x2BFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21631; /* pred_strided_storervvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[3], E_RVVMF4x3BFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21632; /* pred_strided_storervvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[3], E_RVVMF4x4BFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21633; /* pred_strided_storervvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[3], E_RVVMF4x5BFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21634; /* pred_strided_storervvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[3], E_RVVMF4x6BFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21635; /* pred_strided_storervvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[3], E_RVVMF4x7BFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21636; /* pred_strided_storervvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[3], E_RVVMF4x8BFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21637; /* pred_strided_storervvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[3], E_RVVMF4x2HFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21638; /* pred_strided_storervvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[3], E_RVVMF4x3HFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21639; /* pred_strided_storervvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[3], E_RVVMF4x4HFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21640; /* pred_strided_storervvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[3], E_RVVMF4x5HFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21641; /* pred_strided_storervvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[3], E_RVVMF4x6HFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21642; /* pred_strided_storervvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[3], E_RVVMF4x7HFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21643; /* pred_strided_storervvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[3], E_RVVMF4x8HFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21644; /* pred_strided_storervvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[3], E_RVVMF2x2SFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21645; /* pred_strided_storervvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[3], E_RVVMF2x3SFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21646; /* pred_strided_storervvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[3], E_RVVMF2x4SFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21647; /* pred_strided_storervvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[3], E_RVVMF2x5SFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21648; /* pred_strided_storervvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[3], E_RVVMF2x6SFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21649; /* pred_strided_storervvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[3], E_RVVMF2x7SFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21650; /* pred_strided_storervvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[3], E_RVVMF2x8SFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21651; /* pred_strided_storervvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[3], E_RVVM1x2DFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21652; /* pred_strided_storervvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[3], E_RVVM1x3DFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21653; /* pred_strided_storervvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[3], E_RVVM1x4DFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21654; /* pred_strided_storervvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[3], E_RVVM1x5DFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21655; /* pred_strided_storervvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[3], E_RVVM1x6DFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21656; /* pred_strided_storervvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[3], E_RVVM1x7DFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21657; /* pred_strided_storervvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[3], E_RVVM1x8DFmode)
          || !(
#line 8435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21658; /* pred_strided_storervvm1x8df */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5188; /* pred_indexed_ustorervvmf8qirvvmf8qi */

    case 1:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5190; /* pred_indexed_ustorervvmf4hirvvmf8qi */

    case 2:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5192; /* pred_indexed_ustorervvmf2sirvvmf8qi */

    case 3:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5194; /* pred_indexed_ustorervvm1dirvvmf8qi */

    case 4:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5196; /* pred_indexed_ustorervvmf4bfrvvmf8qi */

    case 5:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 811 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5198; /* pred_indexed_ustorervvmf4hfrvvmf8qi */

    case 6:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5200; /* pred_indexed_ustorervvmf2sfrvvmf8qi */

    case 7:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 813 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5202; /* pred_indexed_ustorervvm1dfrvvmf8qi */

    case 8:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23238; /* pred_indexed_ustorervvmf8x2qirvvmf8qi */

    case 9:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23246; /* pred_indexed_ustorervvmf8x3qirvvmf8qi */

    case 10:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23254; /* pred_indexed_ustorervvmf8x4qirvvmf8qi */

    case 11:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23262; /* pred_indexed_ustorervvmf8x5qirvvmf8qi */

    case 12:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23270; /* pred_indexed_ustorervvmf8x6qirvvmf8qi */

    case 13:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23278; /* pred_indexed_ustorervvmf8x7qirvvmf8qi */

    case 14:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23286; /* pred_indexed_ustorervvmf8x8qirvvmf8qi */

    case 15:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23294; /* pred_indexed_ustorervvmf4x2hirvvmf8qi */

    case 16:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23302; /* pred_indexed_ustorervvmf4x3hirvvmf8qi */

    case 17:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23310; /* pred_indexed_ustorervvmf4x4hirvvmf8qi */

    case 18:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23318; /* pred_indexed_ustorervvmf4x5hirvvmf8qi */

    case 19:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23326; /* pred_indexed_ustorervvmf4x6hirvvmf8qi */

    case 20:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23334; /* pred_indexed_ustorervvmf4x7hirvvmf8qi */

    case 21:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23342; /* pred_indexed_ustorervvmf4x8hirvvmf8qi */

    case 22:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23350; /* pred_indexed_ustorervvmf2x2sirvvmf8qi */

    case 23:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23358; /* pred_indexed_ustorervvmf2x3sirvvmf8qi */

    case 24:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23366; /* pred_indexed_ustorervvmf2x4sirvvmf8qi */

    case 25:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23374; /* pred_indexed_ustorervvmf2x5sirvvmf8qi */

    case 26:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23382; /* pred_indexed_ustorervvmf2x6sirvvmf8qi */

    case 27:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23390; /* pred_indexed_ustorervvmf2x7sirvvmf8qi */

    case 28:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23398; /* pred_indexed_ustorervvmf2x8sirvvmf8qi */

    case 29:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23406; /* pred_indexed_ustorervvm1x2dirvvmf8qi */

    case 30:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23414; /* pred_indexed_ustorervvm1x3dirvvmf8qi */

    case 31:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23422; /* pred_indexed_ustorervvm1x4dirvvmf8qi */

    case 32:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23430; /* pred_indexed_ustorervvm1x5dirvvmf8qi */

    case 33:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23438; /* pred_indexed_ustorervvm1x6dirvvmf8qi */

    case 34:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23446; /* pred_indexed_ustorervvm1x7dirvvmf8qi */

    case 35:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23454; /* pred_indexed_ustorervvm1x8dirvvmf8qi */

    case 36:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23462; /* pred_indexed_ustorervvmf4x2bfrvvmf8qi */

    case 37:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23470; /* pred_indexed_ustorervvmf4x3bfrvvmf8qi */

    case 38:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23478; /* pred_indexed_ustorervvmf4x4bfrvvmf8qi */

    case 39:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23486; /* pred_indexed_ustorervvmf4x5bfrvvmf8qi */

    case 40:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23494; /* pred_indexed_ustorervvmf4x6bfrvvmf8qi */

    case 41:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23502; /* pred_indexed_ustorervvmf4x7bfrvvmf8qi */

    case 42:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23510; /* pred_indexed_ustorervvmf4x8bfrvvmf8qi */

    case 43:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23518; /* pred_indexed_ustorervvmf4x2hfrvvmf8qi */

    case 44:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23526; /* pred_indexed_ustorervvmf4x3hfrvvmf8qi */

    case 45:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23534; /* pred_indexed_ustorervvmf4x4hfrvvmf8qi */

    case 46:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23542; /* pred_indexed_ustorervvmf4x5hfrvvmf8qi */

    case 47:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23550; /* pred_indexed_ustorervvmf4x6hfrvvmf8qi */

    case 48:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23558; /* pred_indexed_ustorervvmf4x7hfrvvmf8qi */

    case 49:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23566; /* pred_indexed_ustorervvmf4x8hfrvvmf8qi */

    case 50:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23574; /* pred_indexed_ustorervvmf2x2sfrvvmf8qi */

    case 51:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23582; /* pred_indexed_ustorervvmf2x3sfrvvmf8qi */

    case 52:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23590; /* pred_indexed_ustorervvmf2x4sfrvvmf8qi */

    case 53:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23598; /* pred_indexed_ustorervvmf2x5sfrvvmf8qi */

    case 54:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23606; /* pred_indexed_ustorervvmf2x6sfrvvmf8qi */

    case 55:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23614; /* pred_indexed_ustorervvmf2x7sfrvvmf8qi */

    case 56:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23622; /* pred_indexed_ustorervvmf2x8sfrvvmf8qi */

    case 57:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23630; /* pred_indexed_ustorervvm1x2dfrvvmf8qi */

    case 58:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23638; /* pred_indexed_ustorervvm1x3dfrvvmf8qi */

    case 59:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23646; /* pred_indexed_ustorervvm1x4dfrvvmf8qi */

    case 60:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23654; /* pred_indexed_ustorervvm1x5dfrvvmf8qi */

    case 61:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23662; /* pred_indexed_ustorervvm1x6dfrvvmf8qi */

    case 62:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23670; /* pred_indexed_ustorervvm1x7dfrvvmf8qi */

    case 63:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23678; /* pred_indexed_ustorervvm1x8dfrvvmf8qi */

    case 64:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5204; /* pred_indexed_ustorervvmf8qirvvmf4hi */

    case 65:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5206; /* pred_indexed_ustorervvmf4hirvvmf4hi */

    case 66:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5208; /* pred_indexed_ustorervvmf2sirvvmf4hi */

    case 67:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5210; /* pred_indexed_ustorervvm1dirvvmf4hi */

    case 68:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5212; /* pred_indexed_ustorervvmf4bfrvvmf4hi */

    case 69:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 811 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5214; /* pred_indexed_ustorervvmf4hfrvvmf4hi */

    case 70:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5216; /* pred_indexed_ustorervvmf2sfrvvmf4hi */

    case 71:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 813 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5218; /* pred_indexed_ustorervvm1dfrvvmf4hi */

    case 72:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23240; /* pred_indexed_ustorervvmf8x2qirvvmf4hi */

    case 73:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23248; /* pred_indexed_ustorervvmf8x3qirvvmf4hi */

    case 74:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23256; /* pred_indexed_ustorervvmf8x4qirvvmf4hi */

    case 75:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23264; /* pred_indexed_ustorervvmf8x5qirvvmf4hi */

    case 76:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23272; /* pred_indexed_ustorervvmf8x6qirvvmf4hi */

    case 77:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23280; /* pred_indexed_ustorervvmf8x7qirvvmf4hi */

    case 78:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23288; /* pred_indexed_ustorervvmf8x8qirvvmf4hi */

    case 79:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23296; /* pred_indexed_ustorervvmf4x2hirvvmf4hi */

    case 80:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23304; /* pred_indexed_ustorervvmf4x3hirvvmf4hi */

    case 81:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23312; /* pred_indexed_ustorervvmf4x4hirvvmf4hi */

    case 82:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23320; /* pred_indexed_ustorervvmf4x5hirvvmf4hi */

    case 83:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23328; /* pred_indexed_ustorervvmf4x6hirvvmf4hi */

    case 84:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23336; /* pred_indexed_ustorervvmf4x7hirvvmf4hi */

    case 85:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23344; /* pred_indexed_ustorervvmf4x8hirvvmf4hi */

    case 86:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23352; /* pred_indexed_ustorervvmf2x2sirvvmf4hi */

    case 87:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23360; /* pred_indexed_ustorervvmf2x3sirvvmf4hi */

    case 88:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23368; /* pred_indexed_ustorervvmf2x4sirvvmf4hi */

    case 89:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23376; /* pred_indexed_ustorervvmf2x5sirvvmf4hi */

    case 90:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23384; /* pred_indexed_ustorervvmf2x6sirvvmf4hi */

    case 91:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23392; /* pred_indexed_ustorervvmf2x7sirvvmf4hi */

    case 92:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23400; /* pred_indexed_ustorervvmf2x8sirvvmf4hi */

    case 93:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23408; /* pred_indexed_ustorervvm1x2dirvvmf4hi */

    case 94:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23416; /* pred_indexed_ustorervvm1x3dirvvmf4hi */

    case 95:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23424; /* pred_indexed_ustorervvm1x4dirvvmf4hi */

    case 96:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23432; /* pred_indexed_ustorervvm1x5dirvvmf4hi */

    case 97:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23440; /* pred_indexed_ustorervvm1x6dirvvmf4hi */

    case 98:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23448; /* pred_indexed_ustorervvm1x7dirvvmf4hi */

    case 99:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23456; /* pred_indexed_ustorervvm1x8dirvvmf4hi */

    case 100:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23464; /* pred_indexed_ustorervvmf4x2bfrvvmf4hi */

    case 101:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23472; /* pred_indexed_ustorervvmf4x3bfrvvmf4hi */

    case 102:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23480; /* pred_indexed_ustorervvmf4x4bfrvvmf4hi */

    case 103:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23488; /* pred_indexed_ustorervvmf4x5bfrvvmf4hi */

    case 104:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23496; /* pred_indexed_ustorervvmf4x6bfrvvmf4hi */

    case 105:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23504; /* pred_indexed_ustorervvmf4x7bfrvvmf4hi */

    case 106:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23512; /* pred_indexed_ustorervvmf4x8bfrvvmf4hi */

    case 107:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23520; /* pred_indexed_ustorervvmf4x2hfrvvmf4hi */

    case 108:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23528; /* pred_indexed_ustorervvmf4x3hfrvvmf4hi */

    case 109:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23536; /* pred_indexed_ustorervvmf4x4hfrvvmf4hi */

    case 110:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23544; /* pred_indexed_ustorervvmf4x5hfrvvmf4hi */

    case 111:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23552; /* pred_indexed_ustorervvmf4x6hfrvvmf4hi */

    case 112:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23560; /* pred_indexed_ustorervvmf4x7hfrvvmf4hi */

    case 113:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23568; /* pred_indexed_ustorervvmf4x8hfrvvmf4hi */

    case 114:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23576; /* pred_indexed_ustorervvmf2x2sfrvvmf4hi */

    case 115:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23584; /* pred_indexed_ustorervvmf2x3sfrvvmf4hi */

    case 116:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23592; /* pred_indexed_ustorervvmf2x4sfrvvmf4hi */

    case 117:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23600; /* pred_indexed_ustorervvmf2x5sfrvvmf4hi */

    case 118:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23608; /* pred_indexed_ustorervvmf2x6sfrvvmf4hi */

    case 119:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23616; /* pred_indexed_ustorervvmf2x7sfrvvmf4hi */

    case 120:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23624; /* pred_indexed_ustorervvmf2x8sfrvvmf4hi */

    case 121:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23632; /* pred_indexed_ustorervvm1x2dfrvvmf4hi */

    case 122:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23640; /* pred_indexed_ustorervvm1x3dfrvvmf4hi */

    case 123:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23648; /* pred_indexed_ustorervvm1x4dfrvvmf4hi */

    case 124:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23656; /* pred_indexed_ustorervvm1x5dfrvvmf4hi */

    case 125:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23664; /* pred_indexed_ustorervvm1x6dfrvvmf4hi */

    case 126:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23672; /* pred_indexed_ustorervvm1x7dfrvvmf4hi */

    case 127:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23680; /* pred_indexed_ustorervvm1x8dfrvvmf4hi */

    case 128:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5220; /* pred_indexed_ustorervvmf8qirvvmf2si */

    case 129:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5222; /* pred_indexed_ustorervvmf4hirvvmf2si */

    case 130:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5224; /* pred_indexed_ustorervvmf2sirvvmf2si */

    case 131:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5226; /* pred_indexed_ustorervvm1dirvvmf2si */

    case 132:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5228; /* pred_indexed_ustorervvmf4bfrvvmf2si */

    case 133:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 811 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5230; /* pred_indexed_ustorervvmf4hfrvvmf2si */

    case 134:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5232; /* pred_indexed_ustorervvmf2sfrvvmf2si */

    case 135:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 813 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5234; /* pred_indexed_ustorervvm1dfrvvmf2si */

    case 136:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23242; /* pred_indexed_ustorervvmf8x2qirvvmf2si */

    case 137:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23250; /* pred_indexed_ustorervvmf8x3qirvvmf2si */

    case 138:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23258; /* pred_indexed_ustorervvmf8x4qirvvmf2si */

    case 139:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23266; /* pred_indexed_ustorervvmf8x5qirvvmf2si */

    case 140:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23274; /* pred_indexed_ustorervvmf8x6qirvvmf2si */

    case 141:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23282; /* pred_indexed_ustorervvmf8x7qirvvmf2si */

    case 142:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23290; /* pred_indexed_ustorervvmf8x8qirvvmf2si */

    case 143:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23298; /* pred_indexed_ustorervvmf4x2hirvvmf2si */

    case 144:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23306; /* pred_indexed_ustorervvmf4x3hirvvmf2si */

    case 145:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23314; /* pred_indexed_ustorervvmf4x4hirvvmf2si */

    case 146:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23322; /* pred_indexed_ustorervvmf4x5hirvvmf2si */

    case 147:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23330; /* pred_indexed_ustorervvmf4x6hirvvmf2si */

    case 148:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23338; /* pred_indexed_ustorervvmf4x7hirvvmf2si */

    case 149:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23346; /* pred_indexed_ustorervvmf4x8hirvvmf2si */

    case 150:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23354; /* pred_indexed_ustorervvmf2x2sirvvmf2si */

    case 151:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23362; /* pred_indexed_ustorervvmf2x3sirvvmf2si */

    case 152:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23370; /* pred_indexed_ustorervvmf2x4sirvvmf2si */

    case 153:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23378; /* pred_indexed_ustorervvmf2x5sirvvmf2si */

    case 154:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23386; /* pred_indexed_ustorervvmf2x6sirvvmf2si */

    case 155:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23394; /* pred_indexed_ustorervvmf2x7sirvvmf2si */

    case 156:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23402; /* pred_indexed_ustorervvmf2x8sirvvmf2si */

    case 157:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23410; /* pred_indexed_ustorervvm1x2dirvvmf2si */

    case 158:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23418; /* pred_indexed_ustorervvm1x3dirvvmf2si */

    case 159:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23426; /* pred_indexed_ustorervvm1x4dirvvmf2si */

    case 160:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23434; /* pred_indexed_ustorervvm1x5dirvvmf2si */

    case 161:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23442; /* pred_indexed_ustorervvm1x6dirvvmf2si */

    case 162:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23450; /* pred_indexed_ustorervvm1x7dirvvmf2si */

    case 163:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23458; /* pred_indexed_ustorervvm1x8dirvvmf2si */

    case 164:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23466; /* pred_indexed_ustorervvmf4x2bfrvvmf2si */

    case 165:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23474; /* pred_indexed_ustorervvmf4x3bfrvvmf2si */

    case 166:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23482; /* pred_indexed_ustorervvmf4x4bfrvvmf2si */

    case 167:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23490; /* pred_indexed_ustorervvmf4x5bfrvvmf2si */

    case 168:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23498; /* pred_indexed_ustorervvmf4x6bfrvvmf2si */

    case 169:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23506; /* pred_indexed_ustorervvmf4x7bfrvvmf2si */

    case 170:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23514; /* pred_indexed_ustorervvmf4x8bfrvvmf2si */

    case 171:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23522; /* pred_indexed_ustorervvmf4x2hfrvvmf2si */

    case 172:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23530; /* pred_indexed_ustorervvmf4x3hfrvvmf2si */

    case 173:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23538; /* pred_indexed_ustorervvmf4x4hfrvvmf2si */

    case 174:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23546; /* pred_indexed_ustorervvmf4x5hfrvvmf2si */

    case 175:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23554; /* pred_indexed_ustorervvmf4x6hfrvvmf2si */

    case 176:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23562; /* pred_indexed_ustorervvmf4x7hfrvvmf2si */

    case 177:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23570; /* pred_indexed_ustorervvmf4x8hfrvvmf2si */

    case 178:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23578; /* pred_indexed_ustorervvmf2x2sfrvvmf2si */

    case 179:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23586; /* pred_indexed_ustorervvmf2x3sfrvvmf2si */

    case 180:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23594; /* pred_indexed_ustorervvmf2x4sfrvvmf2si */

    case 181:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23602; /* pred_indexed_ustorervvmf2x5sfrvvmf2si */

    case 182:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23610; /* pred_indexed_ustorervvmf2x6sfrvvmf2si */

    case 183:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23618; /* pred_indexed_ustorervvmf2x7sfrvvmf2si */

    case 184:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23626; /* pred_indexed_ustorervvmf2x8sfrvvmf2si */

    case 185:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23634; /* pred_indexed_ustorervvm1x2dfrvvmf2si */

    case 186:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23642; /* pred_indexed_ustorervvm1x3dfrvvmf2si */

    case 187:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23650; /* pred_indexed_ustorervvm1x4dfrvvmf2si */

    case 188:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23658; /* pred_indexed_ustorervvm1x5dfrvvmf2si */

    case 189:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23666; /* pred_indexed_ustorervvm1x6dfrvvmf2si */

    case 190:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23674; /* pred_indexed_ustorervvm1x7dfrvvmf2si */

    case 191:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23682; /* pred_indexed_ustorervvm1x8dfrvvmf2si */

    case 192:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 806 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5236; /* pred_indexed_ustorervvmf8qirvvm1di */

    case 193:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 807 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5238; /* pred_indexed_ustorervvmf4hirvvm1di */

    case 194:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 808 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5240; /* pred_indexed_ustorervvmf2sirvvm1di */

    case 195:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 809 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5242; /* pred_indexed_ustorervvm1dirvvm1di */

    case 196:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 810 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5244; /* pred_indexed_ustorervvmf4bfrvvm1di */

    case 197:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 811 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5246; /* pred_indexed_ustorervvmf4hfrvvm1di */

    case 198:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 812 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5248; /* pred_indexed_ustorervvmf2sfrvvm1di */

    case 199:
      if (!(
#line 2588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 813 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5250; /* pred_indexed_ustorervvm1dfrvvm1di */

    case 200:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23244; /* pred_indexed_ustorervvmf8x2qirvvm1di */

    case 201:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23252; /* pred_indexed_ustorervvmf8x3qirvvm1di */

    case 202:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23260; /* pred_indexed_ustorervvmf8x4qirvvm1di */

    case 203:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23268; /* pred_indexed_ustorervvmf8x5qirvvm1di */

    case 204:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23276; /* pred_indexed_ustorervvmf8x6qirvvm1di */

    case 205:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23284; /* pred_indexed_ustorervvmf8x7qirvvm1di */

    case 206:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23292; /* pred_indexed_ustorervvmf8x8qirvvm1di */

    case 207:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23300; /* pred_indexed_ustorervvmf4x2hirvvm1di */

    case 208:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23308; /* pred_indexed_ustorervvmf4x3hirvvm1di */

    case 209:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23316; /* pred_indexed_ustorervvmf4x4hirvvm1di */

    case 210:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23324; /* pred_indexed_ustorervvmf4x5hirvvm1di */

    case 211:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23332; /* pred_indexed_ustorervvmf4x6hirvvm1di */

    case 212:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23340; /* pred_indexed_ustorervvmf4x7hirvvm1di */

    case 213:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23348; /* pred_indexed_ustorervvmf4x8hirvvm1di */

    case 214:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23356; /* pred_indexed_ustorervvmf2x2sirvvm1di */

    case 215:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23364; /* pred_indexed_ustorervvmf2x3sirvvm1di */

    case 216:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23372; /* pred_indexed_ustorervvmf2x4sirvvm1di */

    case 217:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23380; /* pred_indexed_ustorervvmf2x5sirvvm1di */

    case 218:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23388; /* pred_indexed_ustorervvmf2x6sirvvm1di */

    case 219:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23396; /* pred_indexed_ustorervvmf2x7sirvvm1di */

    case 220:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23404; /* pred_indexed_ustorervvmf2x8sirvvm1di */

    case 221:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23412; /* pred_indexed_ustorervvm1x2dirvvm1di */

    case 222:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23420; /* pred_indexed_ustorervvm1x3dirvvm1di */

    case 223:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23428; /* pred_indexed_ustorervvm1x4dirvvm1di */

    case 224:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23436; /* pred_indexed_ustorervvm1x5dirvvm1di */

    case 225:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23444; /* pred_indexed_ustorervvm1x6dirvvm1di */

    case 226:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23452; /* pred_indexed_ustorervvm1x7dirvvm1di */

    case 227:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23460; /* pred_indexed_ustorervvm1x8dirvvm1di */

    case 228:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23468; /* pred_indexed_ustorervvmf4x2bfrvvm1di */

    case 229:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23476; /* pred_indexed_ustorervvmf4x3bfrvvm1di */

    case 230:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23484; /* pred_indexed_ustorervvmf4x4bfrvvm1di */

    case 231:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23492; /* pred_indexed_ustorervvmf4x5bfrvvm1di */

    case 232:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23500; /* pred_indexed_ustorervvmf4x6bfrvvm1di */

    case 233:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23508; /* pred_indexed_ustorervvmf4x7bfrvvm1di */

    case 234:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23516; /* pred_indexed_ustorervvmf4x8bfrvvm1di */

    case 235:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23524; /* pred_indexed_ustorervvmf4x2hfrvvm1di */

    case 236:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23532; /* pred_indexed_ustorervvmf4x3hfrvvm1di */

    case 237:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23540; /* pred_indexed_ustorervvmf4x4hfrvvm1di */

    case 238:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23548; /* pred_indexed_ustorervvmf4x5hfrvvm1di */

    case 239:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23556; /* pred_indexed_ustorervvmf4x6hfrvvm1di */

    case 240:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23564; /* pred_indexed_ustorervvmf4x7hfrvvm1di */

    case 241:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23572; /* pred_indexed_ustorervvmf4x8hfrvvm1di */

    case 242:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23580; /* pred_indexed_ustorervvmf2x2sfrvvm1di */

    case 243:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23588; /* pred_indexed_ustorervvmf2x3sfrvvm1di */

    case 244:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23596; /* pred_indexed_ustorervvmf2x4sfrvvm1di */

    case 245:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23604; /* pred_indexed_ustorervvmf2x5sfrvvm1di */

    case 246:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23612; /* pred_indexed_ustorervvmf2x6sfrvvm1di */

    case 247:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23620; /* pred_indexed_ustorervvmf2x7sfrvvm1di */

    case 248:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23628; /* pred_indexed_ustorervvmf2x8sfrvvm1di */

    case 249:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23636; /* pred_indexed_ustorervvm1x2dfrvvm1di */

    case 250:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23644; /* pred_indexed_ustorervvm1x3dfrvvm1di */

    case 251:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23652; /* pred_indexed_ustorervvm1x4dfrvvm1di */

    case 252:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23660; /* pred_indexed_ustorervvm1x5dfrvvm1di */

    case 253:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23668; /* pred_indexed_ustorervvm1x6dfrvvm1di */

    case 254:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23676; /* pred_indexed_ustorervvm1x7dfrvvm1di */

    case 255:
      if (!(
#line 8609 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23684; /* pred_indexed_ustorervvm1x8dfrvvm1di */

    case 256:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5252; /* pred_indexed_ustorervvmf4qirvvmf4qi */

    case 257:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5260; /* pred_indexed_ustorervvmf2hirvvmf4qi */

    case 258:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5268; /* pred_indexed_ustorervvm1sirvvmf4qi */

    case 259:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5276; /* pred_indexed_ustorervvm2dirvvmf4qi */

    case 260:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5284; /* pred_indexed_ustorervvmf2bfrvvmf4qi */

    case 261:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5292; /* pred_indexed_ustorervvmf2hfrvvmf4qi */

    case 262:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5300; /* pred_indexed_ustorervvm1sfrvvmf4qi */

    case 263:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5308; /* pred_indexed_ustorervvm2dfrvvmf4qi */

    case 264:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23686; /* pred_indexed_ustorervvmf4x2qirvvmf4qi */

    case 265:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23688; /* pred_indexed_ustorervvmf4x3qirvvmf4qi */

    case 266:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23690; /* pred_indexed_ustorervvmf4x4qirvvmf4qi */

    case 267:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23692; /* pred_indexed_ustorervvmf4x5qirvvmf4qi */

    case 268:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23694; /* pred_indexed_ustorervvmf4x6qirvvmf4qi */

    case 269:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23696; /* pred_indexed_ustorervvmf4x7qirvvmf4qi */

    case 270:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23698; /* pred_indexed_ustorervvmf4x8qirvvmf4qi */

    case 271:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23700; /* pred_indexed_ustorervvmf2x2hirvvmf4qi */

    case 272:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23702; /* pred_indexed_ustorervvmf2x3hirvvmf4qi */

    case 273:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23704; /* pred_indexed_ustorervvmf2x4hirvvmf4qi */

    case 274:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23706; /* pred_indexed_ustorervvmf2x5hirvvmf4qi */

    case 275:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23708; /* pred_indexed_ustorervvmf2x6hirvvmf4qi */

    case 276:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23710; /* pred_indexed_ustorervvmf2x7hirvvmf4qi */

    case 277:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23712; /* pred_indexed_ustorervvmf2x8hirvvmf4qi */

    case 278:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23714; /* pred_indexed_ustorervvm1x2sirvvmf4qi */

    case 279:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23716; /* pred_indexed_ustorervvm1x3sirvvmf4qi */

    case 280:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23718; /* pred_indexed_ustorervvm1x4sirvvmf4qi */

    case 281:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23720; /* pred_indexed_ustorervvm1x5sirvvmf4qi */

    case 282:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23722; /* pred_indexed_ustorervvm1x6sirvvmf4qi */

    case 283:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23724; /* pred_indexed_ustorervvm1x7sirvvmf4qi */

    case 284:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23726; /* pred_indexed_ustorervvm1x8sirvvmf4qi */

    case 285:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23728; /* pred_indexed_ustorervvm2x2dirvvmf4qi */

    case 286:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23730; /* pred_indexed_ustorervvm2x3dirvvmf4qi */

    case 287:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23732; /* pred_indexed_ustorervvm2x4dirvvmf4qi */

    case 288:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23734; /* pred_indexed_ustorervvmf2x2bfrvvmf4qi */

    case 289:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23736; /* pred_indexed_ustorervvmf2x3bfrvvmf4qi */

    case 290:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23738; /* pred_indexed_ustorervvmf2x4bfrvvmf4qi */

    case 291:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23740; /* pred_indexed_ustorervvmf2x5bfrvvmf4qi */

    case 292:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23742; /* pred_indexed_ustorervvmf2x6bfrvvmf4qi */

    case 293:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23744; /* pred_indexed_ustorervvmf2x7bfrvvmf4qi */

    case 294:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23746; /* pred_indexed_ustorervvmf2x8bfrvvmf4qi */

    case 295:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23748; /* pred_indexed_ustorervvmf2x2hfrvvmf4qi */

    case 296:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23750; /* pred_indexed_ustorervvmf2x3hfrvvmf4qi */

    case 297:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23752; /* pred_indexed_ustorervvmf2x4hfrvvmf4qi */

    case 298:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23754; /* pred_indexed_ustorervvmf2x5hfrvvmf4qi */

    case 299:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23756; /* pred_indexed_ustorervvmf2x6hfrvvmf4qi */

    case 300:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23758; /* pred_indexed_ustorervvmf2x7hfrvvmf4qi */

    case 301:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23760; /* pred_indexed_ustorervvmf2x8hfrvvmf4qi */

    case 302:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23762; /* pred_indexed_ustorervvm1x2sfrvvmf4qi */

    case 303:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23764; /* pred_indexed_ustorervvm1x3sfrvvmf4qi */

    case 304:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23766; /* pred_indexed_ustorervvm1x4sfrvvmf4qi */

    case 305:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23768; /* pred_indexed_ustorervvm1x5sfrvvmf4qi */

    case 306:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23770; /* pred_indexed_ustorervvm1x6sfrvvmf4qi */

    case 307:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23772; /* pred_indexed_ustorervvm1x7sfrvvmf4qi */

    case 308:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23774; /* pred_indexed_ustorervvm1x8sfrvvmf4qi */

    case 309:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23776; /* pred_indexed_ustorervvm2x2dfrvvmf4qi */

    case 310:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23778; /* pred_indexed_ustorervvm2x3dfrvvmf4qi */

    case 311:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23780; /* pred_indexed_ustorervvm2x4dfrvvmf4qi */

    case 312:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5254; /* pred_indexed_ustorervvmf4qirvvmf2hi */

    case 313:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5262; /* pred_indexed_ustorervvmf2hirvvmf2hi */

    case 314:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5270; /* pred_indexed_ustorervvm1sirvvmf2hi */

    case 315:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5278; /* pred_indexed_ustorervvm2dirvvmf2hi */

    case 316:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5286; /* pred_indexed_ustorervvmf2bfrvvmf2hi */

    case 317:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5294; /* pred_indexed_ustorervvmf2hfrvvmf2hi */

    case 318:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5302; /* pred_indexed_ustorervvm1sfrvvmf2hi */

    case 319:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5310; /* pred_indexed_ustorervvm2dfrvvmf2hi */

    case 320:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23782; /* pred_indexed_ustorervvmf4x2qirvvmf2hi */

    case 321:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23784; /* pred_indexed_ustorervvmf4x3qirvvmf2hi */

    case 322:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23786; /* pred_indexed_ustorervvmf4x4qirvvmf2hi */

    case 323:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23788; /* pred_indexed_ustorervvmf4x5qirvvmf2hi */

    case 324:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23790; /* pred_indexed_ustorervvmf4x6qirvvmf2hi */

    case 325:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23792; /* pred_indexed_ustorervvmf4x7qirvvmf2hi */

    case 326:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23794; /* pred_indexed_ustorervvmf4x8qirvvmf2hi */

    case 327:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23796; /* pred_indexed_ustorervvmf2x2hirvvmf2hi */

    case 328:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23798; /* pred_indexed_ustorervvmf2x3hirvvmf2hi */

    case 329:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23800; /* pred_indexed_ustorervvmf2x4hirvvmf2hi */

    case 330:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23802; /* pred_indexed_ustorervvmf2x5hirvvmf2hi */

    case 331:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23804; /* pred_indexed_ustorervvmf2x6hirvvmf2hi */

    case 332:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23806; /* pred_indexed_ustorervvmf2x7hirvvmf2hi */

    case 333:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23808; /* pred_indexed_ustorervvmf2x8hirvvmf2hi */

    case 334:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23810; /* pred_indexed_ustorervvm1x2sirvvmf2hi */

    case 335:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23812; /* pred_indexed_ustorervvm1x3sirvvmf2hi */

    case 336:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23814; /* pred_indexed_ustorervvm1x4sirvvmf2hi */

    case 337:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23816; /* pred_indexed_ustorervvm1x5sirvvmf2hi */

    case 338:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23818; /* pred_indexed_ustorervvm1x6sirvvmf2hi */

    case 339:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23820; /* pred_indexed_ustorervvm1x7sirvvmf2hi */

    case 340:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23822; /* pred_indexed_ustorervvm1x8sirvvmf2hi */

    case 341:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23824; /* pred_indexed_ustorervvm2x2dirvvmf2hi */

    case 342:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23826; /* pred_indexed_ustorervvm2x3dirvvmf2hi */

    case 343:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23828; /* pred_indexed_ustorervvm2x4dirvvmf2hi */

    case 344:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23830; /* pred_indexed_ustorervvmf2x2bfrvvmf2hi */

    case 345:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23832; /* pred_indexed_ustorervvmf2x3bfrvvmf2hi */

    case 346:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23834; /* pred_indexed_ustorervvmf2x4bfrvvmf2hi */

    case 347:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23836; /* pred_indexed_ustorervvmf2x5bfrvvmf2hi */

    case 348:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23838; /* pred_indexed_ustorervvmf2x6bfrvvmf2hi */

    case 349:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23840; /* pred_indexed_ustorervvmf2x7bfrvvmf2hi */

    case 350:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23842; /* pred_indexed_ustorervvmf2x8bfrvvmf2hi */

    case 351:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23844; /* pred_indexed_ustorervvmf2x2hfrvvmf2hi */

    case 352:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23846; /* pred_indexed_ustorervvmf2x3hfrvvmf2hi */

    case 353:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23848; /* pred_indexed_ustorervvmf2x4hfrvvmf2hi */

    case 354:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23850; /* pred_indexed_ustorervvmf2x5hfrvvmf2hi */

    case 355:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23852; /* pred_indexed_ustorervvmf2x6hfrvvmf2hi */

    case 356:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23854; /* pred_indexed_ustorervvmf2x7hfrvvmf2hi */

    case 357:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23856; /* pred_indexed_ustorervvmf2x8hfrvvmf2hi */

    case 358:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23858; /* pred_indexed_ustorervvm1x2sfrvvmf2hi */

    case 359:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23860; /* pred_indexed_ustorervvm1x3sfrvvmf2hi */

    case 360:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23862; /* pred_indexed_ustorervvm1x4sfrvvmf2hi */

    case 361:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23864; /* pred_indexed_ustorervvm1x5sfrvvmf2hi */

    case 362:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23866; /* pred_indexed_ustorervvm1x6sfrvvmf2hi */

    case 363:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23868; /* pred_indexed_ustorervvm1x7sfrvvmf2hi */

    case 364:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23870; /* pred_indexed_ustorervvm1x8sfrvvmf2hi */

    case 365:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23872; /* pred_indexed_ustorervvm2x2dfrvvmf2hi */

    case 366:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23874; /* pred_indexed_ustorervvm2x3dfrvvmf2hi */

    case 367:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23876; /* pred_indexed_ustorervvm2x4dfrvvmf2hi */

    case 368:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5256; /* pred_indexed_ustorervvmf4qirvvm1si */

    case 369:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5264; /* pred_indexed_ustorervvmf2hirvvm1si */

    case 370:
      if (!
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5272; /* pred_indexed_ustorervvm1sirvvm1si */

    case 371:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5280; /* pred_indexed_ustorervvm2dirvvm1si */

    case 372:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5288; /* pred_indexed_ustorervvmf2bfrvvm1si */

    case 373:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5296; /* pred_indexed_ustorervvmf2hfrvvm1si */

    case 374:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5304; /* pred_indexed_ustorervvm1sfrvvm1si */

    case 375:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5312; /* pred_indexed_ustorervvm2dfrvvm1si */

    case 376:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23878; /* pred_indexed_ustorervvmf4x2qirvvm1si */

    case 377:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23880; /* pred_indexed_ustorervvmf4x3qirvvm1si */

    case 378:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23882; /* pred_indexed_ustorervvmf4x4qirvvm1si */

    case 379:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23884; /* pred_indexed_ustorervvmf4x5qirvvm1si */

    case 380:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23886; /* pred_indexed_ustorervvmf4x6qirvvm1si */

    case 381:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23888; /* pred_indexed_ustorervvmf4x7qirvvm1si */

    case 382:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23890; /* pred_indexed_ustorervvmf4x8qirvvm1si */

    case 383:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23892; /* pred_indexed_ustorervvmf2x2hirvvm1si */

    case 384:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23894; /* pred_indexed_ustorervvmf2x3hirvvm1si */

    case 385:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23896; /* pred_indexed_ustorervvmf2x4hirvvm1si */

    case 386:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23898; /* pred_indexed_ustorervvmf2x5hirvvm1si */

    case 387:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23900; /* pred_indexed_ustorervvmf2x6hirvvm1si */

    case 388:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23902; /* pred_indexed_ustorervvmf2x7hirvvm1si */

    case 389:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23904; /* pred_indexed_ustorervvmf2x8hirvvm1si */

    case 390:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23906; /* pred_indexed_ustorervvm1x2sirvvm1si */

    case 391:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23908; /* pred_indexed_ustorervvm1x3sirvvm1si */

    case 392:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23910; /* pred_indexed_ustorervvm1x4sirvvm1si */

    case 393:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23912; /* pred_indexed_ustorervvm1x5sirvvm1si */

    case 394:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23914; /* pred_indexed_ustorervvm1x6sirvvm1si */

    case 395:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23916; /* pred_indexed_ustorervvm1x7sirvvm1si */

    case 396:
      if (!
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23918; /* pred_indexed_ustorervvm1x8sirvvm1si */

    case 397:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23920; /* pred_indexed_ustorervvm2x2dirvvm1si */

    case 398:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23922; /* pred_indexed_ustorervvm2x3dirvvm1si */

    case 399:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23924; /* pred_indexed_ustorervvm2x4dirvvm1si */

    case 400:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23926; /* pred_indexed_ustorervvmf2x2bfrvvm1si */

    case 401:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23928; /* pred_indexed_ustorervvmf2x3bfrvvm1si */

    case 402:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23930; /* pred_indexed_ustorervvmf2x4bfrvvm1si */

    case 403:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23932; /* pred_indexed_ustorervvmf2x5bfrvvm1si */

    case 404:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23934; /* pred_indexed_ustorervvmf2x6bfrvvm1si */

    case 405:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23936; /* pred_indexed_ustorervvmf2x7bfrvvm1si */

    case 406:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23938; /* pred_indexed_ustorervvmf2x8bfrvvm1si */

    case 407:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23940; /* pred_indexed_ustorervvmf2x2hfrvvm1si */

    case 408:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23942; /* pred_indexed_ustorervvmf2x3hfrvvm1si */

    case 409:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23944; /* pred_indexed_ustorervvmf2x4hfrvvm1si */

    case 410:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23946; /* pred_indexed_ustorervvmf2x5hfrvvm1si */

    case 411:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23948; /* pred_indexed_ustorervvmf2x6hfrvvm1si */

    case 412:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23950; /* pred_indexed_ustorervvmf2x7hfrvvm1si */

    case 413:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23952; /* pred_indexed_ustorervvmf2x8hfrvvm1si */

    case 414:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23954; /* pred_indexed_ustorervvm1x2sfrvvm1si */

    case 415:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23956; /* pred_indexed_ustorervvm1x3sfrvvm1si */

    case 416:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23958; /* pred_indexed_ustorervvm1x4sfrvvm1si */

    case 417:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23960; /* pred_indexed_ustorervvm1x5sfrvvm1si */

    case 418:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23962; /* pred_indexed_ustorervvm1x6sfrvvm1si */

    case 419:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23964; /* pred_indexed_ustorervvm1x7sfrvvm1si */

    case 420:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23966; /* pred_indexed_ustorervvm1x8sfrvvm1si */

    case 421:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23968; /* pred_indexed_ustorervvm2x2dfrvvm1si */

    case 422:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23970; /* pred_indexed_ustorervvm2x3dfrvvm1si */

    case 423:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23972; /* pred_indexed_ustorervvm2x4dfrvvm1si */

    case 424:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5258; /* pred_indexed_ustorervvmf4qirvvm2di */

    case 425:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5266; /* pred_indexed_ustorervvmf2hirvvm2di */

    case 426:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5274; /* pred_indexed_ustorervvm1sirvvm2di */

    case 427:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 820 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5282; /* pred_indexed_ustorervvm2dirvvm2di */

    case 428:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 821 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5290; /* pred_indexed_ustorervvmf2bfrvvm2di */

    case 429:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 822 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5298; /* pred_indexed_ustorervvmf2hfrvvm2di */

    case 430:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5306; /* pred_indexed_ustorervvm1sfrvvm2di */

    case 431:
      if (!(
#line 2605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 824 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5314; /* pred_indexed_ustorervvm2dfrvvm2di */

    case 432:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23974; /* pred_indexed_ustorervvmf4x2qirvvm2di */

    case 433:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23976; /* pred_indexed_ustorervvmf4x3qirvvm2di */

    case 434:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23978; /* pred_indexed_ustorervvmf4x4qirvvm2di */

    case 435:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23980; /* pred_indexed_ustorervvmf4x5qirvvm2di */

    case 436:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23982; /* pred_indexed_ustorervvmf4x6qirvvm2di */

    case 437:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23984; /* pred_indexed_ustorervvmf4x7qirvvm2di */

    case 438:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23986; /* pred_indexed_ustorervvmf4x8qirvvm2di */

    case 439:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23988; /* pred_indexed_ustorervvmf2x2hirvvm2di */

    case 440:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23990; /* pred_indexed_ustorervvmf2x3hirvvm2di */

    case 441:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23992; /* pred_indexed_ustorervvmf2x4hirvvm2di */

    case 442:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23994; /* pred_indexed_ustorervvmf2x5hirvvm2di */

    case 443:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23996; /* pred_indexed_ustorervvmf2x6hirvvm2di */

    case 444:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23998; /* pred_indexed_ustorervvmf2x7hirvvm2di */

    case 445:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24000; /* pred_indexed_ustorervvmf2x8hirvvm2di */

    case 446:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24002; /* pred_indexed_ustorervvm1x2sirvvm2di */

    case 447:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24004; /* pred_indexed_ustorervvm1x3sirvvm2di */

    case 448:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24006; /* pred_indexed_ustorervvm1x4sirvvm2di */

    case 449:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24008; /* pred_indexed_ustorervvm1x5sirvvm2di */

    case 450:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24010; /* pred_indexed_ustorervvm1x6sirvvm2di */

    case 451:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24012; /* pred_indexed_ustorervvm1x7sirvvm2di */

    case 452:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24014; /* pred_indexed_ustorervvm1x8sirvvm2di */

    case 453:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24016; /* pred_indexed_ustorervvm2x2dirvvm2di */

    case 454:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24018; /* pred_indexed_ustorervvm2x3dirvvm2di */

    case 455:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24020; /* pred_indexed_ustorervvm2x4dirvvm2di */

    case 456:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24022; /* pred_indexed_ustorervvmf2x2bfrvvm2di */

    case 457:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24024; /* pred_indexed_ustorervvmf2x3bfrvvm2di */

    case 458:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24026; /* pred_indexed_ustorervvmf2x4bfrvvm2di */

    case 459:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24028; /* pred_indexed_ustorervvmf2x5bfrvvm2di */

    case 460:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24030; /* pred_indexed_ustorervvmf2x6bfrvvm2di */

    case 461:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24032; /* pred_indexed_ustorervvmf2x7bfrvvm2di */

    case 462:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24034; /* pred_indexed_ustorervvmf2x8bfrvvm2di */

    case 463:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24036; /* pred_indexed_ustorervvmf2x2hfrvvm2di */

    case 464:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24038; /* pred_indexed_ustorervvmf2x3hfrvvm2di */

    case 465:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24040; /* pred_indexed_ustorervvmf2x4hfrvvm2di */

    case 466:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24042; /* pred_indexed_ustorervvmf2x5hfrvvm2di */

    case 467:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24044; /* pred_indexed_ustorervvmf2x6hfrvvm2di */

    case 468:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24046; /* pred_indexed_ustorervvmf2x7hfrvvm2di */

    case 469:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24048; /* pred_indexed_ustorervvmf2x8hfrvvm2di */

    case 470:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24050; /* pred_indexed_ustorervvm1x2sfrvvm2di */

    case 471:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24052; /* pred_indexed_ustorervvm1x3sfrvvm2di */

    case 472:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24054; /* pred_indexed_ustorervvm1x4sfrvvm2di */

    case 473:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24056; /* pred_indexed_ustorervvm1x5sfrvvm2di */

    case 474:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24058; /* pred_indexed_ustorervvm1x6sfrvvm2di */

    case 475:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24060; /* pred_indexed_ustorervvm1x7sfrvvm2di */

    case 476:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24062; /* pred_indexed_ustorervvm1x8sfrvvm2di */

    case 477:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24064; /* pred_indexed_ustorervvm2x2dfrvvm2di */

    case 478:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24066; /* pred_indexed_ustorervvm2x3dfrvvm2di */

    case 479:
      if (!(
#line 8626 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24068; /* pred_indexed_ustorervvm2x4dfrvvm2di */

    case 480:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5316; /* pred_indexed_ustorervvmf2qirvvmf2qi */

    case 481:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5318; /* pred_indexed_ustorervvm1hirvvmf2qi */

    case 482:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5320; /* pred_indexed_ustorervvm2sirvvmf2qi */

    case 483:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5322; /* pred_indexed_ustorervvm4dirvvmf2qi */

    case 484:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5324; /* pred_indexed_ustorervvm1bfrvvmf2qi */

    case 485:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5326; /* pred_indexed_ustorervvm1hfrvvmf2qi */

    case 486:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5328; /* pred_indexed_ustorervvm2sfrvvmf2qi */

    case 487:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5330; /* pred_indexed_ustorervvm4dfrvvmf2qi */

    case 488:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24070; /* pred_indexed_ustorervvmf2x2qirvvmf2qi */

    case 489:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24072; /* pred_indexed_ustorervvmf2x3qirvvmf2qi */

    case 490:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24074; /* pred_indexed_ustorervvmf2x4qirvvmf2qi */

    case 491:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24076; /* pred_indexed_ustorervvmf2x5qirvvmf2qi */

    case 492:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24078; /* pred_indexed_ustorervvmf2x6qirvvmf2qi */

    case 493:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24080; /* pred_indexed_ustorervvmf2x7qirvvmf2qi */

    case 494:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24082; /* pred_indexed_ustorervvmf2x8qirvvmf2qi */

    case 495:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24084; /* pred_indexed_ustorervvm1x2hirvvmf2qi */

    case 496:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24086; /* pred_indexed_ustorervvm1x3hirvvmf2qi */

    case 497:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24088; /* pred_indexed_ustorervvm1x4hirvvmf2qi */

    case 498:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24090; /* pred_indexed_ustorervvm1x5hirvvmf2qi */

    case 499:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24092; /* pred_indexed_ustorervvm1x6hirvvmf2qi */

    case 500:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24094; /* pred_indexed_ustorervvm1x7hirvvmf2qi */

    case 501:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24096; /* pred_indexed_ustorervvm1x8hirvvmf2qi */

    case 502:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24098; /* pred_indexed_ustorervvm2x2sirvvmf2qi */

    case 503:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24100; /* pred_indexed_ustorervvm2x3sirvvmf2qi */

    case 504:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24102; /* pred_indexed_ustorervvm2x4sirvvmf2qi */

    case 505:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24104; /* pred_indexed_ustorervvm4x2dirvvmf2qi */

    case 506:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24106; /* pred_indexed_ustorervvm1x2bfrvvmf2qi */

    case 507:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24108; /* pred_indexed_ustorervvm1x3bfrvvmf2qi */

    case 508:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24110; /* pred_indexed_ustorervvm1x4bfrvvmf2qi */

    case 509:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24112; /* pred_indexed_ustorervvm1x5bfrvvmf2qi */

    case 510:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24114; /* pred_indexed_ustorervvm1x6bfrvvmf2qi */

    case 511:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24116; /* pred_indexed_ustorervvm1x7bfrvvmf2qi */

    case 512:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24118; /* pred_indexed_ustorervvm1x8bfrvvmf2qi */

    case 513:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24120; /* pred_indexed_ustorervvm1x2hfrvvmf2qi */

    case 514:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24122; /* pred_indexed_ustorervvm1x3hfrvvmf2qi */

    case 515:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24124; /* pred_indexed_ustorervvm1x4hfrvvmf2qi */

    case 516:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24126; /* pred_indexed_ustorervvm1x5hfrvvmf2qi */

    case 517:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24128; /* pred_indexed_ustorervvm1x6hfrvvmf2qi */

    case 518:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24130; /* pred_indexed_ustorervvm1x7hfrvvmf2qi */

    case 519:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24132; /* pred_indexed_ustorervvm1x8hfrvvmf2qi */

    case 520:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24134; /* pred_indexed_ustorervvm2x2sfrvvmf2qi */

    case 521:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24136; /* pred_indexed_ustorervvm2x3sfrvvmf2qi */

    case 522:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24138; /* pred_indexed_ustorervvm2x4sfrvvmf2qi */

    case 523:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24140; /* pred_indexed_ustorervvm4x2dfrvvmf2qi */

    case 524:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5332; /* pred_indexed_ustorervvmf2qirvvm1hi */

    case 525:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5334; /* pred_indexed_ustorervvm1hirvvm1hi */

    case 526:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5336; /* pred_indexed_ustorervvm2sirvvm1hi */

    case 527:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5338; /* pred_indexed_ustorervvm4dirvvm1hi */

    case 528:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5340; /* pred_indexed_ustorervvm1bfrvvm1hi */

    case 529:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5342; /* pred_indexed_ustorervvm1hfrvvm1hi */

    case 530:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5344; /* pred_indexed_ustorervvm2sfrvvm1hi */

    case 531:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5346; /* pred_indexed_ustorervvm4dfrvvm1hi */

    case 532:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24142; /* pred_indexed_ustorervvmf2x2qirvvm1hi */

    case 533:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24144; /* pred_indexed_ustorervvmf2x3qirvvm1hi */

    case 534:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24146; /* pred_indexed_ustorervvmf2x4qirvvm1hi */

    case 535:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24148; /* pred_indexed_ustorervvmf2x5qirvvm1hi */

    case 536:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24150; /* pred_indexed_ustorervvmf2x6qirvvm1hi */

    case 537:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24152; /* pred_indexed_ustorervvmf2x7qirvvm1hi */

    case 538:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24154; /* pred_indexed_ustorervvmf2x8qirvvm1hi */

    case 539:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24156; /* pred_indexed_ustorervvm1x2hirvvm1hi */

    case 540:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24158; /* pred_indexed_ustorervvm1x3hirvvm1hi */

    case 541:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24160; /* pred_indexed_ustorervvm1x4hirvvm1hi */

    case 542:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24162; /* pred_indexed_ustorervvm1x5hirvvm1hi */

    case 543:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24164; /* pred_indexed_ustorervvm1x6hirvvm1hi */

    case 544:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24166; /* pred_indexed_ustorervvm1x7hirvvm1hi */

    case 545:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24168; /* pred_indexed_ustorervvm1x8hirvvm1hi */

    case 546:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24170; /* pred_indexed_ustorervvm2x2sirvvm1hi */

    case 547:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24172; /* pred_indexed_ustorervvm2x3sirvvm1hi */

    case 548:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24174; /* pred_indexed_ustorervvm2x4sirvvm1hi */

    case 549:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24176; /* pred_indexed_ustorervvm4x2dirvvm1hi */

    case 550:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24178; /* pred_indexed_ustorervvm1x2bfrvvm1hi */

    case 551:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24180; /* pred_indexed_ustorervvm1x3bfrvvm1hi */

    case 552:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24182; /* pred_indexed_ustorervvm1x4bfrvvm1hi */

    case 553:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24184; /* pred_indexed_ustorervvm1x5bfrvvm1hi */

    case 554:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24186; /* pred_indexed_ustorervvm1x6bfrvvm1hi */

    case 555:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24188; /* pred_indexed_ustorervvm1x7bfrvvm1hi */

    case 556:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24190; /* pred_indexed_ustorervvm1x8bfrvvm1hi */

    case 557:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24192; /* pred_indexed_ustorervvm1x2hfrvvm1hi */

    case 558:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24194; /* pred_indexed_ustorervvm1x3hfrvvm1hi */

    case 559:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24196; /* pred_indexed_ustorervvm1x4hfrvvm1hi */

    case 560:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24198; /* pred_indexed_ustorervvm1x5hfrvvm1hi */

    case 561:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24200; /* pred_indexed_ustorervvm1x6hfrvvm1hi */

    case 562:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24202; /* pred_indexed_ustorervvm1x7hfrvvm1hi */

    case 563:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24204; /* pred_indexed_ustorervvm1x8hfrvvm1hi */

    case 564:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24206; /* pred_indexed_ustorervvm2x2sfrvvm1hi */

    case 565:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24208; /* pred_indexed_ustorervvm2x3sfrvvm1hi */

    case 566:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24210; /* pred_indexed_ustorervvm2x4sfrvvm1hi */

    case 567:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24212; /* pred_indexed_ustorervvm4x2dfrvvm1hi */

    case 568:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5348; /* pred_indexed_ustorervvmf2qirvvm2si */

    case 569:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5350; /* pred_indexed_ustorervvm1hirvvm2si */

    case 570:
      if (!
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5352; /* pred_indexed_ustorervvm2sirvvm2si */

    case 571:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5354; /* pred_indexed_ustorervvm4dirvvm2si */

    case 572:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5356; /* pred_indexed_ustorervvm1bfrvvm2si */

    case 573:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5358; /* pred_indexed_ustorervvm1hfrvvm2si */

    case 574:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5360; /* pred_indexed_ustorervvm2sfrvvm2si */

    case 575:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5362; /* pred_indexed_ustorervvm4dfrvvm2si */

    case 576:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24214; /* pred_indexed_ustorervvmf2x2qirvvm2si */

    case 577:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24216; /* pred_indexed_ustorervvmf2x3qirvvm2si */

    case 578:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24218; /* pred_indexed_ustorervvmf2x4qirvvm2si */

    case 579:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24220; /* pred_indexed_ustorervvmf2x5qirvvm2si */

    case 580:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24222; /* pred_indexed_ustorervvmf2x6qirvvm2si */

    case 581:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24224; /* pred_indexed_ustorervvmf2x7qirvvm2si */

    case 582:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24226; /* pred_indexed_ustorervvmf2x8qirvvm2si */

    case 583:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24228; /* pred_indexed_ustorervvm1x2hirvvm2si */

    case 584:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24230; /* pred_indexed_ustorervvm1x3hirvvm2si */

    case 585:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24232; /* pred_indexed_ustorervvm1x4hirvvm2si */

    case 586:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24234; /* pred_indexed_ustorervvm1x5hirvvm2si */

    case 587:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24236; /* pred_indexed_ustorervvm1x6hirvvm2si */

    case 588:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24238; /* pred_indexed_ustorervvm1x7hirvvm2si */

    case 589:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24240; /* pred_indexed_ustorervvm1x8hirvvm2si */

    case 590:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24242; /* pred_indexed_ustorervvm2x2sirvvm2si */

    case 591:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24244; /* pred_indexed_ustorervvm2x3sirvvm2si */

    case 592:
      if (!
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24246; /* pred_indexed_ustorervvm2x4sirvvm2si */

    case 593:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24248; /* pred_indexed_ustorervvm4x2dirvvm2si */

    case 594:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24250; /* pred_indexed_ustorervvm1x2bfrvvm2si */

    case 595:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24252; /* pred_indexed_ustorervvm1x3bfrvvm2si */

    case 596:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24254; /* pred_indexed_ustorervvm1x4bfrvvm2si */

    case 597:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24256; /* pred_indexed_ustorervvm1x5bfrvvm2si */

    case 598:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24258; /* pred_indexed_ustorervvm1x6bfrvvm2si */

    case 599:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24260; /* pred_indexed_ustorervvm1x7bfrvvm2si */

    case 600:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24262; /* pred_indexed_ustorervvm1x8bfrvvm2si */

    case 601:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24264; /* pred_indexed_ustorervvm1x2hfrvvm2si */

    case 602:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24266; /* pred_indexed_ustorervvm1x3hfrvvm2si */

    case 603:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24268; /* pred_indexed_ustorervvm1x4hfrvvm2si */

    case 604:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24270; /* pred_indexed_ustorervvm1x5hfrvvm2si */

    case 605:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24272; /* pred_indexed_ustorervvm1x6hfrvvm2si */

    case 606:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24274; /* pred_indexed_ustorervvm1x7hfrvvm2si */

    case 607:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24276; /* pred_indexed_ustorervvm1x8hfrvvm2si */

    case 608:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24278; /* pred_indexed_ustorervvm2x2sfrvvm2si */

    case 609:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24280; /* pred_indexed_ustorervvm2x3sfrvvm2si */

    case 610:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24282; /* pred_indexed_ustorervvm2x4sfrvvm2si */

    case 611:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24284; /* pred_indexed_ustorervvm4x2dfrvvm2si */

    case 612:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5364; /* pred_indexed_ustorervvmf2qirvvm4di */

    case 613:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5366; /* pred_indexed_ustorervvm1hirvvm4di */

    case 614:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5368; /* pred_indexed_ustorervvm2sirvvm4di */

    case 615:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 831 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5370; /* pred_indexed_ustorervvm4dirvvm4di */

    case 616:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 832 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5372; /* pred_indexed_ustorervvm1bfrvvm4di */

    case 617:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 833 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5374; /* pred_indexed_ustorervvm1hfrvvm4di */

    case 618:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 834 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5376; /* pred_indexed_ustorervvm2sfrvvm4di */

    case 619:
      if (!(
#line 2622 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 835 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5378; /* pred_indexed_ustorervvm4dfrvvm4di */

    case 620:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24286; /* pred_indexed_ustorervvmf2x2qirvvm4di */

    case 621:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24288; /* pred_indexed_ustorervvmf2x3qirvvm4di */

    case 622:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24290; /* pred_indexed_ustorervvmf2x4qirvvm4di */

    case 623:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24292; /* pred_indexed_ustorervvmf2x5qirvvm4di */

    case 624:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24294; /* pred_indexed_ustorervvmf2x6qirvvm4di */

    case 625:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24296; /* pred_indexed_ustorervvmf2x7qirvvm4di */

    case 626:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24298; /* pred_indexed_ustorervvmf2x8qirvvm4di */

    case 627:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24300; /* pred_indexed_ustorervvm1x2hirvvm4di */

    case 628:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24302; /* pred_indexed_ustorervvm1x3hirvvm4di */

    case 629:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24304; /* pred_indexed_ustorervvm1x4hirvvm4di */

    case 630:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24306; /* pred_indexed_ustorervvm1x5hirvvm4di */

    case 631:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24308; /* pred_indexed_ustorervvm1x6hirvvm4di */

    case 632:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24310; /* pred_indexed_ustorervvm1x7hirvvm4di */

    case 633:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24312; /* pred_indexed_ustorervvm1x8hirvvm4di */

    case 634:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24314; /* pred_indexed_ustorervvm2x2sirvvm4di */

    case 635:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24316; /* pred_indexed_ustorervvm2x3sirvvm4di */

    case 636:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24318; /* pred_indexed_ustorervvm2x4sirvvm4di */

    case 637:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24320; /* pred_indexed_ustorervvm4x2dirvvm4di */

    case 638:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24322; /* pred_indexed_ustorervvm1x2bfrvvm4di */

    case 639:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24324; /* pred_indexed_ustorervvm1x3bfrvvm4di */

    case 640:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24326; /* pred_indexed_ustorervvm1x4bfrvvm4di */

    case 641:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24328; /* pred_indexed_ustorervvm1x5bfrvvm4di */

    case 642:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24330; /* pred_indexed_ustorervvm1x6bfrvvm4di */

    case 643:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24332; /* pred_indexed_ustorervvm1x7bfrvvm4di */

    case 644:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24334; /* pred_indexed_ustorervvm1x8bfrvvm4di */

    case 645:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24336; /* pred_indexed_ustorervvm1x2hfrvvm4di */

    case 646:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24338; /* pred_indexed_ustorervvm1x3hfrvvm4di */

    case 647:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24340; /* pred_indexed_ustorervvm1x4hfrvvm4di */

    case 648:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24342; /* pred_indexed_ustorervvm1x5hfrvvm4di */

    case 649:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24344; /* pred_indexed_ustorervvm1x6hfrvvm4di */

    case 650:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24346; /* pred_indexed_ustorervvm1x7hfrvvm4di */

    case 651:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24348; /* pred_indexed_ustorervvm1x8hfrvvm4di */

    case 652:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24350; /* pred_indexed_ustorervvm2x2sfrvvm4di */

    case 653:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24352; /* pred_indexed_ustorervvm2x3sfrvvm4di */

    case 654:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24354; /* pred_indexed_ustorervvm2x4sfrvvm4di */

    case 655:
      if (!(
#line 8643 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24356; /* pred_indexed_ustorervvm4x2dfrvvm4di */

    case 656:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5380; /* pred_indexed_ustorervvm1qirvvm1qi */

    case 657:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5382; /* pred_indexed_ustorervvm2hirvvm1qi */

    case 658:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5384; /* pred_indexed_ustorervvm4sirvvm1qi */

    case 659:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5386; /* pred_indexed_ustorervvm8dirvvm1qi */

    case 660:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5388; /* pred_indexed_ustorervvm2bfrvvm1qi */

    case 661:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5390; /* pred_indexed_ustorervvm2hfrvvm1qi */

    case 662:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5392; /* pred_indexed_ustorervvm4sfrvvm1qi */

    case 663:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5394; /* pred_indexed_ustorervvm8dfrvvm1qi */

    case 664:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24358; /* pred_indexed_ustorervvm1x2qirvvm1qi */

    case 665:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24366; /* pred_indexed_ustorervvm1x3qirvvm1qi */

    case 666:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24374; /* pred_indexed_ustorervvm1x4qirvvm1qi */

    case 667:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24382; /* pred_indexed_ustorervvm1x5qirvvm1qi */

    case 668:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24390; /* pred_indexed_ustorervvm1x6qirvvm1qi */

    case 669:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24398; /* pred_indexed_ustorervvm1x7qirvvm1qi */

    case 670:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24406; /* pred_indexed_ustorervvm1x8qirvvm1qi */

    case 671:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24414; /* pred_indexed_ustorervvm2x2hirvvm1qi */

    case 672:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24422; /* pred_indexed_ustorervvm2x3hirvvm1qi */

    case 673:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24430; /* pred_indexed_ustorervvm2x4hirvvm1qi */

    case 674:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24438; /* pred_indexed_ustorervvm4x2sirvvm1qi */

    case 675:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24446; /* pred_indexed_ustorervvm2x2bfrvvm1qi */

    case 676:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24454; /* pred_indexed_ustorervvm2x3bfrvvm1qi */

    case 677:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24462; /* pred_indexed_ustorervvm2x4bfrvvm1qi */

    case 678:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24470; /* pred_indexed_ustorervvm2x2hfrvvm1qi */

    case 679:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24478; /* pred_indexed_ustorervvm2x3hfrvvm1qi */

    case 680:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24486; /* pred_indexed_ustorervvm2x4hfrvvm1qi */

    case 681:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24494; /* pred_indexed_ustorervvm4x2sfrvvm1qi */

    case 682:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5396; /* pred_indexed_ustorervvm1qirvvm2hi */

    case 683:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5398; /* pred_indexed_ustorervvm2hirvvm2hi */

    case 684:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5400; /* pred_indexed_ustorervvm4sirvvm2hi */

    case 685:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5402; /* pred_indexed_ustorervvm8dirvvm2hi */

    case 686:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5404; /* pred_indexed_ustorervvm2bfrvvm2hi */

    case 687:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5406; /* pred_indexed_ustorervvm2hfrvvm2hi */

    case 688:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5408; /* pred_indexed_ustorervvm4sfrvvm2hi */

    case 689:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5410; /* pred_indexed_ustorervvm8dfrvvm2hi */

    case 690:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24360; /* pred_indexed_ustorervvm1x2qirvvm2hi */

    case 691:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24368; /* pred_indexed_ustorervvm1x3qirvvm2hi */

    case 692:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24376; /* pred_indexed_ustorervvm1x4qirvvm2hi */

    case 693:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24384; /* pred_indexed_ustorervvm1x5qirvvm2hi */

    case 694:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24392; /* pred_indexed_ustorervvm1x6qirvvm2hi */

    case 695:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24400; /* pred_indexed_ustorervvm1x7qirvvm2hi */

    case 696:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24408; /* pred_indexed_ustorervvm1x8qirvvm2hi */

    case 697:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24416; /* pred_indexed_ustorervvm2x2hirvvm2hi */

    case 698:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24424; /* pred_indexed_ustorervvm2x3hirvvm2hi */

    case 699:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24432; /* pred_indexed_ustorervvm2x4hirvvm2hi */

    case 700:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24440; /* pred_indexed_ustorervvm4x2sirvvm2hi */

    case 701:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24448; /* pred_indexed_ustorervvm2x2bfrvvm2hi */

    case 702:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24456; /* pred_indexed_ustorervvm2x3bfrvvm2hi */

    case 703:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24464; /* pred_indexed_ustorervvm2x4bfrvvm2hi */

    case 704:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24472; /* pred_indexed_ustorervvm2x2hfrvvm2hi */

    case 705:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24480; /* pred_indexed_ustorervvm2x3hfrvvm2hi */

    case 706:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24488; /* pred_indexed_ustorervvm2x4hfrvvm2hi */

    case 707:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24496; /* pred_indexed_ustorervvm4x2sfrvvm2hi */

    case 708:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5412; /* pred_indexed_ustorervvm1qirvvm4si */

    case 709:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5414; /* pred_indexed_ustorervvm2hirvvm4si */

    case 710:
      if (!
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5416; /* pred_indexed_ustorervvm4sirvvm4si */

    case 711:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5418; /* pred_indexed_ustorervvm8dirvvm4si */

    case 712:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5420; /* pred_indexed_ustorervvm2bfrvvm4si */

    case 713:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5422; /* pred_indexed_ustorervvm2hfrvvm4si */

    case 714:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5424; /* pred_indexed_ustorervvm4sfrvvm4si */

    case 715:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5426; /* pred_indexed_ustorervvm8dfrvvm4si */

    case 716:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24362; /* pred_indexed_ustorervvm1x2qirvvm4si */

    case 717:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24370; /* pred_indexed_ustorervvm1x3qirvvm4si */

    case 718:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24378; /* pred_indexed_ustorervvm1x4qirvvm4si */

    case 719:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24386; /* pred_indexed_ustorervvm1x5qirvvm4si */

    case 720:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24394; /* pred_indexed_ustorervvm1x6qirvvm4si */

    case 721:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24402; /* pred_indexed_ustorervvm1x7qirvvm4si */

    case 722:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24410; /* pred_indexed_ustorervvm1x8qirvvm4si */

    case 723:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24418; /* pred_indexed_ustorervvm2x2hirvvm4si */

    case 724:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24426; /* pred_indexed_ustorervvm2x3hirvvm4si */

    case 725:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24434; /* pred_indexed_ustorervvm2x4hirvvm4si */

    case 726:
      if (!
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24442; /* pred_indexed_ustorervvm4x2sirvvm4si */

    case 727:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24450; /* pred_indexed_ustorervvm2x2bfrvvm4si */

    case 728:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24458; /* pred_indexed_ustorervvm2x3bfrvvm4si */

    case 729:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24466; /* pred_indexed_ustorervvm2x4bfrvvm4si */

    case 730:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24474; /* pred_indexed_ustorervvm2x2hfrvvm4si */

    case 731:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24482; /* pred_indexed_ustorervvm2x3hfrvvm4si */

    case 732:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24490; /* pred_indexed_ustorervvm2x4hfrvvm4si */

    case 733:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24498; /* pred_indexed_ustorervvm4x2sfrvvm4si */

    case 734:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5428; /* pred_indexed_ustorervvm1qirvvm8di */

    case 735:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5430; /* pred_indexed_ustorervvm2hirvvm8di */

    case 736:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5432; /* pred_indexed_ustorervvm4sirvvm8di */

    case 737:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 842 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5434; /* pred_indexed_ustorervvm8dirvvm8di */

    case 738:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 843 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5436; /* pred_indexed_ustorervvm2bfrvvm8di */

    case 739:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 844 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5438; /* pred_indexed_ustorervvm2hfrvvm8di */

    case 740:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 845 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5440; /* pred_indexed_ustorervvm4sfrvvm8di */

    case 741:
      if (!(
#line 2639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 846 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5442; /* pred_indexed_ustorervvm8dfrvvm8di */

    case 742:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24364; /* pred_indexed_ustorervvm1x2qirvvm8di */

    case 743:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24372; /* pred_indexed_ustorervvm1x3qirvvm8di */

    case 744:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24380; /* pred_indexed_ustorervvm1x4qirvvm8di */

    case 745:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24388; /* pred_indexed_ustorervvm1x5qirvvm8di */

    case 746:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24396; /* pred_indexed_ustorervvm1x6qirvvm8di */

    case 747:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24404; /* pred_indexed_ustorervvm1x7qirvvm8di */

    case 748:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24412; /* pred_indexed_ustorervvm1x8qirvvm8di */

    case 749:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24420; /* pred_indexed_ustorervvm2x2hirvvm8di */

    case 750:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24428; /* pred_indexed_ustorervvm2x3hirvvm8di */

    case 751:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24436; /* pred_indexed_ustorervvm2x4hirvvm8di */

    case 752:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24444; /* pred_indexed_ustorervvm4x2sirvvm8di */

    case 753:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24452; /* pred_indexed_ustorervvm2x2bfrvvm8di */

    case 754:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24460; /* pred_indexed_ustorervvm2x3bfrvvm8di */

    case 755:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24468; /* pred_indexed_ustorervvm2x4bfrvvm8di */

    case 756:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24476; /* pred_indexed_ustorervvm2x2hfrvvm8di */

    case 757:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24484; /* pred_indexed_ustorervvm2x3hfrvvm8di */

    case 758:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24492; /* pred_indexed_ustorervvm2x4hfrvvm8di */

    case 759:
      if (!(
#line 8660 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24500; /* pred_indexed_ustorervvm4x2sfrvvm8di */

    case 760:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5444; /* pred_indexed_ustorervvm2qirvvm2qi */

    case 761:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5446; /* pred_indexed_ustorervvm4hirvvm2qi */

    case 762:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5448; /* pred_indexed_ustorervvm8sirvvm2qi */

    case 763:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5450; /* pred_indexed_ustorervvm4bfrvvm2qi */

    case 764:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5452; /* pred_indexed_ustorervvm4hfrvvm2qi */

    case 765:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5454; /* pred_indexed_ustorervvm8sfrvvm2qi */

    case 766:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24502; /* pred_indexed_ustorervvm2x2qirvvm2qi */

    case 767:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24508; /* pred_indexed_ustorervvm2x3qirvvm2qi */

    case 768:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24514; /* pred_indexed_ustorervvm2x4qirvvm2qi */

    case 769:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24520; /* pred_indexed_ustorervvm4x2hirvvm2qi */

    case 770:
      if (!(
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24526; /* pred_indexed_ustorervvm4x2bfrvvm2qi */

    case 771:
      if (!(
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24532; /* pred_indexed_ustorervvm4x2hfrvvm2qi */

    case 772:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5456; /* pred_indexed_ustorervvm2qirvvm4hi */

    case 773:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5458; /* pred_indexed_ustorervvm4hirvvm4hi */

    case 774:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5460; /* pred_indexed_ustorervvm8sirvvm4hi */

    case 775:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5462; /* pred_indexed_ustorervvm4bfrvvm4hi */

    case 776:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5464; /* pred_indexed_ustorervvm4hfrvvm4hi */

    case 777:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5466; /* pred_indexed_ustorervvm8sfrvvm4hi */

    case 778:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24504; /* pred_indexed_ustorervvm2x2qirvvm4hi */

    case 779:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24510; /* pred_indexed_ustorervvm2x3qirvvm4hi */

    case 780:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24516; /* pred_indexed_ustorervvm2x4qirvvm4hi */

    case 781:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24522; /* pred_indexed_ustorervvm4x2hirvvm4hi */

    case 782:
      if (!(
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24528; /* pred_indexed_ustorervvm4x2bfrvvm4hi */

    case 783:
      if (!(
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24534; /* pred_indexed_ustorervvm4x2hfrvvm4hi */

    case 784:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5468; /* pred_indexed_ustorervvm2qirvvm8si */

    case 785:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5470; /* pred_indexed_ustorervvm4hirvvm8si */

    case 786:
      if (!
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5472; /* pred_indexed_ustorervvm8sirvvm8si */

    case 787:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5474; /* pred_indexed_ustorervvm4bfrvvm8si */

    case 788:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5476; /* pred_indexed_ustorervvm4hfrvvm8si */

    case 789:
      if (!(
#line 2656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5478; /* pred_indexed_ustorervvm8sfrvvm8si */

    case 790:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24506; /* pred_indexed_ustorervvm2x2qirvvm8si */

    case 791:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24512; /* pred_indexed_ustorervvm2x3qirvvm8si */

    case 792:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24518; /* pred_indexed_ustorervvm2x4qirvvm8si */

    case 793:
      if (!
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24524; /* pred_indexed_ustorervvm4x2hirvvm8si */

    case 794:
      if (!(
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24530; /* pred_indexed_ustorervvm4x2bfrvvm8si */

    case 795:
      if (!(
#line 8677 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24536; /* pred_indexed_ustorervvm4x2hfrvvm8si */

    case 796:
      if (!
#line 2673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5480; /* pred_indexed_ustorervvm4qirvvm4qi */

    case 797:
      if (!
#line 2673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5482; /* pred_indexed_ustorervvm8hirvvm4qi */

    case 798:
      if (!(
#line 2673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 861 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5484; /* pred_indexed_ustorervvm8bfrvvm4qi */

    case 799:
      if (!(
#line 2673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5486; /* pred_indexed_ustorervvm8hfrvvm4qi */

    case 800:
      if (!
#line 8694 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24538; /* pred_indexed_ustorervvm4x2qirvvm4qi */

    case 801:
      if (!
#line 2673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5488; /* pred_indexed_ustorervvm4qirvvm8hi */

    case 802:
      if (!
#line 2673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5490; /* pred_indexed_ustorervvm8hirvvm8hi */

    case 803:
      if (!(
#line 2673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 861 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5492; /* pred_indexed_ustorervvm8bfrvvm8hi */

    case 804:
      if (!(
#line 2673 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5494; /* pred_indexed_ustorervvm8hfrvvm8hi */

    case 805:
      if (!
#line 8694 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24540; /* pred_indexed_ustorervvm4x2qirvvm8hi */

    case 806:
      if (!
#line 2690 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5496; /* pred_indexed_ustorervvm8qirvvm8qi */

    default:
      return -1;
    }
}

 int
recog_470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024HImode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 4297; /* *pred_broadcastv1024hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024HImode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4419; /* *pred_broadcastv1024hi_imm */
}

 int
recog_478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4HImode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 4289; /* *pred_broadcastv4hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4HImode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 4411; /* *pred_broadcastv4hi_imm */
}

 int
recog_485 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256QImode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 4282; /* *pred_broadcastv256qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256QImode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4404; /* *pred_broadcastv256qi_imm */
}

 int
recog_492 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2QImode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 4275; /* *pred_broadcastv2qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2QImode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 4397; /* *pred_broadcastv2qi_imm */
}

 int
recog_499 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVM1SFmode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4268; /* *pred_broadcastrvvm1sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1SFmode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4390; /* *pred_broadcastrvvm1sf_imm */
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
      && vector_const_0_operand (operands[3], E_RVVM1HFmode)
      && (
#line 2340 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4262; /* *pred_broadcastrvvm1hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1HFmode)
      || !(
#line 2360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4384; /* *pred_broadcastrvvm1hf_imm */
}

 int
recog_512 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512DImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 20704; /* pred_gatherv512df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20826; /* pred_gatherv512df_scalar */
}

 int
recog_517 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16DImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 20699; /* pred_gatherv16df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20821; /* pred_gatherv16df_scalar */
}

 int
recog_524 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256SImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 20692; /* pred_gatherv256sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20814; /* pred_gatherv256sf_scalar */
}

 int
recog_529 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8SImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 20687; /* pred_gatherv8sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 20809; /* pred_gatherv8sf_scalar */
}

 int
recog_532 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1SImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 20684; /* pred_gatherv1sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 20806; /* pred_gatherv1sf_scalar */
}

 int
recog_537 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128HImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return 20679; /* pred_gatherv128hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20801; /* pred_gatherv128hf_scalar */
}

 int
recog_542 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4HImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20674; /* pred_gatherv4hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20796; /* pred_gatherv4hf_scalar */
}

 int
recog_547 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128DImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 20669; /* pred_gatherv128di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20791; /* pred_gatherv128di_scalar */
}

 int
recog_552 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4DImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 20664; /* pred_gatherv4di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 20786; /* pred_gatherv4di_scalar */
}

 int
recog_557 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256SImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 20659; /* pred_gatherv256si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20781; /* pred_gatherv256si_scalar */
}

 int
recog_562 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8SImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 20654; /* pred_gatherv8si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 20776; /* pred_gatherv8si_scalar */
}

 int
recog_567 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024HImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 20649; /* pred_gatherv1024hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20771; /* pred_gatherv1024hi_scalar */
}

 int
recog_572 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32HImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 20644; /* pred_gatherv32hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20766; /* pred_gatherv32hi_scalar */
}

 int
recog_577 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1HImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 20639; /* pred_gatherv1hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 20761; /* pred_gatherv1hi_scalar */
}

 int
recog_582 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256QImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 20634; /* pred_gatherv256qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20756; /* pred_gatherv256qi_scalar */
}

 int
recog_587 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8QImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 20629; /* pred_gatherv8qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 20751; /* pred_gatherv8qi_scalar */
}

 int
recog_592 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM2DImode)
      && (
#line 8239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 20624; /* pred_gatherrvvm2df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20746; /* pred_gatherrvvm2df_scalar */
}

 int
recog_597 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[4] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 0);
  operands[3] = x11;
  switch (pattern700 (x2))
    {
    case 0:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21108; /* pred_unit_strided_loadrvvmf8x2qi */

    case 1:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21109; /* pred_unit_strided_loadrvvmf8x3qi */

    case 2:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21110; /* pred_unit_strided_loadrvvmf8x4qi */

    case 3:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21111; /* pred_unit_strided_loadrvvmf8x5qi */

    case 4:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21112; /* pred_unit_strided_loadrvvmf8x6qi */

    case 5:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21113; /* pred_unit_strided_loadrvvmf8x7qi */

    case 6:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21114; /* pred_unit_strided_loadrvvmf8x8qi */

    case 7:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21115; /* pred_unit_strided_loadrvvmf4x2hi */

    case 8:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21116; /* pred_unit_strided_loadrvvmf4x3hi */

    case 9:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21117; /* pred_unit_strided_loadrvvmf4x4hi */

    case 10:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21118; /* pred_unit_strided_loadrvvmf4x5hi */

    case 11:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21119; /* pred_unit_strided_loadrvvmf4x6hi */

    case 12:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21120; /* pred_unit_strided_loadrvvmf4x7hi */

    case 13:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21121; /* pred_unit_strided_loadrvvmf4x8hi */

    case 14:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21122; /* pred_unit_strided_loadrvvmf2x2si */

    case 15:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21123; /* pred_unit_strided_loadrvvmf2x3si */

    case 16:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21124; /* pred_unit_strided_loadrvvmf2x4si */

    case 17:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21125; /* pred_unit_strided_loadrvvmf2x5si */

    case 18:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21126; /* pred_unit_strided_loadrvvmf2x6si */

    case 19:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21127; /* pred_unit_strided_loadrvvmf2x7si */

    case 20:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21128; /* pred_unit_strided_loadrvvmf2x8si */

    case 21:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21129; /* pred_unit_strided_loadrvvm1x2di */

    case 22:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21130; /* pred_unit_strided_loadrvvm1x3di */

    case 23:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21131; /* pred_unit_strided_loadrvvm1x4di */

    case 24:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21132; /* pred_unit_strided_loadrvvm1x5di */

    case 25:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21133; /* pred_unit_strided_loadrvvm1x6di */

    case 26:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21134; /* pred_unit_strided_loadrvvm1x7di */

    case 27:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21135; /* pred_unit_strided_loadrvvm1x8di */

    case 28:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21136; /* pred_unit_strided_loadrvvmf4x2bf */

    case 29:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21137; /* pred_unit_strided_loadrvvmf4x3bf */

    case 30:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21138; /* pred_unit_strided_loadrvvmf4x4bf */

    case 31:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21139; /* pred_unit_strided_loadrvvmf4x5bf */

    case 32:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21140; /* pred_unit_strided_loadrvvmf4x6bf */

    case 33:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21141; /* pred_unit_strided_loadrvvmf4x7bf */

    case 34:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21142; /* pred_unit_strided_loadrvvmf4x8bf */

    case 35:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21143; /* pred_unit_strided_loadrvvmf4x2hf */

    case 36:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21144; /* pred_unit_strided_loadrvvmf4x3hf */

    case 37:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21145; /* pred_unit_strided_loadrvvmf4x4hf */

    case 38:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21146; /* pred_unit_strided_loadrvvmf4x5hf */

    case 39:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21147; /* pred_unit_strided_loadrvvmf4x6hf */

    case 40:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21148; /* pred_unit_strided_loadrvvmf4x7hf */

    case 41:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21149; /* pred_unit_strided_loadrvvmf4x8hf */

    case 42:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21150; /* pred_unit_strided_loadrvvmf2x2sf */

    case 43:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21151; /* pred_unit_strided_loadrvvmf2x3sf */

    case 44:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21152; /* pred_unit_strided_loadrvvmf2x4sf */

    case 45:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21153; /* pred_unit_strided_loadrvvmf2x5sf */

    case 46:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21154; /* pred_unit_strided_loadrvvmf2x6sf */

    case 47:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21155; /* pred_unit_strided_loadrvvmf2x7sf */

    case 48:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21156; /* pred_unit_strided_loadrvvmf2x8sf */

    case 49:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21157; /* pred_unit_strided_loadrvvm1x2df */

    case 50:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21158; /* pred_unit_strided_loadrvvm1x3df */

    case 51:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21159; /* pred_unit_strided_loadrvvm1x4df */

    case 52:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21160; /* pred_unit_strided_loadrvvm1x5df */

    case 53:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21161; /* pred_unit_strided_loadrvvm1x6df */

    case 54:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21162; /* pred_unit_strided_loadrvvm1x7df */

    case 55:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21163; /* pred_unit_strided_loadrvvm1x8df */

    case 56:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21164; /* pred_unit_strided_loadrvvmf4x2qi */

    case 57:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21165; /* pred_unit_strided_loadrvvmf4x3qi */

    case 58:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21166; /* pred_unit_strided_loadrvvmf4x4qi */

    case 59:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21167; /* pred_unit_strided_loadrvvmf4x5qi */

    case 60:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21168; /* pred_unit_strided_loadrvvmf4x6qi */

    case 61:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21169; /* pred_unit_strided_loadrvvmf4x7qi */

    case 62:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21170; /* pred_unit_strided_loadrvvmf4x8qi */

    case 63:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21171; /* pred_unit_strided_loadrvvmf2x2hi */

    case 64:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21172; /* pred_unit_strided_loadrvvmf2x3hi */

    case 65:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21173; /* pred_unit_strided_loadrvvmf2x4hi */

    case 66:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21174; /* pred_unit_strided_loadrvvmf2x5hi */

    case 67:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21175; /* pred_unit_strided_loadrvvmf2x6hi */

    case 68:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21176; /* pred_unit_strided_loadrvvmf2x7hi */

    case 69:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21177; /* pred_unit_strided_loadrvvmf2x8hi */

    case 70:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21178; /* pred_unit_strided_loadrvvm1x2si */

    case 71:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21179; /* pred_unit_strided_loadrvvm1x3si */

    case 72:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21180; /* pred_unit_strided_loadrvvm1x4si */

    case 73:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21181; /* pred_unit_strided_loadrvvm1x5si */

    case 74:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21182; /* pred_unit_strided_loadrvvm1x6si */

    case 75:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21183; /* pred_unit_strided_loadrvvm1x7si */

    case 76:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21184; /* pred_unit_strided_loadrvvm1x8si */

    case 77:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21185; /* pred_unit_strided_loadrvvm2x2di */

    case 78:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21186; /* pred_unit_strided_loadrvvm2x3di */

    case 79:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21187; /* pred_unit_strided_loadrvvm2x4di */

    case 80:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21188; /* pred_unit_strided_loadrvvmf2x2bf */

    case 81:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21189; /* pred_unit_strided_loadrvvmf2x3bf */

    case 82:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21190; /* pred_unit_strided_loadrvvmf2x4bf */

    case 83:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21191; /* pred_unit_strided_loadrvvmf2x5bf */

    case 84:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21192; /* pred_unit_strided_loadrvvmf2x6bf */

    case 85:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21193; /* pred_unit_strided_loadrvvmf2x7bf */

    case 86:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21194; /* pred_unit_strided_loadrvvmf2x8bf */

    case 87:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21195; /* pred_unit_strided_loadrvvmf2x2hf */

    case 88:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21196; /* pred_unit_strided_loadrvvmf2x3hf */

    case 89:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21197; /* pred_unit_strided_loadrvvmf2x4hf */

    case 90:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21198; /* pred_unit_strided_loadrvvmf2x5hf */

    case 91:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21199; /* pred_unit_strided_loadrvvmf2x6hf */

    case 92:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21200; /* pred_unit_strided_loadrvvmf2x7hf */

    case 93:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21201; /* pred_unit_strided_loadrvvmf2x8hf */

    case 94:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21202; /* pred_unit_strided_loadrvvm1x2sf */

    case 95:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21203; /* pred_unit_strided_loadrvvm1x3sf */

    case 96:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21204; /* pred_unit_strided_loadrvvm1x4sf */

    case 97:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21205; /* pred_unit_strided_loadrvvm1x5sf */

    case 98:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21206; /* pred_unit_strided_loadrvvm1x6sf */

    case 99:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21207; /* pred_unit_strided_loadrvvm1x7sf */

    case 100:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21208; /* pred_unit_strided_loadrvvm1x8sf */

    case 101:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21209; /* pred_unit_strided_loadrvvm2x2df */

    case 102:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21210; /* pred_unit_strided_loadrvvm2x3df */

    case 103:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21211; /* pred_unit_strided_loadrvvm2x4df */

    case 104:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21212; /* pred_unit_strided_loadrvvmf2x2qi */

    case 105:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21213; /* pred_unit_strided_loadrvvmf2x3qi */

    case 106:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21214; /* pred_unit_strided_loadrvvmf2x4qi */

    case 107:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21215; /* pred_unit_strided_loadrvvmf2x5qi */

    case 108:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21216; /* pred_unit_strided_loadrvvmf2x6qi */

    case 109:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21217; /* pred_unit_strided_loadrvvmf2x7qi */

    case 110:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21218; /* pred_unit_strided_loadrvvmf2x8qi */

    case 111:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21219; /* pred_unit_strided_loadrvvm1x2hi */

    case 112:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21220; /* pred_unit_strided_loadrvvm1x3hi */

    case 113:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21221; /* pred_unit_strided_loadrvvm1x4hi */

    case 114:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21222; /* pred_unit_strided_loadrvvm1x5hi */

    case 115:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21223; /* pred_unit_strided_loadrvvm1x6hi */

    case 116:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21224; /* pred_unit_strided_loadrvvm1x7hi */

    case 117:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21225; /* pred_unit_strided_loadrvvm1x8hi */

    case 118:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21226; /* pred_unit_strided_loadrvvm2x2si */

    case 119:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21227; /* pred_unit_strided_loadrvvm2x3si */

    case 120:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21228; /* pred_unit_strided_loadrvvm2x4si */

    case 121:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21229; /* pred_unit_strided_loadrvvm4x2di */

    case 122:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21230; /* pred_unit_strided_loadrvvm1x2bf */

    case 123:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21231; /* pred_unit_strided_loadrvvm1x3bf */

    case 124:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21232; /* pred_unit_strided_loadrvvm1x4bf */

    case 125:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21233; /* pred_unit_strided_loadrvvm1x5bf */

    case 126:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21234; /* pred_unit_strided_loadrvvm1x6bf */

    case 127:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21235; /* pred_unit_strided_loadrvvm1x7bf */

    case 128:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21236; /* pred_unit_strided_loadrvvm1x8bf */

    case 129:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21237; /* pred_unit_strided_loadrvvm1x2hf */

    case 130:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21238; /* pred_unit_strided_loadrvvm1x3hf */

    case 131:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21239; /* pred_unit_strided_loadrvvm1x4hf */

    case 132:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21240; /* pred_unit_strided_loadrvvm1x5hf */

    case 133:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21241; /* pred_unit_strided_loadrvvm1x6hf */

    case 134:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21242; /* pred_unit_strided_loadrvvm1x7hf */

    case 135:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21243; /* pred_unit_strided_loadrvvm1x8hf */

    case 136:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21244; /* pred_unit_strided_loadrvvm2x2sf */

    case 137:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21245; /* pred_unit_strided_loadrvvm2x3sf */

    case 138:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21246; /* pred_unit_strided_loadrvvm2x4sf */

    case 139:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21247; /* pred_unit_strided_loadrvvm4x2df */

    case 140:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21248; /* pred_unit_strided_loadrvvm1x2qi */

    case 141:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21249; /* pred_unit_strided_loadrvvm1x3qi */

    case 142:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21250; /* pred_unit_strided_loadrvvm1x4qi */

    case 143:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21251; /* pred_unit_strided_loadrvvm1x5qi */

    case 144:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21252; /* pred_unit_strided_loadrvvm1x6qi */

    case 145:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21253; /* pred_unit_strided_loadrvvm1x7qi */

    case 146:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21254; /* pred_unit_strided_loadrvvm1x8qi */

    case 147:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21255; /* pred_unit_strided_loadrvvm2x2hi */

    case 148:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21256; /* pred_unit_strided_loadrvvm2x3hi */

    case 149:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21257; /* pred_unit_strided_loadrvvm2x4hi */

    case 150:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21258; /* pred_unit_strided_loadrvvm4x2si */

    case 151:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21259; /* pred_unit_strided_loadrvvm2x2bf */

    case 152:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21260; /* pred_unit_strided_loadrvvm2x3bf */

    case 153:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21261; /* pred_unit_strided_loadrvvm2x4bf */

    case 154:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21262; /* pred_unit_strided_loadrvvm2x2hf */

    case 155:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21263; /* pred_unit_strided_loadrvvm2x3hf */

    case 156:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21264; /* pred_unit_strided_loadrvvm2x4hf */

    case 157:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21265; /* pred_unit_strided_loadrvvm4x2sf */

    case 158:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21266; /* pred_unit_strided_loadrvvm2x2qi */

    case 159:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21267; /* pred_unit_strided_loadrvvm2x3qi */

    case 160:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21268; /* pred_unit_strided_loadrvvm2x4qi */

    case 161:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21269; /* pred_unit_strided_loadrvvm4x2hi */

    case 162:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21270; /* pred_unit_strided_loadrvvm4x2bf */

    case 163:
      if (!(
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21271; /* pred_unit_strided_loadrvvm4x2hf */

    case 164:
      if (!
#line 8379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21272; /* pred_unit_strided_loadrvvm4x2qi */

    default:
      return -1;
    }
}

 int
recog_608 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8DImode:
      if (pattern690 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7793; /* *pred_addrvvm8di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10283; /* pred_single_widen_addsrvvm8di_extended_scalar */

    case E_RVVM4DImode:
      if (pattern690 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7802; /* *pred_addrvvm4di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10285; /* pred_single_widen_addsrvvm4di_extended_scalar */

    case E_RVVM2DImode:
      if (pattern690 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7811; /* *pred_addrvvm2di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10287; /* pred_single_widen_addsrvvm2di_extended_scalar */

    case E_RVVM1DImode:
      if (pattern690 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7820; /* *pred_addrvvm1di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10289; /* pred_single_widen_addsrvvm1di_extended_scalar */

    case E_V1DImode:
      if (pattern690 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 7829; /* *pred_addv1di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10337; /* pred_single_widen_addsv1di_extended_scalar */

    case E_V2DImode:
      if (pattern690 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 7838; /* *pred_addv2di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10339; /* pred_single_widen_addsv2di_extended_scalar */

    case E_V4DImode:
      if (pattern690 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 7847; /* *pred_addv4di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10341; /* pred_single_widen_addsv4di_extended_scalar */

    case E_V8DImode:
      if (pattern690 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 7856; /* *pred_addv8di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10343; /* pred_single_widen_addsv8di_extended_scalar */

    case E_V16DImode:
      if (pattern690 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 7865; /* *pred_addv16di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10345; /* pred_single_widen_addsv16di_extended_scalar */

    case E_V32DImode:
      if (pattern690 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 7874; /* *pred_addv32di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10347; /* pred_single_widen_addsv32di_extended_scalar */

    case E_V64DImode:
      if (pattern690 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 7883; /* *pred_addv64di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10349; /* pred_single_widen_addsv64di_extended_scalar */

    case E_V128DImode:
      if (pattern690 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 7892; /* *pred_addv128di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10351; /* pred_single_widen_addsv128di_extended_scalar */

    case E_V256DImode:
      if (pattern690 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 7901; /* *pred_addv256di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10353; /* pred_single_widen_addsv256di_extended_scalar */

    case E_V512DImode:
      if (pattern690 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 7910; /* *pred_addv512di_extended_scalar */
      if (!(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10355; /* pred_single_widen_addsv512di_extended_scalar */

    case E_RVVM8HImode:
      if (pattern690 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10261; /* pred_single_widen_addsrvvm8hi_extended_scalar */

    case E_RVVM4HImode:
      if (pattern690 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10263; /* pred_single_widen_addsrvvm4hi_extended_scalar */

    case E_RVVM2HImode:
      if (pattern690 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10265; /* pred_single_widen_addsrvvm2hi_extended_scalar */

    case E_RVVM1HImode:
      if (pattern690 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10267; /* pred_single_widen_addsrvvm1hi_extended_scalar */

    case E_RVVMF2HImode:
      if (pattern690 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10269; /* pred_single_widen_addsrvvmf2hi_extended_scalar */

    case E_RVVMF4HImode:
      if (pattern690 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10271; /* pred_single_widen_addsrvvmf4hi_extended_scalar */

    case E_RVVM8SImode:
      if (pattern690 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10273; /* pred_single_widen_addsrvvm8si_extended_scalar */

    case E_RVVM4SImode:
      if (pattern690 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10275; /* pred_single_widen_addsrvvm4si_extended_scalar */

    case E_RVVM2SImode:
      if (pattern690 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10277; /* pred_single_widen_addsrvvm2si_extended_scalar */

    case E_RVVM1SImode:
      if (pattern690 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10279; /* pred_single_widen_addsrvvm1si_extended_scalar */

    case E_RVVMF2SImode:
      if (pattern690 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10281; /* pred_single_widen_addsrvvmf2si_extended_scalar */

    case E_V1HImode:
      if (pattern690 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 10291; /* pred_single_widen_addsv1hi_extended_scalar */

    case E_V2HImode:
      if (pattern690 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 10293; /* pred_single_widen_addsv2hi_extended_scalar */

    case E_V4HImode:
      if (pattern690 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 10295; /* pred_single_widen_addsv4hi_extended_scalar */

    case E_V8HImode:
      if (pattern690 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 10297; /* pred_single_widen_addsv8hi_extended_scalar */

    case E_V16HImode:
      if (pattern690 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 10299; /* pred_single_widen_addsv16hi_extended_scalar */

    case E_V32HImode:
      if (pattern690 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10301; /* pred_single_widen_addsv32hi_extended_scalar */

    case E_V64HImode:
      if (pattern690 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10303; /* pred_single_widen_addsv64hi_extended_scalar */

    case E_V128HImode:
      if (pattern690 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10305; /* pred_single_widen_addsv128hi_extended_scalar */

    case E_V256HImode:
      if (pattern690 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10307; /* pred_single_widen_addsv256hi_extended_scalar */

    case E_V512HImode:
      if (pattern690 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10309; /* pred_single_widen_addsv512hi_extended_scalar */

    case E_V1024HImode:
      if (pattern690 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10311; /* pred_single_widen_addsv1024hi_extended_scalar */

    case E_V2048HImode:
      if (pattern690 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10313; /* pred_single_widen_addsv2048hi_extended_scalar */

    case E_V1SImode:
      if (pattern690 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 10315; /* pred_single_widen_addsv1si_extended_scalar */

    case E_V2SImode:
      if (pattern690 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 10317; /* pred_single_widen_addsv2si_extended_scalar */

    case E_V4SImode:
      if (pattern690 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 10319; /* pred_single_widen_addsv4si_extended_scalar */

    case E_V8SImode:
      if (pattern690 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 10321; /* pred_single_widen_addsv8si_extended_scalar */

    case E_V16SImode:
      if (pattern690 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10323; /* pred_single_widen_addsv16si_extended_scalar */

    case E_V32SImode:
      if (pattern690 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10325; /* pred_single_widen_addsv32si_extended_scalar */

    case E_V64SImode:
      if (pattern690 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10327; /* pred_single_widen_addsv64si_extended_scalar */

    case E_V128SImode:
      if (pattern690 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10329; /* pred_single_widen_addsv128si_extended_scalar */

    case E_V256SImode:
      if (pattern690 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10331; /* pred_single_widen_addsv256si_extended_scalar */

    case E_V512SImode:
      if (pattern690 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10333; /* pred_single_widen_addsv512si_extended_scalar */

    case E_V1024SImode:
      if (pattern690 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10335; /* pred_single_widen_addsv1024si_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_668 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2DImode)
      || !(
#line 5331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13140; /* *pred_mul_plusv2di_undef */
}

 int
recog_674 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128DImode)
      || !(
#line 5331 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13146; /* *pred_mul_plusv128di_undef */
}

 int
recog_680 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_673 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13213; /* *pred_maddv64di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13281; /* *pred_maccv64di */
}

 int
recog_686 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_667 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13207; /* *pred_maddv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13275; /* *pred_maccv1di */
}

 int
recog_693 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_660 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13200; /* *pred_maddv16si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13268; /* *pred_maccv16si */
}

 int
recog_700 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_653 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13193; /* *pred_maddv512hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13261; /* *pred_maccv512hi */
}

 int
recog_706 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_647 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V8HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 13187; /* *pred_maddv8hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 13255; /* *pred_maccv8hi */
}

 int
recog_713 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_640 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13180; /* *pred_maddv512qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13248; /* *pred_maccv512qi */
}

 int
recog_720 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13349; /* *pred_maddv64di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13417; /* *pred_maccv64di_scalar */
}

 int
recog_727 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13342; /* *pred_maddv1024si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13410; /* *pred_maccv1024si_scalar */
}

 int
recog_734 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13335; /* *pred_maddv8si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13403; /* *pred_maccv8si_scalar */
}

 int
recog_741 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13328; /* *pred_maddv256hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13396; /* *pred_maccv256hi_scalar */
}

 int
recog_748 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_609 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM8QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13149; /* *pred_maddrvvm8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13217; /* *pred_maccrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_610 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM4QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13150; /* *pred_maddrvvm4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13218; /* *pred_maccrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_611 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13151; /* *pred_maddrvvm2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13219; /* *pred_maccrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_612 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13152; /* *pred_maddrvvm1qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13220; /* *pred_maccrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_613 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM8HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM8HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13153; /* *pred_maddrvvm8hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13221; /* *pred_maccrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_614 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13154; /* *pred_maddrvvm4hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13222; /* *pred_maccrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_615 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13155; /* *pred_maddrvvm2hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13223; /* *pred_maccrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_616 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM1HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM1HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13156; /* *pred_maddrvvm1hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13224; /* *pred_maccrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_617 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13157; /* *pred_maddrvvm8si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13225; /* *pred_maccrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_618 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13158; /* *pred_maddrvvm4si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13226; /* *pred_maccrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_619 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM2SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM2SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13159; /* *pred_maddrvvm2si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13227; /* *pred_maccrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_620 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM1SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13160; /* *pred_maddrvvm1si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13228; /* *pred_maccrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_621 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13161; /* *pred_maddrvvm8di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13229; /* *pred_maccrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_622 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM4DImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM4DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13162; /* *pred_maddrvvm4di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13230; /* *pred_maccrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_623 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM2DImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13163; /* *pred_maddrvvm2di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13231; /* *pred_maccrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_624 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM1DImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13164; /* *pred_maddrvvm1di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13232; /* *pred_maccrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_625 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF2QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13165; /* *pred_maddrvvmf2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13233; /* *pred_maccrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_626 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF4QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13166; /* *pred_maddrvvmf4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13234; /* *pred_maccrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_627 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF8QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13167; /* *pred_maddrvvmf8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13235; /* *pred_maccrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_628 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF2HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13168; /* *pred_maddrvvmf2hi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13236; /* *pred_maccrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_629 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF4HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13169; /* *pred_maddrvvmf4hi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13237; /* *pred_maccrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_630 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF2SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13170; /* *pred_maddrvvmf2si */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13238; /* *pred_maccrvvmf2si */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_631 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V1QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V1QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 13171; /* *pred_maddv1qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 13239; /* *pred_maccv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_632 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V2QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 13172; /* *pred_maddv2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 13240; /* *pred_maccv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_633 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V4QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 13173; /* *pred_maddv4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 13241; /* *pred_maccv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_634 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 13174; /* *pred_maddv8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 13242; /* *pred_maccv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_635 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V16QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 13175; /* *pred_maddv16qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 13243; /* *pred_maccv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_636 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V32QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V32QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 13176; /* *pred_maddv32qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 13244; /* *pred_maccv32qi */

    case E_V64QImode:
      return recog_716 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_715 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_714 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_713 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_712 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_711 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_710 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_709 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_708 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_707 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_706 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_705 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_704 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_703 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_702 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_701 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_700 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_699 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_698 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_697 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_696 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_695 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_694 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_693 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_692 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_691 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_690 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_689 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_688 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_687 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_686 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_685 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_684 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_683 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_682 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_681 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_680 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_679 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_678 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_677 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_760 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V16DImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13511; /* *pred_minus_mulv16di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13579; /* *pred_nmsubv16di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13647; /* *pred_nmsacv16di */
}

 int
recog_762 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V4DImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13509; /* *pred_minus_mulv4di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13577; /* *pred_nmsubv4di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13645; /* *pred_nmsacv4di */
}

 int
recog_764 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V1DImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13507; /* *pred_minus_mulv1di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13575; /* *pred_nmsubv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13643; /* *pred_nmsacv1di */
}

 int
recog_766 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V512SImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13505; /* *pred_minus_mulv512si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13573; /* *pred_nmsubv512si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13641; /* *pred_nmsacv512si */
}

 int
recog_768 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V128SImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13503; /* *pred_minus_mulv128si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13571; /* *pred_nmsubv128si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13639; /* *pred_nmsacv128si */
}

 int
recog_771 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V16SImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13500; /* *pred_minus_mulv16si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13568; /* *pred_nmsubv16si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13636; /* *pred_nmsacv16si */
}

 int
recog_774 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V2SImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13497; /* *pred_minus_mulv2si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13565; /* *pred_nmsubv2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13633; /* *pred_nmsacv2si */
}

 int
recog_779 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V256HImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13492; /* *pred_minus_mulv256hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13560; /* *pred_nmsubv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13628; /* *pred_nmsacv256hi */
}

 int
recog_785 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V4HImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13486; /* *pred_minus_mulv4hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13554; /* *pred_nmsubv4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13622; /* *pred_nmsacv4hi */
}

 int
recog_791 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V512QImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13480; /* *pred_minus_mulv512qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13548; /* *pred_nmsubv512qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13616; /* *pred_nmsacv512qi */
}

 int
recog_799 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V2QImode) == 0
      && (
#line 5613 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 13472; /* *pred_minus_mulv2qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 13540; /* *pred_nmsubv2qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 13608; /* *pred_nmsacv2qi */
}

 int
recog_807 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13717; /* *pred_nmsubv64di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13785; /* *pred_nmsacv64di_scalar */
}

 int
recog_814 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13710; /* *pred_nmsubv1024si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13778; /* *pred_nmsacv1024si_scalar */
}

 int
recog_822 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13702; /* *pred_nmsubv4si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13770; /* *pred_nmsacv4si_scalar */
}

 int
recog_830 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13694; /* *pred_nmsubv64hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13762; /* *pred_nmsacv64hi_scalar */
}

 int
recog_839 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern535 (x2, 
SIGN_EXTEND))
    {
    case 0:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9303; /* pred_dual_widen_subsrvvm8hi */

    case 1:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9309; /* pred_dual_widen_subsrvvm4hi */

    case 2:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9315; /* pred_dual_widen_subsrvvm2hi */

    case 3:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9321; /* pred_dual_widen_subsrvvm1hi */

    case 4:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9327; /* pred_dual_widen_subsrvvmf2hi */

    case 5:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9333; /* pred_dual_widen_subsrvvmf4hi */

    case 6:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9339; /* pred_dual_widen_subsrvvm8si */

    case 7:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9345; /* pred_dual_widen_subsrvvm4si */

    case 8:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9351; /* pred_dual_widen_subsrvvm2si */

    case 9:
      if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9357; /* pred_dual_widen_subsrvvm1si */

    case 10:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9363; /* pred_dual_widen_subsrvvmf2si */

    case 11:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9369; /* pred_dual_widen_subsrvvm8di */

    case 12:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9375; /* pred_dual_widen_subsrvvm4di */

    case 13:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9381; /* pred_dual_widen_subsrvvm2di */

    case 14:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9387; /* pred_dual_widen_subsrvvm1di */

    case 15:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9393; /* pred_dual_widen_subsv1hi */

    case 16:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9399; /* pred_dual_widen_subsv2hi */

    case 17:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9405; /* pred_dual_widen_subsv4hi */

    case 18:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9411; /* pred_dual_widen_subsv8hi */

    case 19:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9417; /* pred_dual_widen_subsv16hi */

    case 20:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9423; /* pred_dual_widen_subsv32hi */

    case 21:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9429; /* pred_dual_widen_subsv64hi */

    case 22:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9435; /* pred_dual_widen_subsv128hi */

    case 23:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9441; /* pred_dual_widen_subsv256hi */

    case 24:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9447; /* pred_dual_widen_subsv512hi */

    case 25:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9453; /* pred_dual_widen_subsv1024hi */

    case 26:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9459; /* pred_dual_widen_subsv2048hi */

    case 27:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9465; /* pred_dual_widen_subsv1si */

    case 28:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9471; /* pred_dual_widen_subsv2si */

    case 29:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9477; /* pred_dual_widen_subsv4si */

    case 30:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9483; /* pred_dual_widen_subsv8si */

    case 31:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9489; /* pred_dual_widen_subsv16si */

    case 32:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9495; /* pred_dual_widen_subsv32si */

    case 33:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9501; /* pred_dual_widen_subsv64si */

    case 34:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9507; /* pred_dual_widen_subsv128si */

    case 35:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9513; /* pred_dual_widen_subsv256si */

    case 36:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9519; /* pred_dual_widen_subsv512si */

    case 37:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9525; /* pred_dual_widen_subsv1024si */

    case 38:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9531; /* pred_dual_widen_subsv1di */

    case 39:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9537; /* pred_dual_widen_subsv2di */

    case 40:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9543; /* pred_dual_widen_subsv4di */

    case 41:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9549; /* pred_dual_widen_subsv8di */

    case 42:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9555; /* pred_dual_widen_subsv16di */

    case 43:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9561; /* pred_dual_widen_subsv32di */

    case 44:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9567; /* pred_dual_widen_subsv64di */

    case 45:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9573; /* pred_dual_widen_subsv128di */

    case 46:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9579; /* pred_dual_widen_subsv256di */

    case 47:
      if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9585; /* pred_dual_widen_subsv512di */

    case 48:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9591; /* pred_dual_widen_subsrvvm8hi_scalar */

    case 49:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9597; /* pred_dual_widen_subsrvvm4hi_scalar */

    case 50:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9603; /* pred_dual_widen_subsrvvm2hi_scalar */

    case 51:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9609; /* pred_dual_widen_subsrvvm1hi_scalar */

    case 52:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9615; /* pred_dual_widen_subsrvvmf2hi_scalar */

    case 53:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9621; /* pred_dual_widen_subsrvvmf4hi_scalar */

    case 54:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9627; /* pred_dual_widen_subsrvvm8si_scalar */

    case 55:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9633; /* pred_dual_widen_subsrvvm4si_scalar */

    case 56:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9639; /* pred_dual_widen_subsrvvm2si_scalar */

    case 57:
      if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9645; /* pred_dual_widen_subsrvvm1si_scalar */

    case 58:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9651; /* pred_dual_widen_subsrvvmf2si_scalar */

    case 59:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9657; /* pred_dual_widen_subsrvvm8di_scalar */

    case 60:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9663; /* pred_dual_widen_subsrvvm4di_scalar */

    case 61:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9669; /* pred_dual_widen_subsrvvm2di_scalar */

    case 62:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9675; /* pred_dual_widen_subsrvvm1di_scalar */

    case 63:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9681; /* pred_dual_widen_subsv1hi_scalar */

    case 64:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9687; /* pred_dual_widen_subsv2hi_scalar */

    case 65:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9693; /* pred_dual_widen_subsv4hi_scalar */

    case 66:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9699; /* pred_dual_widen_subsv8hi_scalar */

    case 67:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9705; /* pred_dual_widen_subsv16hi_scalar */

    case 68:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9711; /* pred_dual_widen_subsv32hi_scalar */

    case 69:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9717; /* pred_dual_widen_subsv64hi_scalar */

    case 70:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9723; /* pred_dual_widen_subsv128hi_scalar */

    case 71:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9729; /* pred_dual_widen_subsv256hi_scalar */

    case 72:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9735; /* pred_dual_widen_subsv512hi_scalar */

    case 73:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9741; /* pred_dual_widen_subsv1024hi_scalar */

    case 74:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9747; /* pred_dual_widen_subsv2048hi_scalar */

    case 75:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9753; /* pred_dual_widen_subsv1si_scalar */

    case 76:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9759; /* pred_dual_widen_subsv2si_scalar */

    case 77:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9765; /* pred_dual_widen_subsv4si_scalar */

    case 78:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9771; /* pred_dual_widen_subsv8si_scalar */

    case 79:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9777; /* pred_dual_widen_subsv16si_scalar */

    case 80:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9783; /* pred_dual_widen_subsv32si_scalar */

    case 81:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9789; /* pred_dual_widen_subsv64si_scalar */

    case 82:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9795; /* pred_dual_widen_subsv128si_scalar */

    case 83:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9801; /* pred_dual_widen_subsv256si_scalar */

    case 84:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9807; /* pred_dual_widen_subsv512si_scalar */

    case 85:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9813; /* pred_dual_widen_subsv1024si_scalar */

    case 86:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9819; /* pred_dual_widen_subsv1di_scalar */

    case 87:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9825; /* pred_dual_widen_subsv2di_scalar */

    case 88:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9831; /* pred_dual_widen_subsv4di_scalar */

    case 89:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9837; /* pred_dual_widen_subsv8di_scalar */

    case 90:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9843; /* pred_dual_widen_subsv16di_scalar */

    case 91:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9849; /* pred_dual_widen_subsv32di_scalar */

    case 92:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9855; /* pred_dual_widen_subsv64di_scalar */

    case 93:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9861; /* pred_dual_widen_subsv128di_scalar */

    case 94:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9867; /* pred_dual_widen_subsv256di_scalar */

    case 95:
      if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9873; /* pred_dual_widen_subsv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_842 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512DImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 6641; /* pred_ashlv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 6854; /* pred_ashlv512di_scalar */
}

 int
recog_844 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V128DImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 6607; /* pred_ashlv128di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6848; /* pred_ashlv128di_scalar */
}

 int
recog_847 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16DImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 6556; /* pred_ashlv16di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 6839; /* pred_ashlv16di_scalar */
}

 int
recog_850 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2DImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 6505; /* pred_ashlv2di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 6830; /* pred_ashlv2di_scalar */
}

 int
recog_854 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256SImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 6437; /* pred_ashlv256si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6818; /* pred_ashlv256si_scalar */
}

 int
recog_858 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 6369; /* pred_ashlv16si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 6806; /* pred_ashlv16si_scalar */
}

 int
recog_863 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2048HImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 6284; /* pred_ashlv2048hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 6791; /* pred_ashlv2048hi_scalar */
}

 int
recog_868 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V64HImode)
      && (
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 6199; /* pred_ashlv64hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 6776; /* pred_ashlv64hi_scalar */
}

 int
recog_874 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V64SImode)
      && (
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 32893; /* pred_vwsllv64di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 32941; /* pred_vwsllv64di_scalar */
}

 int
recog_878 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V4SImode)
      && (
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 32889; /* pred_vwsllv4di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 32937; /* pred_vwsllv4di_scalar */
}

 int
recog_883 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8981; /* pred_negrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8983; /* pred_negrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8985; /* pred_negrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8987; /* pred_negrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8989; /* pred_negrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8991; /* pred_negrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8993; /* pred_negrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8995; /* pred_negrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8997; /* pred_negrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8999; /* pred_negrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9001; /* pred_negrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9003; /* pred_negrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9005; /* pred_negrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9007; /* pred_negrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9009; /* pred_negrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9011; /* pred_negrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 9013; /* pred_negrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 9015; /* pred_negrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9017; /* pred_negrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 9019; /* pred_negrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9021; /* pred_negrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9023; /* pred_negrvvmf2si */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 9025; /* pred_negv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 9027; /* pred_negv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 9029; /* pred_negv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 9031; /* pred_negv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 9033; /* pred_negv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 9035; /* pred_negv32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9037; /* pred_negv64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9039; /* pred_negv128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9041; /* pred_negv256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9043; /* pred_negv512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9045; /* pred_negv1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9047; /* pred_negv2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9049; /* pred_negv4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9051; /* pred_negv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9053; /* pred_negv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9055; /* pred_negv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9057; /* pred_negv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9059; /* pred_negv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9061; /* pred_negv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9063; /* pred_negv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9065; /* pred_negv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9067; /* pred_negv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9069; /* pred_negv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9071; /* pred_negv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9073; /* pred_negv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9075; /* pred_negv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9077; /* pred_negv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9079; /* pred_negv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9081; /* pred_negv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9083; /* pred_negv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9085; /* pred_negv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9087; /* pred_negv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9089; /* pred_negv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9091; /* pred_negv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9093; /* pred_negv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9095; /* pred_negv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9097; /* pred_negv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9099; /* pred_negv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9101; /* pred_negv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9103; /* pred_negv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9105; /* pred_negv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9107; /* pred_negv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9109; /* pred_negv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9111; /* pred_negv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9113; /* pred_negv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 3906 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9115; /* pred_negv512di */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16262; /* pred_negrvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16264; /* pred_negrvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16266; /* pred_negrvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16268; /* pred_negrvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16270; /* pred_negrvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16272; /* pred_negrvvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16274; /* pred_negrvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16276; /* pred_negrvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16278; /* pred_negrvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16280; /* pred_negrvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16282; /* pred_negrvvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16284; /* pred_negrvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16286; /* pred_negrvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16288; /* pred_negrvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16290; /* pred_negrvvm1df */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16292; /* pred_negv1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 16294; /* pred_negv2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 16296; /* pred_negv4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16298; /* pred_negv8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16300; /* pred_negv16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16302; /* pred_negv32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16304; /* pred_negv64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16306; /* pred_negv128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16308; /* pred_negv256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16310; /* pred_negv512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16312; /* pred_negv1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16314; /* pred_negv2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16316; /* pred_negv1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16318; /* pred_negv2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16320; /* pred_negv4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16322; /* pred_negv8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16324; /* pred_negv16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16326; /* pred_negv32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16328; /* pred_negv64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16330; /* pred_negv128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16332; /* pred_negv256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16334; /* pred_negv512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16336; /* pred_negv1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16338; /* pred_negv1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16340; /* pred_negv2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16342; /* pred_negv4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16344; /* pred_negv8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16346; /* pred_negv16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16348; /* pred_negv32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16350; /* pred_negv64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16352; /* pred_negv128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16354; /* pred_negv256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern493 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 6940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16356; /* pred_negv512df */

    default:
      return -1;
    }
}

 int
recog_893 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_838 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern489 (x2))
            {
            case 0:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7613; /* pred_subrvvm8qi_reverse_scalar */

            case 1:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7614; /* pred_subrvvm4qi_reverse_scalar */

            case 2:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7615; /* pred_subrvvm2qi_reverse_scalar */

            case 3:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7616; /* pred_subrvvm1qi_reverse_scalar */

            case 4:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7617; /* pred_subrvvmf2qi_reverse_scalar */

            case 5:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7618; /* pred_subrvvmf4qi_reverse_scalar */

            case 6:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7619; /* pred_subrvvmf8qi_reverse_scalar */

            case 7:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7620; /* pred_subrvvm8hi_reverse_scalar */

            case 8:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7621; /* pred_subrvvm4hi_reverse_scalar */

            case 9:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7622; /* pred_subrvvm2hi_reverse_scalar */

            case 10:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7623; /* pred_subrvvm1hi_reverse_scalar */

            case 11:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7624; /* pred_subrvvmf2hi_reverse_scalar */

            case 12:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7625; /* pred_subrvvmf4hi_reverse_scalar */

            case 13:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7626; /* pred_subrvvm8si_reverse_scalar */

            case 14:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7627; /* pred_subrvvm4si_reverse_scalar */

            case 15:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7628; /* pred_subrvvm2si_reverse_scalar */

            case 16:
              if (!
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7629; /* pred_subrvvm1si_reverse_scalar */

            case 17:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7630; /* pred_subrvvmf2si_reverse_scalar */

            case 18:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7631; /* pred_subv1qi_reverse_scalar */

            case 19:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7632; /* pred_subv2qi_reverse_scalar */

            case 20:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7633; /* pred_subv4qi_reverse_scalar */

            case 21:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7634; /* pred_subv8qi_reverse_scalar */

            case 22:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7635; /* pred_subv16qi_reverse_scalar */

            case 23:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7636; /* pred_subv32qi_reverse_scalar */

            case 24:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7637; /* pred_subv64qi_reverse_scalar */

            case 25:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7638; /* pred_subv128qi_reverse_scalar */

            case 26:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7639; /* pred_subv256qi_reverse_scalar */

            case 27:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7640; /* pred_subv512qi_reverse_scalar */

            case 28:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7641; /* pred_subv1024qi_reverse_scalar */

            case 29:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7642; /* pred_subv2048qi_reverse_scalar */

            case 30:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7643; /* pred_subv4096qi_reverse_scalar */

            case 31:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7644; /* pred_subv1hi_reverse_scalar */

            case 32:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7645; /* pred_subv2hi_reverse_scalar */

            case 33:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7646; /* pred_subv4hi_reverse_scalar */

            case 34:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7647; /* pred_subv8hi_reverse_scalar */

            case 35:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7648; /* pred_subv16hi_reverse_scalar */

            case 36:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7649; /* pred_subv32hi_reverse_scalar */

            case 37:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7650; /* pred_subv64hi_reverse_scalar */

            case 38:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7651; /* pred_subv128hi_reverse_scalar */

            case 39:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7652; /* pred_subv256hi_reverse_scalar */

            case 40:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7653; /* pred_subv512hi_reverse_scalar */

            case 41:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7654; /* pred_subv1024hi_reverse_scalar */

            case 42:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7655; /* pred_subv2048hi_reverse_scalar */

            case 43:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7656; /* pred_subv1si_reverse_scalar */

            case 44:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7657; /* pred_subv2si_reverse_scalar */

            case 45:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7658; /* pred_subv4si_reverse_scalar */

            case 46:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7659; /* pred_subv8si_reverse_scalar */

            case 47:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7660; /* pred_subv16si_reverse_scalar */

            case 48:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7661; /* pred_subv32si_reverse_scalar */

            case 49:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7662; /* pred_subv64si_reverse_scalar */

            case 50:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7663; /* pred_subv128si_reverse_scalar */

            case 51:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7664; /* pred_subv256si_reverse_scalar */

            case 52:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7665; /* pred_subv512si_reverse_scalar */

            case 53:
              if (!(
#line 2823 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7666; /* pred_subv1024si_reverse_scalar */

            case 54:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8059; /* *pred_subrvvm8di_reverse_scalar */

            case 55:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8060; /* *pred_subrvvm4di_reverse_scalar */

            case 56:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8061; /* *pred_subrvvm2di_reverse_scalar */

            case 57:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8062; /* *pred_subrvvm1di_reverse_scalar */

            case 58:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8063; /* *pred_subv1di_reverse_scalar */

            case 59:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8064; /* *pred_subv2di_reverse_scalar */

            case 60:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8065; /* *pred_subv4di_reverse_scalar */

            case 61:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8066; /* *pred_subv8di_reverse_scalar */

            case 62:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8067; /* *pred_subv16di_reverse_scalar */

            case 63:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8068; /* *pred_subv32di_reverse_scalar */

            case 64:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8069; /* *pred_subv64di_reverse_scalar */

            case 65:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8070; /* *pred_subv128di_reverse_scalar */

            case 66:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8071; /* *pred_subv256di_reverse_scalar */

            case 67:
              if (!(
#line 3031 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8072; /* *pred_subv512di_reverse_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern491 (x2))
            {
            case 0:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8073; /* *pred_subrvvm8di_extended_reverse_scalar */

            case 1:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8074; /* *pred_subrvvm4di_extended_reverse_scalar */

            case 2:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8075; /* *pred_subrvvm2di_extended_reverse_scalar */

            case 3:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8076; /* *pred_subrvvm1di_extended_reverse_scalar */

            case 4:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8077; /* *pred_subv1di_extended_reverse_scalar */

            case 5:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8078; /* *pred_subv2di_extended_reverse_scalar */

            case 6:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8079; /* *pred_subv4di_extended_reverse_scalar */

            case 7:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8080; /* *pred_subv8di_extended_reverse_scalar */

            case 8:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8081; /* *pred_subv16di_extended_reverse_scalar */

            case 9:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8082; /* *pred_subv32di_extended_reverse_scalar */

            case 10:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8083; /* *pred_subv64di_extended_reverse_scalar */

            case 11:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8084; /* *pred_subv128di_extended_reverse_scalar */

            case 12:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8085; /* *pred_subv256di_extended_reverse_scalar */

            case 13:
              if (!(
#line 3053 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8086; /* *pred_subv512di_extended_reverse_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_839 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern535 (x2, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9304; /* pred_dual_widen_suburvvm8hi */

        case 1:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9310; /* pred_dual_widen_suburvvm4hi */

        case 2:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9316; /* pred_dual_widen_suburvvm2hi */

        case 3:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9322; /* pred_dual_widen_suburvvm1hi */

        case 4:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9328; /* pred_dual_widen_suburvvmf2hi */

        case 5:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9334; /* pred_dual_widen_suburvvmf4hi */

        case 6:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9340; /* pred_dual_widen_suburvvm8si */

        case 7:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9346; /* pred_dual_widen_suburvvm4si */

        case 8:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9352; /* pred_dual_widen_suburvvm2si */

        case 9:
          if (!
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9358; /* pred_dual_widen_suburvvm1si */

        case 10:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9364; /* pred_dual_widen_suburvvmf2si */

        case 11:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9370; /* pred_dual_widen_suburvvm8di */

        case 12:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9376; /* pred_dual_widen_suburvvm4di */

        case 13:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9382; /* pred_dual_widen_suburvvm2di */

        case 14:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9388; /* pred_dual_widen_suburvvm1di */

        case 15:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9394; /* pred_dual_widen_subuv1hi */

        case 16:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9400; /* pred_dual_widen_subuv2hi */

        case 17:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9406; /* pred_dual_widen_subuv4hi */

        case 18:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9412; /* pred_dual_widen_subuv8hi */

        case 19:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9418; /* pred_dual_widen_subuv16hi */

        case 20:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9424; /* pred_dual_widen_subuv32hi */

        case 21:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9430; /* pred_dual_widen_subuv64hi */

        case 22:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9436; /* pred_dual_widen_subuv128hi */

        case 23:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9442; /* pred_dual_widen_subuv256hi */

        case 24:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9448; /* pred_dual_widen_subuv512hi */

        case 25:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9454; /* pred_dual_widen_subuv1024hi */

        case 26:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9460; /* pred_dual_widen_subuv2048hi */

        case 27:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9466; /* pred_dual_widen_subuv1si */

        case 28:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9472; /* pred_dual_widen_subuv2si */

        case 29:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9478; /* pred_dual_widen_subuv4si */

        case 30:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9484; /* pred_dual_widen_subuv8si */

        case 31:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9490; /* pred_dual_widen_subuv16si */

        case 32:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9496; /* pred_dual_widen_subuv32si */

        case 33:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9502; /* pred_dual_widen_subuv64si */

        case 34:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9508; /* pred_dual_widen_subuv128si */

        case 35:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9514; /* pred_dual_widen_subuv256si */

        case 36:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9520; /* pred_dual_widen_subuv512si */

        case 37:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9526; /* pred_dual_widen_subuv1024si */

        case 38:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9532; /* pred_dual_widen_subuv1di */

        case 39:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9538; /* pred_dual_widen_subuv2di */

        case 40:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9544; /* pred_dual_widen_subuv4di */

        case 41:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9550; /* pred_dual_widen_subuv8di */

        case 42:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9556; /* pred_dual_widen_subuv16di */

        case 43:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9562; /* pred_dual_widen_subuv32di */

        case 44:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9568; /* pred_dual_widen_subuv64di */

        case 45:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9574; /* pred_dual_widen_subuv128di */

        case 46:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9580; /* pred_dual_widen_subuv256di */

        case 47:
          if (!(
#line 4005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9586; /* pred_dual_widen_subuv512di */

        case 48:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9592; /* pred_dual_widen_suburvvm8hi_scalar */

        case 49:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9598; /* pred_dual_widen_suburvvm4hi_scalar */

        case 50:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9604; /* pred_dual_widen_suburvvm2hi_scalar */

        case 51:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9610; /* pred_dual_widen_suburvvm1hi_scalar */

        case 52:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9616; /* pred_dual_widen_suburvvmf2hi_scalar */

        case 53:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9622; /* pred_dual_widen_suburvvmf4hi_scalar */

        case 54:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9628; /* pred_dual_widen_suburvvm8si_scalar */

        case 55:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9634; /* pred_dual_widen_suburvvm4si_scalar */

        case 56:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9640; /* pred_dual_widen_suburvvm2si_scalar */

        case 57:
          if (!
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9646; /* pred_dual_widen_suburvvm1si_scalar */

        case 58:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9652; /* pred_dual_widen_suburvvmf2si_scalar */

        case 59:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9658; /* pred_dual_widen_suburvvm8di_scalar */

        case 60:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9664; /* pred_dual_widen_suburvvm4di_scalar */

        case 61:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9670; /* pred_dual_widen_suburvvm2di_scalar */

        case 62:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9676; /* pred_dual_widen_suburvvm1di_scalar */

        case 63:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9682; /* pred_dual_widen_subuv1hi_scalar */

        case 64:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9688; /* pred_dual_widen_subuv2hi_scalar */

        case 65:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9694; /* pred_dual_widen_subuv4hi_scalar */

        case 66:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9700; /* pred_dual_widen_subuv8hi_scalar */

        case 67:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9706; /* pred_dual_widen_subuv16hi_scalar */

        case 68:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9712; /* pred_dual_widen_subuv32hi_scalar */

        case 69:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9718; /* pred_dual_widen_subuv64hi_scalar */

        case 70:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9724; /* pred_dual_widen_subuv128hi_scalar */

        case 71:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9730; /* pred_dual_widen_subuv256hi_scalar */

        case 72:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9736; /* pred_dual_widen_subuv512hi_scalar */

        case 73:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9742; /* pred_dual_widen_subuv1024hi_scalar */

        case 74:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9748; /* pred_dual_widen_subuv2048hi_scalar */

        case 75:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9754; /* pred_dual_widen_subuv1si_scalar */

        case 76:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9760; /* pred_dual_widen_subuv2si_scalar */

        case 77:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9766; /* pred_dual_widen_subuv4si_scalar */

        case 78:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9772; /* pred_dual_widen_subuv8si_scalar */

        case 79:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9778; /* pred_dual_widen_subuv16si_scalar */

        case 80:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9784; /* pred_dual_widen_subuv32si_scalar */

        case 81:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9790; /* pred_dual_widen_subuv64si_scalar */

        case 82:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9796; /* pred_dual_widen_subuv128si_scalar */

        case 83:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9802; /* pred_dual_widen_subuv256si_scalar */

        case 84:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9808; /* pred_dual_widen_subuv512si_scalar */

        case 85:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9814; /* pred_dual_widen_subuv1024si_scalar */

        case 86:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9820; /* pred_dual_widen_subuv1di_scalar */

        case 87:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9826; /* pred_dual_widen_subuv2di_scalar */

        case 88:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9832; /* pred_dual_widen_subuv4di_scalar */

        case 89:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9838; /* pred_dual_widen_subuv8di_scalar */

        case 90:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9844; /* pred_dual_widen_subuv16di_scalar */

        case 91:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9850; /* pred_dual_widen_subuv32di_scalar */

        case 92:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9856; /* pred_dual_widen_subuv64di_scalar */

        case 93:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9862; /* pred_dual_widen_subuv128di_scalar */

        case 94:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9868; /* pred_dual_widen_subuv256di_scalar */

        case 95:
          if (!(
#line 4028 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9874; /* pred_dual_widen_subuv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_905 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern492 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5500; /* pred_iorrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5517; /* pred_iorrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5534; /* pred_iorrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5551; /* pred_iorrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5568; /* pred_iorrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5585; /* pred_iorrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5602; /* pred_iorrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5619; /* pred_iorrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5636; /* pred_iorrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5653; /* pred_iorrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5670; /* pred_iorrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5687; /* pred_iorrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5704; /* pred_iorrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5721; /* pred_iorrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5738; /* pred_iorrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5755; /* pred_iorrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5772; /* pred_iorrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5789; /* pred_iorrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5806; /* pred_iorrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5823; /* pred_iorrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5840; /* pred_iorrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5857; /* pred_iorrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5874; /* pred_iorv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5891; /* pred_iorv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5908; /* pred_iorv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5925; /* pred_iorv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5942; /* pred_iorv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5959; /* pred_iorv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5976; /* pred_iorv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5993; /* pred_iorv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6010; /* pred_iorv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6027; /* pred_iorv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6044; /* pred_iorv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6061; /* pred_iorv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6078; /* pred_iorv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6095; /* pred_iorv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6112; /* pred_iorv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6129; /* pred_iorv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6146; /* pred_iorv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6163; /* pred_iorv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6180; /* pred_iorv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6197; /* pred_iorv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6214; /* pred_iorv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6231; /* pred_iorv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6248; /* pred_iorv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6265; /* pred_iorv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6282; /* pred_iorv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6299; /* pred_iorv1si */

    case 48:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6316; /* pred_iorv2si */

    case 49:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6333; /* pred_iorv4si */

    case 50:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6350; /* pred_iorv8si */

    case 51:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6367; /* pred_iorv16si */

    case 52:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6384; /* pred_iorv32si */

    case 53:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6401; /* pred_iorv64si */

    case 54:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6418; /* pred_iorv128si */

    case 55:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6435; /* pred_iorv256si */

    case 56:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6452; /* pred_iorv512si */

    case 57:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6469; /* pred_iorv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6486; /* pred_iorv1di */

    case 59:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6503; /* pred_iorv2di */

    case 60:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6520; /* pred_iorv4di */

    case 61:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6537; /* pred_iorv8di */

    case 62:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6554; /* pred_iorv16di */

    case 63:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6571; /* pred_iorv32di */

    case 64:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6588; /* pred_iorv64di */

    case 65:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6605; /* pred_iorv128di */

    case 66:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6622; /* pred_iorv256di */

    case 67:
      if (!(
#line 2723 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6639; /* pred_iorv512di */

    case 68:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6859; /* pred_iorrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6868; /* pred_iorrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6877; /* pred_iorrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6886; /* pred_iorrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6895; /* pred_iorrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6904; /* pred_iorrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6913; /* pred_iorrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6922; /* pred_iorrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6931; /* pred_iorrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6940; /* pred_iorrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6949; /* pred_iorrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6958; /* pred_iorrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6967; /* pred_iorrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6976; /* pred_iorrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6985; /* pred_iorrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6994; /* pred_iorrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7003; /* pred_iorrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7012; /* pred_iorrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7021; /* pred_iorv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7030; /* pred_iorv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7039; /* pred_iorv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7048; /* pred_iorv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7057; /* pred_iorv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7066; /* pred_iorv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7075; /* pred_iorv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7084; /* pred_iorv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7093; /* pred_iorv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7102; /* pred_iorv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7111; /* pred_iorv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7120; /* pred_iorv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7129; /* pred_iorv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7138; /* pred_iorv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7147; /* pred_iorv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7156; /* pred_iorv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7165; /* pred_iorv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7174; /* pred_iorv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7183; /* pred_iorv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7192; /* pred_iorv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7201; /* pred_iorv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7210; /* pred_iorv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7219; /* pred_iorv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7228; /* pred_iorv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7237; /* pred_iorv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7246; /* pred_iorv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7255; /* pred_iorv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7264; /* pred_iorv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7273; /* pred_iorv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7282; /* pred_iorv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7291; /* pred_iorv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7300; /* pred_iorv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7309; /* pred_iorv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7318; /* pred_iorv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7327; /* pred_iorv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7336; /* pred_iorv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7669; /* *pred_iorrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7678; /* *pred_iorrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7687; /* *pred_iorrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7696; /* *pred_iorrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7705; /* *pred_iorv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7714; /* *pred_iorv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7723; /* *pred_iorv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7732; /* *pred_iorv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7741; /* *pred_iorv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7750; /* *pred_iorv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7759; /* *pred_iorv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7768; /* *pred_iorv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7777; /* *pred_iorv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7786; /* *pred_iorv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7795; /* *pred_iorrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7804; /* *pred_iorrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7813; /* *pred_iorrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7822; /* *pred_iorrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7831; /* *pred_iorv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7840; /* *pred_iorv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7849; /* *pred_iorv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7858; /* *pred_iorv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7867; /* *pred_iorv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7876; /* *pred_iorv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7885; /* *pred_iorv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7894; /* *pred_iorv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7903; /* *pred_iorv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7912; /* *pred_iorv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_916 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern505 (x2))
    {
    case 0:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9118; /* pred_zero_extendrvvm8hi_vf2 */

    case 1:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9120; /* pred_zero_extendrvvm4hi_vf2 */

    case 2:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9122; /* pred_zero_extendrvvm2hi_vf2 */

    case 3:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9124; /* pred_zero_extendrvvm1hi_vf2 */

    case 4:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9126; /* pred_zero_extendrvvmf2hi_vf2 */

    case 5:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9128; /* pred_zero_extendrvvmf4hi_vf2 */

    case 6:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9130; /* pred_zero_extendrvvm8si_vf2 */

    case 7:
      if (!
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9214; /* pred_zero_extendrvvm8si_vf4 */

    case 8:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9132; /* pred_zero_extendrvvm4si_vf2 */

    case 9:
      if (!
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9216; /* pred_zero_extendrvvm4si_vf4 */

    case 10:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9134; /* pred_zero_extendrvvm2si_vf2 */

    case 11:
      if (!
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9218; /* pred_zero_extendrvvm2si_vf4 */

    case 12:
      if (!
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9136; /* pred_zero_extendrvvm1si_vf2 */

    case 13:
      if (!
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9220; /* pred_zero_extendrvvm1si_vf4 */

    case 14:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9138; /* pred_zero_extendrvvmf2si_vf2 */

    case 15:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9222; /* pred_zero_extendrvvmf2si_vf4 */

    case 16:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9140; /* pred_zero_extendrvvm8di_vf2 */

    case 17:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9224; /* pred_zero_extendrvvm8di_vf4 */

    case 18:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9274; /* pred_zero_extendrvvm8di_vf8 */

    case 19:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9142; /* pred_zero_extendrvvm4di_vf2 */

    case 20:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9226; /* pred_zero_extendrvvm4di_vf4 */

    case 21:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9276; /* pred_zero_extendrvvm4di_vf8 */

    case 22:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9144; /* pred_zero_extendrvvm2di_vf2 */

    case 23:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9228; /* pred_zero_extendrvvm2di_vf4 */

    case 24:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9278; /* pred_zero_extendrvvm2di_vf8 */

    case 25:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9146; /* pred_zero_extendrvvm1di_vf2 */

    case 26:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9230; /* pred_zero_extendrvvm1di_vf4 */

    case 27:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9280; /* pred_zero_extendrvvm1di_vf8 */

    case 28:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9148; /* pred_zero_extendv1hi_vf2 */

    case 29:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9150; /* pred_zero_extendv2hi_vf2 */

    case 30:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9152; /* pred_zero_extendv4hi_vf2 */

    case 31:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9154; /* pred_zero_extendv8hi_vf2 */

    case 32:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9156; /* pred_zero_extendv16hi_vf2 */

    case 33:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9158; /* pred_zero_extendv32hi_vf2 */

    case 34:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9160; /* pred_zero_extendv64hi_vf2 */

    case 35:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9162; /* pred_zero_extendv128hi_vf2 */

    case 36:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9164; /* pred_zero_extendv256hi_vf2 */

    case 37:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9166; /* pred_zero_extendv512hi_vf2 */

    case 38:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9168; /* pred_zero_extendv1024hi_vf2 */

    case 39:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9170; /* pred_zero_extendv2048hi_vf2 */

    case 40:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9172; /* pred_zero_extendv1si_vf2 */

    case 41:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9232; /* pred_zero_extendv1si_vf4 */

    case 42:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9174; /* pred_zero_extendv2si_vf2 */

    case 43:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9234; /* pred_zero_extendv2si_vf4 */

    case 44:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9176; /* pred_zero_extendv4si_vf2 */

    case 45:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9236; /* pred_zero_extendv4si_vf4 */

    case 46:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9178; /* pred_zero_extendv8si_vf2 */

    case 47:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9238; /* pred_zero_extendv8si_vf4 */

    case 48:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9180; /* pred_zero_extendv16si_vf2 */

    case 49:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9240; /* pred_zero_extendv16si_vf4 */

    case 50:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9182; /* pred_zero_extendv32si_vf2 */

    case 51:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9242; /* pred_zero_extendv32si_vf4 */

    case 52:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9184; /* pred_zero_extendv64si_vf2 */

    case 53:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9244; /* pred_zero_extendv64si_vf4 */

    case 54:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9186; /* pred_zero_extendv128si_vf2 */

    case 55:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9246; /* pred_zero_extendv128si_vf4 */

    case 56:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9188; /* pred_zero_extendv256si_vf2 */

    case 57:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9248; /* pred_zero_extendv256si_vf4 */

    case 58:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9190; /* pred_zero_extendv512si_vf2 */

    case 59:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9250; /* pred_zero_extendv512si_vf4 */

    case 60:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9192; /* pred_zero_extendv1024si_vf2 */

    case 61:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9252; /* pred_zero_extendv1024si_vf4 */

    case 62:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9194; /* pred_zero_extendv1di_vf2 */

    case 63:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9254; /* pred_zero_extendv1di_vf4 */

    case 64:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1154 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9282; /* pred_zero_extendv1di_vf8 */

    case 65:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9196; /* pred_zero_extendv2di_vf2 */

    case 66:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9256; /* pred_zero_extendv2di_vf4 */

    case 67:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9284; /* pred_zero_extendv2di_vf8 */

    case 68:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9198; /* pred_zero_extendv4di_vf2 */

    case 69:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9258; /* pred_zero_extendv4di_vf4 */

    case 70:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9286; /* pred_zero_extendv4di_vf8 */

    case 71:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9200; /* pred_zero_extendv8di_vf2 */

    case 72:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9260; /* pred_zero_extendv8di_vf4 */

    case 73:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9288; /* pred_zero_extendv8di_vf8 */

    case 74:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9202; /* pred_zero_extendv16di_vf2 */

    case 75:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9262; /* pred_zero_extendv16di_vf4 */

    case 76:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1158 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9290; /* pred_zero_extendv16di_vf8 */

    case 77:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9204; /* pred_zero_extendv32di_vf2 */

    case 78:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9264; /* pred_zero_extendv32di_vf4 */

    case 79:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9292; /* pred_zero_extendv32di_vf8 */

    case 80:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9206; /* pred_zero_extendv64di_vf2 */

    case 81:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9266; /* pred_zero_extendv64di_vf4 */

    case 82:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9294; /* pred_zero_extendv64di_vf8 */

    case 83:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9208; /* pred_zero_extendv128di_vf2 */

    case 84:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9268; /* pred_zero_extendv128di_vf4 */

    case 85:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9296; /* pred_zero_extendv128di_vf8 */

    case 86:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9210; /* pred_zero_extendv256di_vf2 */

    case 87:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9270; /* pred_zero_extendv256di_vf4 */

    case 88:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9298; /* pred_zero_extendv256di_vf8 */

    case 89:
      if (!(
#line 3942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9212; /* pred_zero_extendv512di_vf2 */

    case 90:
      if (!(
#line 3962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9272; /* pred_zero_extendv512di_vf4 */

    case 91:
      if (!(
#line 3982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9300; /* pred_zero_extendv512di_vf8 */

    default:
      return -1;
    }
}

 int
recog_928 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern478 (x2, 
191))
    {
    case 0:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2216; /* pred_indexed_load_widthwurvvm8qi */

    case 1:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2222; /* pred_indexed_load_widthwurvvm4qi */

    case 2:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2228; /* pred_indexed_load_widthwurvvm2qi */

    case 3:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2234; /* pred_indexed_load_widthwurvvm1qi */

    case 4:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2240; /* pred_indexed_load_widthwurvvm8hi */

    case 5:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2246; /* pred_indexed_load_widthwurvvm4hi */

    case 6:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2252; /* pred_indexed_load_widthwurvvm2hi */

    case 7:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2258; /* pred_indexed_load_widthwurvvm1hi */

    case 8:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2264; /* pred_indexed_load_widthwurvvm8si */

    case 9:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2270; /* pred_indexed_load_widthwurvvm4si */

    case 10:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2276; /* pred_indexed_load_widthwurvvm2si */

    case 11:
      if (!
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2282; /* pred_indexed_load_widthwurvvm1si */

    case 12:
      if (!(
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2288; /* pred_indexed_load_widthwurvvm8di */

    case 13:
      if (!(
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2294; /* pred_indexed_load_widthwurvvm4di */

    case 14:
      if (!(
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2300; /* pred_indexed_load_widthwurvvm2di */

    case 15:
      if (!(
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2306; /* pred_indexed_load_widthwurvvm1di */

    case 16:
      if (!(
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2312; /* pred_indexed_load_widthwurvvmf8qi */

    case 17:
      if (!(
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2318; /* pred_indexed_load_widthwurvvmf4hi */

    case 18:
      if (!(
#line 310 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2324; /* pred_indexed_load_widthwurvvmf2si */

    default:
      return -1;
    }
}

 int
recog_931 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern722 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11409; /* pred_smulrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11885; /* pred_smulrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11416; /* pred_smulrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11890; /* pred_smulrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11423; /* pred_smulrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11895; /* pred_smulrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11430; /* pred_smulrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11900; /* pred_smulrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11437; /* pred_smulrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11920; /* pred_smulrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11444; /* pred_smulrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11925; /* pred_smulrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11451; /* pred_smulrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11930; /* pred_smulrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11458; /* pred_smulrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11935; /* pred_smulrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11465; /* pred_smulrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11950; /* pred_smulrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11472; /* pred_smulrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11955; /* pred_smulrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11479; /* pred_smulrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11960; /* pred_smulrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11486; /* pred_smulrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11965; /* pred_smulrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11493; /* pred_smulrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12199; /* *pred_smulrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11500; /* pred_smulrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12204; /* *pred_smulrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11507; /* pred_smulrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12209; /* *pred_smulrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11514; /* pred_smulrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12214; /* *pred_smulrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11521; /* pred_smulrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11905; /* pred_smulrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11528; /* pred_smulrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11910; /* pred_smulrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11535; /* pred_smulrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11915; /* pred_smulrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11542; /* pred_smulrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11940; /* pred_smulrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11549; /* pred_smulrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11945; /* pred_smulrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11556; /* pred_smulrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11970; /* pred_smulrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11563; /* pred_smulv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11975; /* pred_smulv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11570; /* pred_smulv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11980; /* pred_smulv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11577; /* pred_smulv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11985; /* pred_smulv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11584; /* pred_smulv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11990; /* pred_smulv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11591; /* pred_smulv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11995; /* pred_smulv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11598; /* pred_smulv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12000; /* pred_smulv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11605; /* pred_smulv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12005; /* pred_smulv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11612; /* pred_smulv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12010; /* pred_smulv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11619; /* pred_smulv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12015; /* pred_smulv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11626; /* pred_smulv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12020; /* pred_smulv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11633; /* pred_smulv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12025; /* pred_smulv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11640; /* pred_smulv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12030; /* pred_smulv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11647; /* pred_smulv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12035; /* pred_smulv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11654; /* pred_smulv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12040; /* pred_smulv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11661; /* pred_smulv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12045; /* pred_smulv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11668; /* pred_smulv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12050; /* pred_smulv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11675; /* pred_smulv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12055; /* pred_smulv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11682; /* pred_smulv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12060; /* pred_smulv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11689; /* pred_smulv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12065; /* pred_smulv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11696; /* pred_smulv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12070; /* pred_smulv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11703; /* pred_smulv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12075; /* pred_smulv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11710; /* pred_smulv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12080; /* pred_smulv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11717; /* pred_smulv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12085; /* pred_smulv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11724; /* pred_smulv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12090; /* pred_smulv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11731; /* pred_smulv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12095; /* pred_smulv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11738; /* pred_smulv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12100; /* pred_smulv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11745; /* pred_smulv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12105; /* pred_smulv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11752; /* pred_smulv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12110; /* pred_smulv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11759; /* pred_smulv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12115; /* pred_smulv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11766; /* pred_smulv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12120; /* pred_smulv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11773; /* pred_smulv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12125; /* pred_smulv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11780; /* pred_smulv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12130; /* pred_smulv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11787; /* pred_smulv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12135; /* pred_smulv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11794; /* pred_smulv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12140; /* pred_smulv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11801; /* pred_smulv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12145; /* pred_smulv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11808; /* pred_smulv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12150; /* pred_smulv1024si_scalar */

    case 58:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11815; /* pred_smulv1di */

    case 59:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11822; /* pred_smulv2di */

    case 60:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11829; /* pred_smulv4di */

    case 61:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11836; /* pred_smulv8di */

    case 62:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11843; /* pred_smulv16di */

    case 63:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11850; /* pred_smulv32di */

    case 64:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11857; /* pred_smulv64di */

    case 65:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11864; /* pred_smulv128di */

    case 66:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11871; /* pred_smulv256di */

    case 67:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11878; /* pred_smulv512di */

    case 68:
      if (!(
#line 4679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12219; /* *pred_smulrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12224; /* *pred_smulrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12229; /* *pred_smulrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4679 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12234; /* *pred_smulrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_938 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern723 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11411; /* pred_ssrarvvm8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12152; /* pred_ssrarvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11418; /* pred_ssrarvvm4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12154; /* pred_ssrarvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11425; /* pred_ssrarvvm2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12156; /* pred_ssrarvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11432; /* pred_ssrarvvm1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12158; /* pred_ssrarvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11439; /* pred_ssrarvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12160; /* pred_ssrarvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11446; /* pred_ssrarvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12162; /* pred_ssrarvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11453; /* pred_ssrarvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12164; /* pred_ssrarvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11460; /* pred_ssrarvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12166; /* pred_ssrarvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11467; /* pred_ssrarvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12168; /* pred_ssrarvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11474; /* pred_ssrarvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12170; /* pred_ssrarvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11481; /* pred_ssrarvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12172; /* pred_ssrarvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11488; /* pred_ssrarvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12174; /* pred_ssrarvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11495; /* pred_ssrarvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12176; /* pred_ssrarvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11502; /* pred_ssrarvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12178; /* pred_ssrarvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11509; /* pred_ssrarvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12180; /* pred_ssrarvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11516; /* pred_ssrarvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12182; /* pred_ssrarvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11523; /* pred_ssrarvvmf2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12184; /* pred_ssrarvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11530; /* pred_ssrarvvmf4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12186; /* pred_ssrarvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11537; /* pred_ssrarvvmf8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12188; /* pred_ssrarvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11544; /* pred_ssrarvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12190; /* pred_ssrarvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11551; /* pred_ssrarvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12192; /* pred_ssrarvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11558; /* pred_ssrarvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12194; /* pred_ssrarvvmf2si_scalar */

    case 22:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11565; /* pred_ssrav1qi */

    case 23:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11572; /* pred_ssrav2qi */

    case 24:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11579; /* pred_ssrav4qi */

    case 25:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11586; /* pred_ssrav8qi */

    case 26:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11593; /* pred_ssrav16qi */

    case 27:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11600; /* pred_ssrav32qi */

    case 28:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11607; /* pred_ssrav64qi */

    case 29:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11614; /* pred_ssrav128qi */

    case 30:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11621; /* pred_ssrav256qi */

    case 31:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11628; /* pred_ssrav512qi */

    case 32:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11635; /* pred_ssrav1024qi */

    case 33:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11642; /* pred_ssrav2048qi */

    case 34:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11649; /* pred_ssrav4096qi */

    case 35:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11656; /* pred_ssrav1hi */

    case 36:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11663; /* pred_ssrav2hi */

    case 37:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11670; /* pred_ssrav4hi */

    case 38:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11677; /* pred_ssrav8hi */

    case 39:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11684; /* pred_ssrav16hi */

    case 40:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11691; /* pred_ssrav32hi */

    case 41:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11698; /* pred_ssrav64hi */

    case 42:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11705; /* pred_ssrav128hi */

    case 43:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11712; /* pred_ssrav256hi */

    case 44:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11719; /* pred_ssrav512hi */

    case 45:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11726; /* pred_ssrav1024hi */

    case 46:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11733; /* pred_ssrav2048hi */

    case 47:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11740; /* pred_ssrav1si */

    case 48:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11747; /* pred_ssrav2si */

    case 49:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11754; /* pred_ssrav4si */

    case 50:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11761; /* pred_ssrav8si */

    case 51:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11768; /* pred_ssrav16si */

    case 52:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11775; /* pred_ssrav32si */

    case 53:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11782; /* pred_ssrav64si */

    case 54:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11789; /* pred_ssrav128si */

    case 55:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11796; /* pred_ssrav256si */

    case 56:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11803; /* pred_ssrav512si */

    case 57:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11810; /* pred_ssrav1024si */

    case 58:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11817; /* pred_ssrav1di */

    case 59:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11824; /* pred_ssrav2di */

    case 60:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11831; /* pred_ssrav4di */

    case 61:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11838; /* pred_ssrav8di */

    case 62:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11845; /* pred_ssrav16di */

    case 63:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11852; /* pred_ssrav32di */

    case 64:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11859; /* pred_ssrav64di */

    case 65:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11866; /* pred_ssrav128di */

    case 66:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11873; /* pred_ssrav256di */

    case 67:
      if (!(
#line 4553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11880; /* pred_ssrav512di */

    default:
      return -1;
    }
}

 int
recog_1028 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_955 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15382; /* *pred_maddv2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15478; /* *pred_maccv2hf */
}

 int
recog_1034 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_949 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return 15370; /* *pred_maddrvvmf2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15466; /* *pred_maccrvvmf2sf */
}

 int
recog_1040 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_943 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15358; /* *pred_maddrvvmf2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15454; /* *pred_maccrvvmf2hf */
}

 int
recog_1047 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15738; /* *pred_mul_neg_addrvvm2hf_undef */
}

 int
recog_1055 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15754; /* *pred_mul_neg_addrvvmf2sf_undef */
}

 int
recog_1063 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15770; /* *pred_mul_neg_addv8hf_undef */
}

 int
recog_1071 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15786; /* *pred_mul_neg_addv2048hf_undef */
}

 int
recog_1080 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15804; /* *pred_mul_neg_addv256sf_undef */
}

 int
recog_1089 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15822; /* *pred_mul_neg_addv64df_undef */
}

 int
recog_1099 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1086 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15912; /* *pred_nmsubv8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 16008; /* *pred_nmsacv8df */
}

 int
recog_1111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1074 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15888; /* *pred_nmsubv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15984; /* *pred_nmsacv4sf */
}

 int
recog_1120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1065 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return 15870; /* *pred_nmsubv32hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15966; /* *pred_nmsacv32hf */
}

 int
recog_1131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1054 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15848; /* *pred_nmsubrvvm1sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15944; /* *pred_nmsacrvvm1sf */
}

 int
recog_1140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1045 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15830; /* *pred_nmsubrvvm8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15926; /* *pred_nmsacrvvm8hf */
}

 int
recog_1150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15267; /* *pred_mul_subrvvm8sf_undef */
}

 int
recog_1157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15281; /* *pred_mul_subrvvm2df_undef */
}

 int
recog_1164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32HFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15295; /* *pred_mul_subv32hf_undef */
}

 int
recog_1171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15309; /* *pred_mul_subv1sf_undef */
}

 int
recog_1178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15323; /* *pred_mul_subv128sf_undef */
}

 int
recog_1185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15337; /* *pred_mul_subv8df_undef */
}

 int
recog_1192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1191 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 15445; /* *pred_msubv512df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15541; /* *pred_msacv512df */
}

 int
recog_1199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1184 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15431; /* *pred_msubv4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15527; /* *pred_msacv4df */
}

 int
recog_1206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1177 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15417; /* *pred_msubv64sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15513; /* *pred_msacv64sf */
}

 int
recog_1213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1170 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15403; /* *pred_msubv2048hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15499; /* *pred_msacv2048hf */
}

 int
recog_1220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1163 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15389; /* *pred_msubv16hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15485; /* *pred_msacv16hf */
}

 int
recog_1227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1156 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15375; /* *pred_msubrvvm4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15471; /* *pred_msacrvvm4df */
}

 int
recog_1234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1149 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return 15361; /* *pred_msubrvvmf4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15457; /* *pred_msacrvvmf4hf */
}

 int
recog_1241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15737; /* *pred_mul_neg_subrvvm4hf_undef */
}

 int
recog_1248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15751; /* *pred_mul_neg_subrvvm2sf_undef */
}

 int
recog_1255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15765; /* *pred_mul_neg_subv1hf_undef */
}

 int
recog_1262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15779; /* *pred_mul_neg_subv128hf_undef */
}

 int
recog_1269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15793; /* *pred_mul_neg_subv4sf_undef */
}

 int
recog_1276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15807; /* *pred_mul_neg_subv512sf_undef */
}

 int
recog_1283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32DFmode)
      || !(
#line 6715 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15821; /* *pred_mul_neg_subv32df_undef */
}

 int
recog_1290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1285 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15921; /* *pred_nmaddv128df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 16017; /* *pred_nmaccv128df */
}

 int
recog_1297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1278 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15907; /* *pred_nmaddv1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16003; /* *pred_nmaccv1df */
}

 int
recog_1304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1271 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15893; /* *pred_nmaddv16sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15989; /* *pred_nmaccv16sf */
}

 int
recog_1311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1264 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15879; /* *pred_nmaddv512hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15975; /* *pred_nmaccv512hf */
}

 int
recog_1318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1257 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return 15865; /* *pred_nmaddv4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15961; /* *pred_nmaccv4hf */
}

 int
recog_1326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1249 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15849; /* *pred_nmaddrvvm1sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15945; /* *pred_nmaccrvvm1sf */
}

 int
recog_1334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1241 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15833; /* *pred_nmaddrvvm4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15929; /* *pred_nmaccrvvm4hf */
}

 int
recog_1342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XVECEXP (x5, 0, 5);
      operands[9] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x3, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          switch (pattern713 (x2))
            {
            case 0:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14498; /* pred_addrvvm8hf */

            case 1:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14502; /* pred_addrvvm4hf */

            case 2:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14506; /* pred_addrvvm2hf */

            case 3:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14510; /* pred_addrvvm1hf */

            case 4:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14514; /* pred_addrvvmf2hf */

            case 5:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14518; /* pred_addrvvmf4hf */

            case 6:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14522; /* pred_addrvvm8sf */

            case 7:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14526; /* pred_addrvvm4sf */

            case 8:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14530; /* pred_addrvvm2sf */

            case 9:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14534; /* pred_addrvvm1sf */

            case 10:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14538; /* pred_addrvvmf2sf */

            case 11:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14542; /* pred_addrvvm8df */

            case 12:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14546; /* pred_addrvvm4df */

            case 13:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14550; /* pred_addrvvm2df */

            case 14:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14554; /* pred_addrvvm1df */

            case 15:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14558; /* pred_addv1hf */

            case 16:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14562; /* pred_addv2hf */

            case 17:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14566; /* pred_addv4hf */

            case 18:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14570; /* pred_addv8hf */

            case 19:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14574; /* pred_addv16hf */

            case 20:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14578; /* pred_addv32hf */

            case 21:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14582; /* pred_addv64hf */

            case 22:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14586; /* pred_addv128hf */

            case 23:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14590; /* pred_addv256hf */

            case 24:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14594; /* pred_addv512hf */

            case 25:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14598; /* pred_addv1024hf */

            case 26:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14602; /* pred_addv2048hf */

            case 27:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14606; /* pred_addv1sf */

            case 28:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14610; /* pred_addv2sf */

            case 29:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14614; /* pred_addv4sf */

            case 30:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14618; /* pred_addv8sf */

            case 31:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14622; /* pred_addv16sf */

            case 32:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14626; /* pred_addv32sf */

            case 33:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14630; /* pred_addv64sf */

            case 34:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14634; /* pred_addv128sf */

            case 35:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14638; /* pred_addv256sf */

            case 36:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14642; /* pred_addv512sf */

            case 37:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14646; /* pred_addv1024sf */

            case 38:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14650; /* pred_addv1df */

            case 39:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14654; /* pred_addv2df */

            case 40:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14658; /* pred_addv4df */

            case 41:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14662; /* pred_addv8df */

            case 42:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14666; /* pred_addv16df */

            case 43:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14670; /* pred_addv32df */

            case 44:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14674; /* pred_addv64df */

            case 45:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14678; /* pred_addv128df */

            case 46:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14682; /* pred_addv256df */

            case 47:
              if (!(
#line 6202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14686; /* pred_addv512df */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != VEC_DUPLICATE)
            return -1;
          switch (pattern734 (x2))
            {
            case 0:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16643; /* pred_single_widen_addrvvm8sf_scalar */

            case 1:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16645; /* pred_single_widen_addrvvm4sf_scalar */

            case 2:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16647; /* pred_single_widen_addrvvm2sf_scalar */

            case 3:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16649; /* pred_single_widen_addrvvm1sf_scalar */

            case 4:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 16651; /* pred_single_widen_addrvvmf2sf_scalar */

            case 5:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16653; /* pred_single_widen_addrvvm8df_scalar */

            case 6:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16655; /* pred_single_widen_addrvvm4df_scalar */

            case 7:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16657; /* pred_single_widen_addrvvm2df_scalar */

            case 8:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16659; /* pred_single_widen_addrvvm1df_scalar */

            case 9:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16661; /* pred_single_widen_addv1sf_scalar */

            case 10:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16663; /* pred_single_widen_addv2sf_scalar */

            case 11:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16665; /* pred_single_widen_addv4sf_scalar */

            case 12:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16667; /* pred_single_widen_addv8sf_scalar */

            case 13:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16669; /* pred_single_widen_addv16sf_scalar */

            case 14:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16671; /* pred_single_widen_addv32sf_scalar */

            case 15:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16673; /* pred_single_widen_addv64sf_scalar */

            case 16:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16675; /* pred_single_widen_addv128sf_scalar */

            case 17:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16677; /* pred_single_widen_addv256sf_scalar */

            case 18:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16679; /* pred_single_widen_addv512sf_scalar */

            case 19:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16681; /* pred_single_widen_addv1024sf_scalar */

            case 20:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16683; /* pred_single_widen_addv1df_scalar */

            case 21:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16685; /* pred_single_widen_addv2df_scalar */

            case 22:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16687; /* pred_single_widen_addv4df_scalar */

            case 23:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16689; /* pred_single_widen_addv8df_scalar */

            case 24:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16691; /* pred_single_widen_addv16df_scalar */

            case 25:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16693; /* pred_single_widen_addv32df_scalar */

            case 26:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16695; /* pred_single_widen_addv64df_scalar */

            case 27:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16697; /* pred_single_widen_addv128df_scalar */

            case 28:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16699; /* pred_single_widen_addv256df_scalar */

            case 29:
              if (!(
#line 7141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16701; /* pred_single_widen_addv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern581 (x2))
        {
        case 0:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14882; /* pred_addrvvm8hf_scalar */

        case 1:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14884; /* pred_addrvvm4hf_scalar */

        case 2:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14886; /* pred_addrvvm2hf_scalar */

        case 3:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14888; /* pred_addrvvm1hf_scalar */

        case 4:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14890; /* pred_addrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14892; /* pred_addrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14894; /* pred_addrvvm8sf_scalar */

        case 7:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14896; /* pred_addrvvm4sf_scalar */

        case 8:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14898; /* pred_addrvvm2sf_scalar */

        case 9:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14900; /* pred_addrvvm1sf_scalar */

        case 10:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14902; /* pred_addrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14904; /* pred_addrvvm8df_scalar */

        case 12:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14906; /* pred_addrvvm4df_scalar */

        case 13:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14908; /* pred_addrvvm2df_scalar */

        case 14:
          if (!(
#line 6268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14910; /* pred_addrvvm1df_scalar */

        default:
          return -1;
        }

    case MULT:
      return recog_1141 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_1142 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_1143 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[3], E_RVVM4QImode)
          || !vector_arith_operand (operands[4], E_RVVM4QImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12428; /* *pred_cmprvvm4qi_merge_tie_mask */

    case E_RVVM8HImode:
      if (!register_operand (operands[3], E_RVVM8HImode)
          || !vector_arith_operand (operands[4], E_RVVM8HImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12431; /* *pred_cmprvvm8hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode)
          || !vector_arith_operand (operands[4], E_RVVM2QImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12429; /* *pred_cmprvvm2qi_merge_tie_mask */

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode)
          || !vector_arith_operand (operands[4], E_RVVM4HImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12432; /* *pred_cmprvvm4hi_merge_tie_mask */

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode)
          || !vector_arith_operand (operands[4], E_RVVM8SImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12435; /* *pred_cmprvvm8si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode)
          || !vector_arith_operand (operands[4], E_RVVM1QImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12430; /* *pred_cmprvvm1qi_merge_tie_mask */

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode)
          || !vector_arith_operand (operands[4], E_RVVM2HImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12433; /* *pred_cmprvvm2hi_merge_tie_mask */

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode)
          || !vector_arith_operand (operands[4], E_RVVM4SImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12436; /* *pred_cmprvvm4si_merge_tie_mask */

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode)
          || !vector_arith_operand (operands[4], E_RVVM8DImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12439; /* *pred_cmprvvm8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HImode:
      if (!register_operand (operands[3], E_RVVM1HImode)
          || !vector_arith_operand (operands[4], E_RVVM1HImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12434; /* *pred_cmprvvm1hi_merge_tie_mask */

    case E_RVVM2SImode:
      if (!register_operand (operands[3], E_RVVM2SImode)
          || !vector_arith_operand (operands[4], E_RVVM2SImode)
          || !
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12437; /* *pred_cmprvvm2si_merge_tie_mask */

    case E_RVVM4DImode:
      if (!register_operand (operands[3], E_RVVM4DImode)
          || !vector_arith_operand (operands[4], E_RVVM4DImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12440; /* *pred_cmprvvm4di_merge_tie_mask */

    case E_RVVMF2QImode:
      if (!register_operand (operands[3], E_RVVMF2QImode)
          || !vector_arith_operand (operands[4], E_RVVMF2QImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12443; /* *pred_cmprvvmf2qi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[3], E_RVVM1DImode)
          || !vector_arith_operand (operands[4], E_RVVM1DImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12442; /* *pred_cmprvvm1di_merge_tie_mask */

    case E_RVVMF8QImode:
      if (!register_operand (operands[3], E_RVVMF8QImode)
          || !vector_arith_operand (operands[4], E_RVVMF8QImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12445; /* *pred_cmprvvmf8qi_merge_tie_mask */

    case E_RVVMF4HImode:
      if (!register_operand (operands[3], E_RVVMF4HImode)
          || !vector_arith_operand (operands[4], E_RVVMF4HImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12447; /* *pred_cmprvvmf4hi_merge_tie_mask */

    case E_RVVMF2SImode:
      if (!register_operand (operands[3], E_RVVMF2SImode)
          || !vector_arith_operand (operands[4], E_RVVMF2SImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12448; /* *pred_cmprvvmf2si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1355 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || !vector_arith_operand (operands[4], E_V4QImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12451; /* *pred_cmpv4qi_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || !vector_arith_operand (operands[4], E_V4HImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12464; /* *pred_cmpv4hi_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || !vector_arith_operand (operands[4], E_V4SImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12476; /* *pred_cmpv4si_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !vector_arith_operand (operands[4], E_V4DImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12487; /* *pred_cmpv4di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V128QImode:
      if (!register_operand (operands[3], E_V128QImode)
          || !vector_arith_operand (operands[4], E_V128QImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12456; /* *pred_cmpv128qi_merge_tie_mask */

    case E_V128HImode:
      if (!register_operand (operands[3], E_V128HImode)
          || !vector_arith_operand (operands[4], E_V128HImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12469; /* *pred_cmpv128hi_merge_tie_mask */

    case E_V128SImode:
      if (!register_operand (operands[3], E_V128SImode)
          || !vector_arith_operand (operands[4], E_V128SImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12481; /* *pred_cmpv128si_merge_tie_mask */

    case E_V128DImode:
      if (!register_operand (operands[3], E_V128DImode)
          || !vector_arith_operand (operands[4], E_V128DImode)
          || !(
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12492; /* *pred_cmpv128di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V256BImode))
    {
      res = recog_1361 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V256BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V256BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V256QImode:
      if (!register_operand (operands[4], E_V256QImode)
          || !vector_arith_operand (operands[5], E_V256QImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256QImode)) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 12525; /* *pred_cmpv256qi */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256QImode)) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12593; /* *pred_cmpv256qi_narrow */

    case E_V256HImode:
      if (!register_operand (operands[4], E_V256HImode)
          || !vector_arith_operand (operands[5], E_V256HImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256HImode)) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12538; /* *pred_cmpv256hi */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256HImode)) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12606; /* *pred_cmpv256hi_narrow */

    case E_V256SImode:
      if (!register_operand (operands[4], E_V256SImode)
          || !vector_arith_operand (operands[5], E_V256SImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256SImode)) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12550; /* *pred_cmpv256si */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256SImode)) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12618; /* *pred_cmpv256si_narrow */

    case E_V256DImode:
      if (!register_operand (operands[4], E_V256DImode)
          || !vector_arith_operand (operands[5], E_V256DImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DImode)) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12561; /* *pred_cmpv256di */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DImode)) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12629; /* *pred_cmpv256di_narrow */

    default:
      return -1;
    }
}

 int
recog_1373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern591 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) == 0
          && 
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12427; /* *pred_cmprvvm8qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern592 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0)
        return -1;
      if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12495; /* *pred_cmprvvm8qi */
      if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12563; /* *pred_cmprvvm8qi_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1347 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || !vector_arith_operand (operands[5], E_RVVM4QImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12496; /* *pred_cmprvvm4qi */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12564; /* *pred_cmprvvm4qi_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || !vector_arith_operand (operands[5], E_RVVM8HImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12499; /* *pred_cmprvvm8hi */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12567; /* *pred_cmprvvm8hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1348 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || !vector_arith_operand (operands[5], E_RVVM2QImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12497; /* *pred_cmprvvm2qi */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12565; /* *pred_cmprvvm2qi_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || !vector_arith_operand (operands[5], E_RVVM4HImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12500; /* *pred_cmprvvm4hi */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12568; /* *pred_cmprvvm4hi_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || !vector_arith_operand (operands[5], E_RVVM8SImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12503; /* *pred_cmprvvm8si */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12571; /* *pred_cmprvvm8si_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1349 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || !vector_arith_operand (operands[5], E_RVVM1QImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12498; /* *pred_cmprvvm1qi */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12566; /* *pred_cmprvvm1qi_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || !vector_arith_operand (operands[5], E_RVVM2HImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12501; /* *pred_cmprvvm2hi */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12569; /* *pred_cmprvvm2hi_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || !vector_arith_operand (operands[5], E_RVVM4SImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12504; /* *pred_cmprvvm4si */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12572; /* *pred_cmprvvm4si_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || !vector_arith_operand (operands[5], E_RVVM8DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12507; /* *pred_cmprvvm8di */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12575; /* *pred_cmprvvm8di_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1350 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || !vector_arith_operand (operands[5], E_RVVM1HImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12502; /* *pred_cmprvvm1hi */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12570; /* *pred_cmprvvm1hi_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || !vector_arith_operand (operands[5], E_RVVM2SImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12505; /* *pred_cmprvvm2si */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12573; /* *pred_cmprvvm2si_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || !vector_arith_operand (operands[5], E_RVVM4DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12508; /* *pred_cmprvvm4di */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12576; /* *pred_cmprvvm4di_narrow */

        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || !vector_arith_operand (operands[5], E_RVVMF2QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12511; /* *pred_cmprvvmf2qi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12579; /* *pred_cmprvvmf2qi_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1351 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || !vector_arith_operand (operands[5], E_RVVM1SImode))
            return -1;
          if (
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12506; /* *pred_cmprvvm1si */
          if (!
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12574; /* *pred_cmprvvm1si_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || !vector_arith_operand (operands[5], E_RVVM2DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12509; /* *pred_cmprvvm2di */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12577; /* *pred_cmprvvm2di_narrow */

        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || !vector_arith_operand (operands[5], E_RVVMF4QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12512; /* *pred_cmprvvmf4qi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12580; /* *pred_cmprvvmf4qi_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || !vector_arith_operand (operands[5], E_RVVMF2HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12514; /* *pred_cmprvvmf2hi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12582; /* *pred_cmprvvmf2hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1352 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || !vector_arith_operand (operands[5], E_RVVM1DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12510; /* *pred_cmprvvm1di */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12578; /* *pred_cmprvvm1di_narrow */

        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || !vector_arith_operand (operands[5], E_RVVMF8QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12513; /* *pred_cmprvvmf8qi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12581; /* *pred_cmprvvmf8qi_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || !vector_arith_operand (operands[5], E_RVVMF4HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12515; /* *pred_cmprvvmf4hi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12583; /* *pred_cmprvvmf4hi_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || !vector_arith_operand (operands[5], E_RVVMF2SImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12516; /* *pred_cmprvvmf2si */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12584; /* *pred_cmprvvmf2si_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1353 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1QImode:
          if (!register_operand (operands[4], E_V1QImode)
              || !vector_arith_operand (operands[5], E_V1QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1QImode)) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return 12517; /* *pred_cmpv1qi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1QImode)) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 12585; /* *pred_cmpv1qi_narrow */

        case E_V1HImode:
          if (!register_operand (operands[4], E_V1HImode)
              || !vector_arith_operand (operands[5], E_V1HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HImode)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return 12530; /* *pred_cmpv1hi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HImode)) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 12598; /* *pred_cmpv1hi_narrow */

        case E_V1SImode:
          if (!register_operand (operands[4], E_V1SImode)
              || !vector_arith_operand (operands[5], E_V1SImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SImode)) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return 12542; /* *pred_cmpv1si */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SImode)) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 12610; /* *pred_cmpv1si_narrow */

        case E_V1DImode:
          if (!register_operand (operands[4], E_V1DImode)
              || !vector_arith_operand (operands[5], E_V1DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode)) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 12553; /* *pred_cmpv1di */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode)) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12621; /* *pred_cmpv1di_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1354 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2QImode:
          if (!register_operand (operands[4], E_V2QImode)
              || !vector_arith_operand (operands[5], E_V2QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2QImode)) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return 12518; /* *pred_cmpv2qi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2QImode)) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 12586; /* *pred_cmpv2qi_narrow */

        case E_V2HImode:
          if (!register_operand (operands[4], E_V2HImode)
              || !vector_arith_operand (operands[5], E_V2HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HImode)) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return 12531; /* *pred_cmpv2hi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HImode)) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 12599; /* *pred_cmpv2hi_narrow */

        case E_V2SImode:
          if (!register_operand (operands[4], E_V2SImode)
              || !vector_arith_operand (operands[5], E_V2SImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SImode)) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return 12543; /* *pred_cmpv2si */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SImode)) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 12611; /* *pred_cmpv2si_narrow */

        case E_V2DImode:
          if (!register_operand (operands[4], E_V2DImode)
              || !vector_arith_operand (operands[5], E_V2DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode)) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 12554; /* *pred_cmpv2di */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode)) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12622; /* *pred_cmpv2di_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      return recog_1372 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1371 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1370 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1369 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1368 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1367 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1366 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1365 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1363 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || !vector_arith_operand (operands[5], E_V1024QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12527; /* *pred_cmpv1024qi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12595; /* *pred_cmpv1024qi_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || !vector_arith_operand (operands[5], E_V1024HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12540; /* *pred_cmpv1024hi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12608; /* *pred_cmpv1024hi_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || !vector_arith_operand (operands[5], E_V1024SImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12552; /* *pred_cmpv1024si */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12620; /* *pred_cmpv1024si_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1364 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || !vector_arith_operand (operands[5], E_V2048QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12528; /* *pred_cmpv2048qi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12596; /* *pred_cmpv2048qi_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || !vector_arith_operand (operands[5], E_V2048HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12541; /* *pred_cmpv2048hi */
          if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12609; /* *pred_cmpv2048hi_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern591 (x2, 
E_V4096QImode, 
E_V4096BImode) == 0
          && (
#line 4769 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12461; /* *pred_cmpv4096qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern592 (x2, 
E_V4096BImode, 
E_V4096QImode) != 0)
        return -1;
      if ((
#line 4793 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12529; /* *pred_cmpv4096qi */
      if (!(
#line 4814 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12597; /* *pred_cmpv4096qi_narrow */

    default:
      return -1;
    }
}

 int
recog_1468 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern548 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1456 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || GET_MODE (x9) != E_V16HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HFmode)) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 17154; /* *pred_cmpv16hf_scalar */
      if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HFmode)) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17202; /* *pred_cmpv16hf_scalar_narrow */

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || GET_MODE (x9) != E_V16SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SFmode)) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 17166; /* *pred_cmpv16sf_scalar */
      if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SFmode)) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17214; /* *pred_cmpv16sf_scalar_narrow */

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || GET_MODE (x9) != E_V16DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DFmode)) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 17177; /* *pred_cmpv16df_scalar */
      if (!(
#line 7440 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DFmode)) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17225; /* *pred_cmpv16df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1475 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          return recog_3 (x1, insn, pnum_clobbers);

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 2724 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && TARGET_ZFA))
            return -1;
          return 292; /* movdfsisi3_rv32 */

        default:
          return -1;
        }

    case AND:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x8;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern229 (x3, 
E_SImode) != 0
                  || !(
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 10; /* *lui_constraintsi_and_to_or */

            case E_DImode:
              if (pattern229 (x3, 
E_DImode) != 0
                  || !(
#line 883 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 11; /* *lui_constraintdi_and_to_or */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x8) != E_DImode
              || pattern283 (x3, 
E_DImode) != 0)
            return -1;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          if (!imm123_operand (operands[2], E_QImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          if (pnum_clobbers != NULL
              && consecutive_bits_operand (operands[3], E_DImode))
            {
              x5 = XEXP (x3, 1);
              operands[4] = x5;
              if (register_operand (operands[4], E_DImode)
                  && 
#line 98 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))
   && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))))
                {
                  *pnum_clobbers = 1;
                  return 511; /* *andi_add.uw */
                }
            }
          if (!immediate_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[4] = x5;
          if (!register_operand (operands[4], E_DImode)
              || !
#line 118 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && (INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff))
            return -1;
          return 512; /* *shNadduw */

        default:
          return -1;
        }

    case ASHIFT:
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_CODE (operands[3]))
        {
        case CONST_INT:
          if (pnum_clobbers == NULL
              || !const_int_operand (operands[3], E_VOIDmode)
              || pattern229 (x3, 
E_DImode) != 0
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4694 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)))
            return -1;
          *pnum_clobbers = 1;
          return 492; /* *riscv.md:4688 */

        case REG:
        case SUBREG:
          if (!imm123_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern399 (x3, 
E_SImode) != 0)
                return -1;
              if ((
#line 37 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBA) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 509; /* *shNadd */
              if (!(
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBA) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 868; /* *th_addslsi4 */

            case E_DImode:
              if (pattern399 (x3, 
E_DImode) != 0)
                return -1;
              if ((
#line 37 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBA) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 510; /* *shNadd */
              if (!(
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead.md"
(TARGET_XTHEADBA) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 869; /* *th_addsldi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_8 (x1, insn, pnum_clobbers);

    case MULT:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          return recog_4 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          return recog_6 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          return recog_7 (x1, insn, pnum_clobbers);

        case FLOAT_EXTEND:
          switch (pattern139 (x3))
            {
            case 0:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31598; /* *dual_widen_fmarvvm8sf */

            case 1:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31599; /* *dual_widen_fmarvvm4sf */

            case 2:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31600; /* *dual_widen_fmarvvm2sf */

            case 3:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31601; /* *dual_widen_fmarvvm1sf */

            case 4:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 31602; /* *dual_widen_fmarvvmf2sf */

            case 5:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31603; /* *dual_widen_fmarvvm8df */

            case 6:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31604; /* *dual_widen_fmarvvm4df */

            case 7:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31605; /* *dual_widen_fmarvvm2df */

            case 8:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31606; /* *dual_widen_fmarvvm1df */

            case 9:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31607; /* *dual_widen_fmav1sf */

            case 10:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31608; /* *dual_widen_fmav2sf */

            case 11:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31609; /* *dual_widen_fmav4sf */

            case 12:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31610; /* *dual_widen_fmav8sf */

            case 13:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31611; /* *dual_widen_fmav16sf */

            case 14:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31612; /* *dual_widen_fmav32sf */

            case 15:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31613; /* *dual_widen_fmav64sf */

            case 16:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31614; /* *dual_widen_fmav128sf */

            case 17:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31615; /* *dual_widen_fmav256sf */

            case 18:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31616; /* *dual_widen_fmav512sf */

            case 19:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 31617; /* *dual_widen_fmav1024sf */

            case 20:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31618; /* *dual_widen_fmav1df */

            case 21:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31619; /* *dual_widen_fmav2df */

            case 22:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31620; /* *dual_widen_fmav4df */

            case 23:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31621; /* *dual_widen_fmav8df */

            case 24:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31622; /* *dual_widen_fmav16df */

            case 25:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31623; /* *dual_widen_fmav32df */

            case 26:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31624; /* *dual_widen_fmav64df */

            case 27:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31625; /* *dual_widen_fmav128df */

            case 28:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31626; /* *dual_widen_fmav256df */

            case 29:
              if (!(
#line 1058 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 31627; /* *dual_widen_fmav512df */

            case 30:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31628; /* *single_widen_fmarvvm8sf */

            case 31:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31629; /* *single_widen_fmarvvm4sf */

            case 32:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31630; /* *single_widen_fmarvvm2sf */

            case 33:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31631; /* *single_widen_fmarvvm1sf */

            case 34:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 31632; /* *single_widen_fmarvvmf2sf */

            case 35:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31633; /* *single_widen_fmarvvm8df */

            case 36:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31634; /* *single_widen_fmarvvm4df */

            case 37:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31635; /* *single_widen_fmarvvm2df */

            case 38:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31636; /* *single_widen_fmarvvm1df */

            case 39:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31637; /* *single_widen_fmav1sf */

            case 40:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31638; /* *single_widen_fmav2sf */

            case 41:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31639; /* *single_widen_fmav4sf */

            case 42:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31640; /* *single_widen_fmav8sf */

            case 43:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31641; /* *single_widen_fmav16sf */

            case 44:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31642; /* *single_widen_fmav32sf */

            case 45:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31643; /* *single_widen_fmav64sf */

            case 46:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31644; /* *single_widen_fmav128sf */

            case 47:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31645; /* *single_widen_fmav256sf */

            case 48:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31646; /* *single_widen_fmav512sf */

            case 49:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 31647; /* *single_widen_fmav1024sf */

            case 50:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31648; /* *single_widen_fmav1df */

            case 51:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31649; /* *single_widen_fmav2df */

            case 52:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31650; /* *single_widen_fmav4df */

            case 53:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31651; /* *single_widen_fmav8df */

            case 54:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31652; /* *single_widen_fmav16df */

            case 55:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31653; /* *single_widen_fmav32df */

            case 56:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31654; /* *single_widen_fmav64df */

            case 57:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31655; /* *single_widen_fmav128df */

            case 58:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31656; /* *single_widen_fmav256df */

            case 59:
              if (!(
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 31657; /* *single_widen_fmav512df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FFS:
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 5
          || XINT (x8, 1) != 93)
        return -1;
      x11 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x11) != AND)
        return -1;
      x12 = XVECEXP (x8, 0, 3);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 66
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XVECEXP (x8, 0, 4);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 67
          || GET_MODE (x13) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x14 = XEXP (x11, 0);
      operands[1] = x14;
      x15 = XEXP (x11, 1);
      operands[2] = x15;
      x16 = XVECEXP (x8, 0, 1);
      operands[3] = x16;
      if (!vector_length_operand (operands[3], E_VOIDmode))
        return -1;
      x17 = XVECEXP (x8, 0, 2);
      operands[4] = x17;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern572 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
                return -1;
              return 14373; /* pred_ffsrvvmf64bisi */

            case 1:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14375; /* pred_ffsrvvmf32bisi */

            case 2:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14377; /* pred_ffsrvvmf16bisi */

            case 3:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14379; /* pred_ffsrvvmf8bisi */

            case 4:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14381; /* pred_ffsrvvmf4bisi */

            case 5:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14383; /* pred_ffsrvvmf2bisi */

            case 6:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14385; /* pred_ffsrvvm1bisi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern572 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
                return -1;
              return 14374; /* pred_ffsrvvmf64bidi */

            case 1:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14376; /* pred_ffsrvvmf32bidi */

            case 2:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14378; /* pred_ffsrvvmf16bidi */

            case 3:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14380; /* pred_ffsrvvmf8bidi */

            case 4:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14382; /* pred_ffsrvvmf4bidi */

            case 5:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14384; /* pred_ffsrvvmf2bidi */

            case 6:
              if (!(
#line 6115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14386; /* pred_ffsrvvm1bidi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_9 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      switch (pattern131 (x3))
        {
        case 0:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30914; /* *dual_widen_addrvvm8sf */

        case 1:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30917; /* *dual_widen_addrvvm4sf */

        case 2:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30920; /* *dual_widen_addrvvm2sf */

        case 3:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30923; /* *dual_widen_addrvvm1sf */

        case 4:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30926; /* *dual_widen_addrvvmf2sf */

        case 5:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30929; /* *dual_widen_addrvvm8df */

        case 6:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30932; /* *dual_widen_addrvvm4df */

        case 7:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30935; /* *dual_widen_addrvvm2df */

        case 8:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30938; /* *dual_widen_addrvvm1df */

        case 9:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30941; /* *dual_widen_addv1sf */

        case 10:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30944; /* *dual_widen_addv2sf */

        case 11:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30947; /* *dual_widen_addv4sf */

        case 12:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30950; /* *dual_widen_addv8sf */

        case 13:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30953; /* *dual_widen_addv16sf */

        case 14:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30956; /* *dual_widen_addv32sf */

        case 15:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30959; /* *dual_widen_addv64sf */

        case 16:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30962; /* *dual_widen_addv128sf */

        case 17:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30965; /* *dual_widen_addv256sf */

        case 18:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30968; /* *dual_widen_addv512sf */

        case 19:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30971; /* *dual_widen_addv1024sf */

        case 20:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30974; /* *dual_widen_addv1df */

        case 21:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30977; /* *dual_widen_addv2df */

        case 22:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30980; /* *dual_widen_addv4df */

        case 23:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30983; /* *dual_widen_addv8df */

        case 24:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30986; /* *dual_widen_addv16df */

        case 25:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30989; /* *dual_widen_addv32df */

        case 26:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30992; /* *dual_widen_addv64df */

        case 27:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30995; /* *dual_widen_addv128df */

        case 28:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30998; /* *dual_widen_addv256df */

        case 29:
          if (!(
#line 758 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31001; /* *dual_widen_addv512df */

        case 30:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31004; /* *single_widen_addrvvm8sf */

        case 31:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31005; /* *single_widen_addrvvm4sf */

        case 32:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31006; /* *single_widen_addrvvm2sf */

        case 33:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31007; /* *single_widen_addrvvm1sf */

        case 34:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31008; /* *single_widen_addrvvmf2sf */

        case 35:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31009; /* *single_widen_addrvvm8df */

        case 36:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31010; /* *single_widen_addrvvm4df */

        case 37:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31011; /* *single_widen_addrvvm2df */

        case 38:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31012; /* *single_widen_addrvvm1df */

        case 39:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31013; /* *single_widen_addv1sf */

        case 40:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31014; /* *single_widen_addv2sf */

        case 41:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31015; /* *single_widen_addv4sf */

        case 42:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31016; /* *single_widen_addv8sf */

        case 43:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31017; /* *single_widen_addv16sf */

        case 44:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31018; /* *single_widen_addv32sf */

        case 45:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31019; /* *single_widen_addv64sf */

        case 46:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31020; /* *single_widen_addv128sf */

        case 47:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31021; /* *single_widen_addv256sf */

        case 48:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31022; /* *single_widen_addv512sf */

        case 49:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31023; /* *single_widen_addv1024sf */

        case 50:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31024; /* *single_widen_addv1df */

        case 51:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31025; /* *single_widen_addv2df */

        case 52:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31026; /* *single_widen_addv4df */

        case 53:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31027; /* *single_widen_addv8df */

        case 54:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31028; /* *single_widen_addv16df */

        case 55:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31029; /* *single_widen_addv32df */

        case 56:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31030; /* *single_widen_addv64df */

        case 57:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31031; /* *single_widen_addv128df */

        case 58:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31032; /* *single_widen_addv256df */

        case 59:
          if (!(
#line 775 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31033; /* *single_widen_addv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 2:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 4102 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 463; /* riscv_frcsr */

        case 4:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 4115 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 465; /* riscv_frflags */

        case 21:
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 4767 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 498; /* ssrdpsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 4767 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 499; /* ssrdpdi */

            default:
              return -1;
            }

        case 24:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 7)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[0] = x3;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!immediate_operand (operands[0], E_SImode)
                  || !
#line 4790 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 503; /* set_lplsi */

            case E_DImode:
              if (!immediate_operand (operands[0], E_DImode)
                  || !(
#line 4790 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_ZICFILP) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 504; /* set_lpldi */

            default:
              return -1;
            }

        case 26:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 7)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[0] = x3;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 4804 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 506; /* set_guardedsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 4804 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_ZICFILP) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 507; /* set_guardeddi */

            default:
              return -1;
            }

        case 29:
          if (pattern184 (x1, 
69) != 0
              || !register_operand (operands[0], E_SImode)
              || !
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 2724; /* fsrmsi_restore_volatile */

        case 233:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!move_operand (operands[1], E_SImode)
              || !
#line 862 "../../gcc-15.1.1-20250425/gcc/config/riscv/corev.md"
(TARGET_XCVELW && !TARGET_64BIT))
            return -1;
          return 33943; /* riscv_cv_elw_elw_si */

        default:
          return -1;
        }

    case 2:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 84:
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern367 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 720; /* atomic_addqi */

                case 1:
                  if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 724; /* atomic_addhi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern367 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 721; /* atomic_orqi */

                case 1:
                  if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 725; /* atomic_orhi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern367 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 722; /* atomic_xorqi */

                case 1:
                  if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 726; /* atomic_xorhi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern367 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 723; /* atomic_andqi */

                case 1:
                  if (!
#line 100 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 727; /* atomic_andhi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 82:
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern368 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 728; /* amo_atomic_addsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 736; /* lrsc_atomic_addsi */

                case 1:
                  if ((
#line 127 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 732; /* amo_atomic_adddi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 740; /* lrsc_atomic_adddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern368 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 729; /* amo_atomic_orsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 737; /* lrsc_atomic_orsi */

                case 1:
                  if ((
#line 127 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 733; /* amo_atomic_ordi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 741; /* lrsc_atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern368 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 730; /* amo_atomic_xorsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 738; /* lrsc_atomic_xorsi */

                case 1:
                  if ((
#line 127 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 734; /* amo_atomic_xordi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 742; /* lrsc_atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern368 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 731; /* amo_atomic_andsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 739; /* lrsc_atomic_andsi */

                case 1:
                  if ((
#line 127 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 735; /* amo_atomic_anddi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 743; /* lrsc_atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 88:
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !memory_operand (operands[1], E_QImode))
                return -1;
              if (
#line 55 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 788; /* atomic_load_rvwmoqi */
              if (!
#line 49 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 797; /* atomic_load_ztsoqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !memory_operand (operands[1], E_HImode))
                return -1;
              if (
#line 55 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 789; /* atomic_load_rvwmohi */
              if (!
#line 49 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 798; /* atomic_load_ztsohi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              if (
#line 55 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 790; /* atomic_load_rvwmosi */
              if (!
#line 49 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 799; /* atomic_load_ztsosi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 55 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO) && 
#line 69 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 791; /* atomic_load_rvwmodi */
              if (!(
#line 49 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO) && 
#line 69 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 800; /* atomic_load_ztsodi */

            default:
              return -1;
            }

        case 89:
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!memory_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !reg_or_0_operand (operands[1], E_QImode))
                return -1;
              if (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 792; /* atomic_store_rvwmoqi */
              if (!
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 801; /* atomic_store_ztsoqi */

            case E_HImode:
              if (!memory_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !reg_or_0_operand (operands[1], E_HImode))
                return -1;
              if (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 793; /* atomic_store_rvwmohi */
              if (!
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 802; /* atomic_store_ztsohi */

            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !reg_or_0_operand (operands[1], E_SImode))
                return -1;
              if (
#line 84 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 794; /* atomic_store_rvwmosi */
              if (!
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 803; /* atomic_store_ztsosi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !reg_or_0_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 84 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO) && 
#line 69 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 795; /* atomic_store_rvwmodi */
              if (!(
#line 72 "../../gcc-15.1.1-20250425/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO) && 
#line 69 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 804; /* atomic_store_ztsodi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1492 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return recog_112 (x1, insn, pnum_clobbers);

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern200 (x3, 
E_SImode) != 0
              || !(
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 523; /* *xor_notsi */

        case E_DImode:
          if (pattern200 (x3, 
E_DImode) != 0
              || !(
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 524; /* *xor_notdi */

        case E_RVVMF64BImode:
          if (pattern200 (x3, 
E_RVVMF64BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32147; /* *nxorrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern200 (x3, 
E_RVVMF32BImode) != 0
              || !
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32150; /* *nxorrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern200 (x3, 
E_RVVMF16BImode) != 0
              || !
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32153; /* *nxorrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern200 (x3, 
E_RVVMF8BImode) != 0
              || !
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32156; /* *nxorrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern200 (x3, 
E_RVVMF4BImode) != 0
              || !
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32159; /* *nxorrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern200 (x3, 
E_RVVMF2BImode) != 0
              || !
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32162; /* *nxorrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern200 (x3, 
E_RVVM1BImode) != 0
              || !
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32165; /* *nxorrvvm1bi */

        case E_V1BImode:
          if (pattern200 (x3, 
E_V1BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32168; /* *nxorv1bi */

        case E_V2BImode:
          if (pattern200 (x3, 
E_V2BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32171; /* *nxorv2bi */

        case E_V4BImode:
          if (pattern200 (x3, 
E_V4BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32174; /* *nxorv4bi */

        case E_V8BImode:
          if (pattern200 (x3, 
E_V8BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32177; /* *nxorv8bi */

        case E_V16BImode:
          if (pattern200 (x3, 
E_V16BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32180; /* *nxorv16bi */

        case E_V32BImode:
          if (pattern200 (x3, 
E_V32BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32183; /* *nxorv32bi */

        case E_V64BImode:
          if (pattern200 (x3, 
E_V64BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32186; /* *nxorv64bi */

        case E_V128BImode:
          if (pattern200 (x3, 
E_V128BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32189; /* *nxorv128bi */

        case E_V256BImode:
          if (pattern200 (x3, 
E_V256BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32192; /* *nxorv256bi */

        case E_V512BImode:
          if (pattern200 (x3, 
E_V512BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32195; /* *nxorv512bi */

        case E_V1024BImode:
          if (pattern200 (x3, 
E_V1024BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32198; /* *nxorv1024bi */

        case E_V2048BImode:
          if (pattern200 (x3, 
E_V2048BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32201; /* *nxorv2048bi */

        case E_V4096BImode:
          if (pattern200 (x3, 
E_V4096BImode) != 0
              || !(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32204; /* *nxorv4096bi */

        default:
          return -1;
        }

    case AND:
      switch (pattern201 (x3))
        {
        case 0:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32145; /* *nandrvvmf64bi */

        case 1:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32148; /* *nandrvvmf32bi */

        case 2:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32151; /* *nandrvvmf16bi */

        case 3:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32154; /* *nandrvvmf8bi */

        case 4:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32157; /* *nandrvvmf4bi */

        case 5:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32160; /* *nandrvvmf2bi */

        case 6:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32163; /* *nandrvvm1bi */

        case 7:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32166; /* *nandv1bi */

        case 8:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32169; /* *nandv2bi */

        case 9:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32172; /* *nandv4bi */

        case 10:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32175; /* *nandv8bi */

        case 11:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32178; /* *nandv16bi */

        case 12:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32181; /* *nandv32bi */

        case 13:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32184; /* *nandv64bi */

        case 14:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32187; /* *nandv128bi */

        case 15:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32190; /* *nandv256bi */

        case 16:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32193; /* *nandv512bi */

        case 17:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32196; /* *nandv1024bi */

        case 18:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32199; /* *nandv2048bi */

        case 19:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32202; /* *nandv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern201 (x3))
        {
        case 0:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32146; /* *niorrvvmf64bi */

        case 1:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32149; /* *niorrvvmf32bi */

        case 2:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32152; /* *niorrvvmf16bi */

        case 3:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32155; /* *niorrvvmf8bi */

        case 4:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32158; /* *niorrvvmf4bi */

        case 5:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32161; /* *niorrvvmf2bi */

        case 6:
          if (!
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32164; /* *niorrvvm1bi */

        case 7:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32167; /* *niorv1bi */

        case 8:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32170; /* *niorv2bi */

        case 9:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32173; /* *niorv4bi */

        case 10:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32176; /* *niorv8bi */

        case 11:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32179; /* *niorv16bi */

        case 12:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32182; /* *niorv32bi */

        case 13:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32185; /* *niorv64bi */

        case 14:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32188; /* *niorv128bi */

        case 15:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32191; /* *niorv256bi */

        case 16:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32194; /* *niorv512bi */

        case 17:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32197; /* *niorv1024bi */

        case 18:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32200; /* *niorv2048bi */

        case 19:
          if (!(
#line 1491 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32203; /* *niorv4096bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1500 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      if (!
#line 1416 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_DIV))
        return -1;
      return 37; /* *udivsi3 */

    case 1:
      if (!
#line 1443 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 41; /* udivdi3 */

    case 2:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24552; /* udivrvvm8qi3 */

    case 3:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24566; /* udivrvvm4qi3 */

    case 4:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24580; /* udivrvvm2qi3 */

    case 5:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24594; /* udivrvvm1qi3 */

    case 6:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24608; /* udivrvvm8hi3 */

    case 7:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24622; /* udivrvvm4hi3 */

    case 8:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24636; /* udivrvvm2hi3 */

    case 9:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24650; /* udivrvvm1hi3 */

    case 10:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24664; /* udivrvvm8si3 */

    case 11:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24678; /* udivrvvm4si3 */

    case 12:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24692; /* udivrvvm2si3 */

    case 13:
      if (!
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24706; /* udivrvvm1si3 */

    case 14:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24720; /* udivrvvm8di3 */

    case 15:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24734; /* udivrvvm4di3 */

    case 16:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24748; /* udivrvvm2di3 */

    case 17:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24762; /* udivrvvm1di3 */

    case 18:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24776; /* udivrvvmf2qi3 */

    case 19:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24790; /* udivrvvmf4qi3 */

    case 20:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24804; /* udivrvvmf8qi3 */

    case 21:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24818; /* udivrvvmf2hi3 */

    case 22:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24832; /* udivrvvmf4hi3 */

    case 23:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24846; /* udivrvvmf2si3 */

    case 24:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24860; /* udivv1qi3 */

    case 25:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24874; /* udivv2qi3 */

    case 26:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24888; /* udivv4qi3 */

    case 27:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24902; /* udivv8qi3 */

    case 28:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24916; /* udivv16qi3 */

    case 29:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24930; /* udivv32qi3 */

    case 30:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24944; /* udivv64qi3 */

    case 31:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24958; /* udivv128qi3 */

    case 32:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24972; /* udivv256qi3 */

    case 33:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24986; /* udivv512qi3 */

    case 34:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25000; /* udivv1024qi3 */

    case 35:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25014; /* udivv2048qi3 */

    case 36:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25028; /* udivv4096qi3 */

    case 37:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25042; /* udivv1hi3 */

    case 38:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25056; /* udivv2hi3 */

    case 39:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25070; /* udivv4hi3 */

    case 40:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25084; /* udivv8hi3 */

    case 41:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25098; /* udivv16hi3 */

    case 42:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25112; /* udivv32hi3 */

    case 43:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25126; /* udivv64hi3 */

    case 44:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25140; /* udivv128hi3 */

    case 45:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25154; /* udivv256hi3 */

    case 46:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25168; /* udivv512hi3 */

    case 47:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25182; /* udivv1024hi3 */

    case 48:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25196; /* udivv2048hi3 */

    case 49:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25210; /* udivv1si3 */

    case 50:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25224; /* udivv2si3 */

    case 51:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25238; /* udivv4si3 */

    case 52:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25252; /* udivv8si3 */

    case 53:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25266; /* udivv16si3 */

    case 54:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25280; /* udivv32si3 */

    case 55:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25294; /* udivv64si3 */

    case 56:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25308; /* udivv128si3 */

    case 57:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25322; /* udivv256si3 */

    case 58:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25336; /* udivv512si3 */

    case 59:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25350; /* udivv1024si3 */

    case 60:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25364; /* udivv1di3 */

    case 61:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25378; /* udivv2di3 */

    case 62:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25392; /* udivv4di3 */

    case 63:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25406; /* udivv8di3 */

    case 64:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25420; /* udivv16di3 */

    case 65:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25434; /* udivv32di3 */

    case 66:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25448; /* udivv64di3 */

    case 67:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25462; /* udivv128di3 */

    case 68:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25476; /* udivv256di3 */

    case 69:
      if (!(
#line 484 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25490; /* udivv512di3 */

    default:
      return -1;
    }
}

 int
recog_1509 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return recog_24 (x1, insn, pnum_clobbers);

    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern403 (x3, 
E_SFmode) != 0
                      || !(
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 66; /* *fmasf4 */

                case E_DFmode:
                  if (pattern403 (x3, 
E_DFmode) != 0
                      || !(
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 67; /* *fmadf4 */

                case E_HFmode:
                  if (pattern403 (x3, 
E_HFmode) != 0
                      || !(
#line 1556 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 68; /* *fmahf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern404 (x3, 
E_SFmode) != 0
                      || !(
#line 1569 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 69; /* *fmssf4 */

                case E_DFmode:
                  if (pattern404 (x3, 
E_DFmode) != 0
                      || !(
#line 1569 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 70; /* *fmsdf4 */

                case E_HFmode:
                  if (pattern404 (x3, 
E_HFmode) != 0
                      || !(
#line 1569 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 71; /* *fmshf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern405 (x3, 
E_SFmode) != 0
                      || !(
#line 1582 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 72; /* *fnmssf4 */

                case E_DFmode:
                  if (pattern405 (x3, 
E_DFmode) != 0
                      || !(
#line 1582 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 73; /* *fnmsdf4 */

                case E_HFmode:
                  if (pattern405 (x3, 
E_HFmode) != 0
                      || !(
#line 1582 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 74; /* *fnmshf4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern406 (x3, 
E_SFmode) != 0
                      || !(
#line 1595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 75; /* *fnmasf4 */

                case E_DFmode:
                  if (pattern406 (x3, 
E_DFmode) != 0
                      || !(
#line 1595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 76; /* *fnmadf4 */

                case E_HFmode:
                  if (pattern406 (x3, 
E_HFmode) != 0
                      || !(
#line 1595 "../../gcc-15.1.1-20250425/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 77; /* *fnmahf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern152 (x3))
        {
        case 0:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32090; /* *copysignrvvm8hf_neg */

        case 1:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32091; /* *copysignrvvm4hf_neg */

        case 2:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32092; /* *copysignrvvm2hf_neg */

        case 3:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32093; /* *copysignrvvm1hf_neg */

        case 4:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32094; /* *copysignrvvmf2hf_neg */

        case 5:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32095; /* *copysignrvvmf4hf_neg */

        case 6:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32096; /* *copysignrvvm8sf_neg */

        case 7:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32097; /* *copysignrvvm4sf_neg */

        case 8:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32098; /* *copysignrvvm2sf_neg */

        case 9:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32099; /* *copysignrvvm1sf_neg */

        case 10:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32100; /* *copysignrvvmf2sf_neg */

        case 11:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 32101; /* *copysignrvvm8df_neg */

        case 12:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 32102; /* *copysignrvvm4df_neg */

        case 13:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 32103; /* *copysignrvvm2df_neg */

        case 14:
          if (!(
#line 1456 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 32104; /* *copysignrvvm1df_neg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (pattern347 (x3))
    {
    case 0:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2826; /* *movrvvmf2qisi_lra */

    case 1:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2837; /* *movrvvmf2qidi_lra */

    case 2:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2827; /* *movrvvmf4qisi_lra */

    case 3:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2838; /* *movrvvmf4qidi_lra */

    case 4:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 932 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2828; /* *movrvvmf8qisi_lra */

    case 5:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 932 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2839; /* *movrvvmf8qidi_lra */

    case 6:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2829; /* *movrvvmf2hisi_lra */

    case 7:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2840; /* *movrvvmf2hidi_lra */

    case 8:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2830; /* *movrvvmf4hisi_lra */

    case 9:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2841; /* *movrvvmf4hidi_lra */

    case 10:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2831; /* *movrvvmf2bfsi_lra */

    case 11:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2842; /* *movrvvmf2bfdi_lra */

    case 12:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2832; /* *movrvvmf4bfsi_lra */

    case 13:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2843; /* *movrvvmf4bfdi_lra */

    case 14:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2833; /* *movrvvmf2hfsi_lra */

    case 15:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2844; /* *movrvvmf2hfdi_lra */

    case 16:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2834; /* *movrvvmf4hfsi_lra */

    case 17:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2845; /* *movrvvmf4hfdi_lra */

    case 18:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2835; /* *movrvvmf2sisi_lra */

    case 19:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2846; /* *movrvvmf2sidi_lra */

    case 20:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2836; /* *movrvvmf2sfsi_lra */

    case 21:
      if (!(
#line 1332 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2847; /* *movrvvmf2sfdi_lra */

    case 22:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2848; /* *movrvvmf64bisi_lra */

    case 23:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2849; /* *movrvvmf64bidi_lra */

    case 24:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2850; /* *movrvvmf32bisi_lra */

    case 25:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2851; /* *movrvvmf32bidi_lra */

    case 26:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2852; /* *movrvvmf16bisi_lra */

    case 27:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2853; /* *movrvvmf16bidi_lra */

    case 28:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2854; /* *movrvvmf8bisi_lra */

    case 29:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2855; /* *movrvvmf8bidi_lra */

    case 30:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2856; /* *movrvvmf4bisi_lra */

    case 31:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2857; /* *movrvvmf4bidi_lra */

    case 32:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2858; /* *movrvvmf2bisi_lra */

    case 33:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2859; /* *movrvvmf2bidi_lra */

    case 34:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2860; /* *movrvvm1bisi_lra */

    case 35:
      if (!(
#line 1354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2861; /* *movrvvm1bidi_lra */

    case 36:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3232; /* *movv32qisi_lra */

    case 37:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3233; /* *movv32qidi_lra */

    case 38:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3234; /* *movv64qisi_lra */

    case 39:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3235; /* *movv64qidi_lra */

    case 40:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4350 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3236; /* *movv128qisi_lra */

    case 41:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4350 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3237; /* *movv128qidi_lra */

    case 42:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3238; /* *movv256qisi_lra */

    case 43:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3239; /* *movv256qidi_lra */

    case 44:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3240; /* *movv512qisi_lra */

    case 45:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3241; /* *movv512qidi_lra */

    case 46:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4353 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3242; /* *movv1024qisi_lra */

    case 47:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4353 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3243; /* *movv1024qidi_lra */

    case 48:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3244; /* *movv2048qisi_lra */

    case 49:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3245; /* *movv2048qidi_lra */

    case 50:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3246; /* *movv4096qisi_lra */

    case 51:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3247; /* *movv4096qidi_lra */

    case 52:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3248; /* *movv32hisi_lra */

    case 53:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4356 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3249; /* *movv32hidi_lra */

    case 54:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3250; /* *movv64hisi_lra */

    case 55:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3251; /* *movv64hidi_lra */

    case 56:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3252; /* *movv128hisi_lra */

    case 57:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3253; /* *movv128hidi_lra */

    case 58:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4359 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3254; /* *movv256hisi_lra */

    case 59:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4359 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3255; /* *movv256hidi_lra */

    case 60:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3256; /* *movv512hisi_lra */

    case 61:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3257; /* *movv512hidi_lra */

    case 62:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3258; /* *movv1024hisi_lra */

    case 63:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3259; /* *movv1024hidi_lra */

    case 64:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4362 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3260; /* *movv2048hisi_lra */

    case 65:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4362 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3261; /* *movv2048hidi_lra */

    case 66:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3262; /* *movv32sisi_lra */

    case 67:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3263; /* *movv32sidi_lra */

    case 68:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3264; /* *movv64sisi_lra */

    case 69:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3265; /* *movv64sidi_lra */

    case 70:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4365 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3266; /* *movv128sisi_lra */

    case 71:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4365 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3267; /* *movv128sidi_lra */

    case 72:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3268; /* *movv256sisi_lra */

    case 73:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3269; /* *movv256sidi_lra */

    case 74:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3270; /* *movv512sisi_lra */

    case 75:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3271; /* *movv512sidi_lra */

    case 76:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4368 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3272; /* *movv1024sisi_lra */

    case 77:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4368 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3273; /* *movv1024sidi_lra */

    case 78:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3274; /* *movv32disi_lra */

    case 79:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3275; /* *movv32didi_lra */

    case 80:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3276; /* *movv64disi_lra */

    case 81:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3277; /* *movv64didi_lra */

    case 82:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4371 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3278; /* *movv128disi_lra */

    case 83:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4371 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3279; /* *movv128didi_lra */

    case 84:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3280; /* *movv256disi_lra */

    case 85:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3281; /* *movv256didi_lra */

    case 86:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3282; /* *movv512disi_lra */

    case 87:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3283; /* *movv512didi_lra */

    case 88:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4374 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3284; /* *movv32hfsi_lra */

    case 89:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4374 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3285; /* *movv32hfdi_lra */

    case 90:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3286; /* *movv64hfsi_lra */

    case 91:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3287; /* *movv64hfdi_lra */

    case 92:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3288; /* *movv128hfsi_lra */

    case 93:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3289; /* *movv128hfdi_lra */

    case 94:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4377 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3290; /* *movv256hfsi_lra */

    case 95:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4377 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3291; /* *movv256hfdi_lra */

    case 96:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3292; /* *movv512hfsi_lra */

    case 97:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3293; /* *movv512hfdi_lra */

    case 98:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3294; /* *movv1024hfsi_lra */

    case 99:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3295; /* *movv1024hfdi_lra */

    case 100:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4380 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3296; /* *movv2048hfsi_lra */

    case 101:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4380 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3297; /* *movv2048hfdi_lra */

    case 102:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3298; /* *movv32sfsi_lra */

    case 103:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3299; /* *movv32sfdi_lra */

    case 104:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3300; /* *movv64sfsi_lra */

    case 105:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3301; /* *movv64sfdi_lra */

    case 106:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3302; /* *movv128sfsi_lra */

    case 107:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4383 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3303; /* *movv128sfdi_lra */

    case 108:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3304; /* *movv256sfsi_lra */

    case 109:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3305; /* *movv256sfdi_lra */

    case 110:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3306; /* *movv512sfsi_lra */

    case 111:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3307; /* *movv512sfdi_lra */

    case 112:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3308; /* *movv1024sfsi_lra */

    case 113:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3309; /* *movv1024sfdi_lra */

    case 114:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3310; /* *movv32dfsi_lra */

    case 115:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3311; /* *movv32dfdi_lra */

    case 116:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3312; /* *movv64dfsi_lra */

    case 117:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3313; /* *movv64dfdi_lra */

    case 118:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4389 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3314; /* *movv128dfsi_lra */

    case 119:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4389 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3315; /* *movv128dfdi_lra */

    case 120:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3316; /* *movv256dfsi_lra */

    case 121:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3317; /* *movv256dfdi_lra */

    case 122:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4391 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3318; /* *movv512dfsi_lra */

    case 123:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4391 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3319; /* *movv512dfdi_lra */

    case 124:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3320; /* *movv32bisi_lra */

    case 125:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3321; /* *movv32bidi_lra */

    case 126:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3322; /* *movv64bisi_lra */

    case 127:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3323; /* *movv64bidi_lra */

    case 128:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3324; /* *movv128bisi_lra */

    case 129:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3325; /* *movv128bidi_lra */

    case 130:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3326; /* *movv256bisi_lra */

    case 131:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3327; /* *movv256bidi_lra */

    case 132:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3328; /* *movv512bisi_lra */

    case 133:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3329; /* *movv512bidi_lra */

    case 134:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3330; /* *movv1024bisi_lra */

    case 135:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3331; /* *movv1024bidi_lra */

    case 136:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3332; /* *movv2048bisi_lra */

    case 137:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3333; /* *movv2048bidi_lra */

    case 138:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3334; /* *movv4096bisi_lra */

    case 139:
      if (!(
#line 1478 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.1.1-20250425/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3335; /* *movv4096bidi_lra */

    default:
      return -1;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern145 (x2))
        {
        case 0:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8132 (insn, operands);

        case 1:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8138 (insn, operands);

        case 2:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8144 (insn, operands);

        case 3:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8150 (insn, operands);

        case 4:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8156 (insn, operands);

        case 5:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8162 (insn, operands);

        case 6:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8168 (insn, operands);

        case 7:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8174 (insn, operands);

        case 8:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8180 (insn, operands);

        case 9:
          if (!(
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8186 (insn, operands);

        case 10:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8192 (insn, operands);

        case 11:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8198 (insn, operands);

        case 12:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8204 (insn, operands);

        case 13:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8210 (insn, operands);

        case 14:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8216 (insn, operands);

        case 15:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8222 (insn, operands);

        case 16:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8228 (insn, operands);

        case 17:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8234 (insn, operands);

        case 18:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8240 (insn, operands);

        case 19:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8246 (insn, operands);

        case 20:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8252 (insn, operands);

        case 21:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8258 (insn, operands);

        case 22:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8264 (insn, operands);

        case 23:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8270 (insn, operands);

        case 24:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8276 (insn, operands);

        case 25:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8282 (insn, operands);

        case 26:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8288 (insn, operands);

        case 27:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8294 (insn, operands);

        case 28:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8300 (insn, operands);

        case 29:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8306 (insn, operands);

        case 30:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8312 (insn, operands);

        case 31:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8318 (insn, operands);

        case 32:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8324 (insn, operands);

        case 33:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8330 (insn, operands);

        case 34:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8336 (insn, operands);

        case 35:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8342 (insn, operands);

        case 36:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8348 (insn, operands);

        case 37:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8354 (insn, operands);

        case 38:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8360 (insn, operands);

        case 39:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8366 (insn, operands);

        case 40:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8372 (insn, operands);

        case 41:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8378 (insn, operands);

        case 42:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8384 (insn, operands);

        case 43:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8390 (insn, operands);

        case 44:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8396 (insn, operands);

        case 45:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8402 (insn, operands);

        case 46:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8408 (insn, operands);

        case 47:
          if (!((
#line 610 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8414 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern153 (x2))
        {
        case 0:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8612 (insn, operands);

        case 1:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8614 (insn, operands);

        case 2:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8616 (insn, operands);

        case 3:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8618 (insn, operands);

        case 4:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8620 (insn, operands);

        case 5:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8622 (insn, operands);

        case 6:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8624 (insn, operands);

        case 7:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8626 (insn, operands);

        case 8:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8628 (insn, operands);

        case 9:
          if (!(
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8630 (insn, operands);

        case 10:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8632 (insn, operands);

        case 11:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8634 (insn, operands);

        case 12:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8636 (insn, operands);

        case 13:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8638 (insn, operands);

        case 14:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8640 (insn, operands);

        case 15:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8642 (insn, operands);

        case 16:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8644 (insn, operands);

        case 17:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8646 (insn, operands);

        case 18:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8648 (insn, operands);

        case 19:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8650 (insn, operands);

        case 20:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8652 (insn, operands);

        case 21:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8654 (insn, operands);

        case 22:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8656 (insn, operands);

        case 23:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8658 (insn, operands);

        case 24:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8660 (insn, operands);

        case 25:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8662 (insn, operands);

        case 26:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8664 (insn, operands);

        case 27:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8666 (insn, operands);

        case 28:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8668 (insn, operands);

        case 29:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8670 (insn, operands);

        case 30:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8672 (insn, operands);

        case 31:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8674 (insn, operands);

        case 32:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8676 (insn, operands);

        case 33:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8678 (insn, operands);

        case 34:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8680 (insn, operands);

        case 35:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8682 (insn, operands);

        case 36:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8684 (insn, operands);

        case 37:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8686 (insn, operands);

        case 38:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8688 (insn, operands);

        case 39:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8690 (insn, operands);

        case 40:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8692 (insn, operands);

        case 41:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8694 (insn, operands);

        case 42:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8696 (insn, operands);

        case 43:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8698 (insn, operands);

        case 44:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8700 (insn, operands);

        case 45:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8702 (insn, operands);

        case 46:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8704 (insn, operands);

        case 47:
          if (!((
#line 675 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8706 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_39 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HImode)
      && reg_or_mem_operand (operands[1], E_V1HImode))
    {
      if ((
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return gen_split_257 (insn, operands);
      if (((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HImode)
       || register_operand (operands[1], V1HImode))) && 
#line 4309 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1HImode)
       || !register_operand (operands[1], V1HImode)))))
        return gen_split_1952 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1HImode)
      || !register_operand (operands[1], E_V1HImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2104 (insn, operands);
}

 rtx_insn *
split_45 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16BImode)
      && reg_or_mem_operand (operands[1], E_V16BImode)
      && ((
#line 1434 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))) && 
#line 4344 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1441 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16BImode)
       || !register_operand (operands[1], V16BImode)))))
    return gen_split_1986 (insn, operands);
  if (!register_operand (operands[0], E_V16BImode)
      || !register_operand (operands[1], E_V16BImode)
      || !((
#line 1530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2174 (insn, operands);
}

 rtx_insn *
split_50 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512DFmode)
      && reg_or_mem_operand (operands[1], E_V512DFmode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_322 (insn, operands);
  if (!register_operand (operands[0], E_V512DFmode)
      || !register_operand (operands[1], E_V512DFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2169 (insn, operands);
}

 rtx_insn *
split_55 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024SFmode)
      && reg_or_mem_operand (operands[1], E_V1024SFmode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_312 (insn, operands);
  if (!register_operand (operands[0], E_V1024SFmode)
      || !register_operand (operands[1], E_V1024SFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2159 (insn, operands);
}

 rtx_insn *
split_61 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2048HFmode)
      && reg_or_mem_operand (operands[1], E_V2048HFmode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_301 (insn, operands);
  if (!register_operand (operands[0], E_V2048HFmode)
      || !register_operand (operands[1], E_V2048HFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2148 (insn, operands);
}

 rtx_insn *
split_67 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32HFmode)
      && reg_or_mem_operand (operands[1], E_V32HFmode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return gen_split_295 (insn, operands);
  if (!register_operand (operands[0], E_V32HFmode)
      || !register_operand (operands[1], E_V32HFmode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2142 (insn, operands);
}

 rtx_insn *
split_73 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024SImode)
      && reg_or_mem_operand (operands[1], E_V1024SImode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return gen_split_279 (insn, operands);
  if (!register_operand (operands[0], E_V1024SImode)
      || !register_operand (operands[1], E_V1024SImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2126 (insn, operands);
}

 rtx_insn *
split_80 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return gen_split_267 (insn, operands);
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2114 (insn, operands);
}

 rtx_insn *
split_87 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2048QImode)
      && reg_or_mem_operand (operands[1], E_V2048QImode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return gen_split_255 (insn, operands);
  if (!register_operand (operands[0], E_V2048QImode)
      || !register_operand (operands[1], E_V2048QImode)
      || !((
#line 1509 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2102 (insn, operands);
}

 rtx_insn *
split_94 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVM1BImode)
      && reg_or_mem_operand (operands[1], E_RVVM1BImode)
      && 
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_243 (insn, operands);
  if (!register_operand (operands[0], E_RVVM1BImode)
      || !register_operand (operands[1], E_RVVM1BImode)
      || !(
#line 1294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1580 (insn, operands);
}

 rtx_insn *
split_101 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2SFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2SFmode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return gen_split_232 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2SFmode)
      || !register_operand (operands[1], E_RVVMF2SFmode)
      || !((
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1573 (insn, operands);
}

 rtx_insn *
split_108 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF8QImode)
      && reg_or_mem_operand (operands[1], E_RVVMF8QImode)
      && (
#line 99 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return gen_split_213 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF8QImode)
      || !register_operand (operands[1], E_RVVMF8QImode)
      || !((
#line 1257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1565 (insn, operands);
}

 rtx_insn *
split_116 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4945 (insn, operands);

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4947 (insn, operands);

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4949 (insn, operands);

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4951 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4953 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4955 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4957 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4959 (insn, operands);

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4961 (insn, operands);

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4963 (insn, operands);

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4965 (insn, operands);

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !(
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4967 (insn, operands);

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4969 (insn, operands);

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4971 (insn, operands);

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4973 (insn, operands);

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4975 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4977 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4979 (insn, operands);

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4981 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4983 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4985 (insn, operands);

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4987 (insn, operands);

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4989 (insn, operands);

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4991 (insn, operands);

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4993 (insn, operands);

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4995 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4997 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4999 (insn, operands);

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5001 (insn, operands);

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5003 (insn, operands);

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5005 (insn, operands);

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5007 (insn, operands);

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5009 (insn, operands);

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5011 (insn, operands);

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5013 (insn, operands);

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5015 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5017 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5019 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5021 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5023 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5025 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5027 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5029 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5031 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5033 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5035 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5037 (insn, operands);

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5039 (insn, operands);

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5041 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5043 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5045 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5047 (insn, operands);

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5049 (insn, operands);

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5051 (insn, operands);

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5053 (insn, operands);

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5055 (insn, operands);

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5057 (insn, operands);

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5059 (insn, operands);

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5061 (insn, operands);

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5063 (insn, operands);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5065 (insn, operands);

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5067 (insn, operands);

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5069 (insn, operands);

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5071 (insn, operands);

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5073 (insn, operands);

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5075 (insn, operands);

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5077 (insn, operands);

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !((
#line 1093 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1095 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5079 (insn, operands);

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5081 (insn, operands);

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5083 (insn, operands);

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5085 (insn, operands);

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5087 (insn, operands);

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5089 (insn, operands);

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5091 (insn, operands);

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5093 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5095 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5097 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5099 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5101 (insn, operands);

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5103 (insn, operands);

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5105 (insn, operands);

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5107 (insn, operands);

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5109 (insn, operands);

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5111 (insn, operands);

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5113 (insn, operands);

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5115 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5117 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5119 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5121 (insn, operands);

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5123 (insn, operands);

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5125 (insn, operands);

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5127 (insn, operands);

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5129 (insn, operands);

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5131 (insn, operands);

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5133 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5135 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5137 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5139 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5141 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5143 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5145 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5147 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5149 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5151 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5153 (insn, operands);

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5155 (insn, operands);

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5157 (insn, operands);

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5159 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5161 (insn, operands);

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5163 (insn, operands);

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5165 (insn, operands);

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5167 (insn, operands);

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5169 (insn, operands);

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5171 (insn, operands);

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5173 (insn, operands);

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !((
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5175 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_125 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_799 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_805 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_811 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_817 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_823 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_829 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_835 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_841 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_847 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_853 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_859 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_865 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_871 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_877 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_883 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_889 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_895 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_901 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_907 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_913 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_919 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_925 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_931 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_937 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_943 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_949 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_955 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_961 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_967 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_973 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_979 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_985 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_991 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_997 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1003 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1009 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1015 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1021 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1027 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1033 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1039 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1045 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1051 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1057 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1063 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1069 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1075 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1081 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1087 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1093 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1099 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1105 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1111 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1117 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1123 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1129 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1135 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1141 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1147 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1153 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1159 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1165 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1171 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1177 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1183 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1189 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1195 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1201 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1207 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1213 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1219 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1225 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1231 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1237 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1243 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1249 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1255 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1261 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1267 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1273 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1279 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1285 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1291 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1297 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1303 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1309 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1315 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1321 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1327 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1333 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1339 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1345 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1351 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1357 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1363 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1369 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1375 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1381 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1387 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1393 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1399 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1405 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1411 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1417 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1423 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1429 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1435 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1441 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1447 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1453 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1459 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1465 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1471 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1477 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1483 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1489 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1495 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1501 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1507 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1513 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1519 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1525 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_133 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern219 (x2))
    {
    case 0:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4027 (insn, operands);

    case 1:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4028 (insn, operands);

    case 2:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4029 (insn, operands);

    case 3:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4030 (insn, operands);

    case 4:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4031 (insn, operands);

    case 5:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4032 (insn, operands);

    case 6:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4033 (insn, operands);

    case 7:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4034 (insn, operands);

    case 8:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4035 (insn, operands);

    case 9:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4036 (insn, operands);

    case 10:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4037 (insn, operands);

    case 11:
      if (!(
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4038 (insn, operands);

    case 12:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4039 (insn, operands);

    case 13:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4040 (insn, operands);

    case 14:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4041 (insn, operands);

    case 15:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4042 (insn, operands);

    case 16:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4043 (insn, operands);

    case 17:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4044 (insn, operands);

    case 18:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4045 (insn, operands);

    case 19:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4046 (insn, operands);

    case 20:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4047 (insn, operands);

    case 21:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4048 (insn, operands);

    case 22:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4049 (insn, operands);

    case 23:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 168 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4050 (insn, operands);

    case 24:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4051 (insn, operands);

    case 25:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4052 (insn, operands);

    case 26:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 171 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4053 (insn, operands);

    case 27:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 172 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4054 (insn, operands);

    case 28:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4055 (insn, operands);

    case 29:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4056 (insn, operands);

    case 30:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4057 (insn, operands);

    case 31:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4058 (insn, operands);

    case 32:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4059 (insn, operands);

    case 33:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4060 (insn, operands);

    case 34:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4061 (insn, operands);

    case 35:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4062 (insn, operands);

    case 36:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4063 (insn, operands);

    case 37:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4064 (insn, operands);

    case 38:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4065 (insn, operands);

    case 39:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4066 (insn, operands);

    case 40:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4067 (insn, operands);

    case 41:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4068 (insn, operands);

    case 42:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4069 (insn, operands);

    case 43:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4070 (insn, operands);

    case 44:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4071 (insn, operands);

    case 45:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4072 (insn, operands);

    case 46:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4073 (insn, operands);

    case 47:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4074 (insn, operands);

    case 48:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4075 (insn, operands);

    case 49:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4076 (insn, operands);

    case 50:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4077 (insn, operands);

    case 51:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4078 (insn, operands);

    case 52:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4079 (insn, operands);

    case 53:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4080 (insn, operands);

    case 54:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4081 (insn, operands);

    case 55:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4082 (insn, operands);

    case 56:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4083 (insn, operands);

    case 57:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4084 (insn, operands);

    case 58:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4085 (insn, operands);

    case 59:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4086 (insn, operands);

    case 60:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4087 (insn, operands);

    case 61:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4088 (insn, operands);

    case 62:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4089 (insn, operands);

    case 63:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4090 (insn, operands);

    case 64:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4091 (insn, operands);

    case 65:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4092 (insn, operands);

    case 66:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4093 (insn, operands);

    case 67:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4094 (insn, operands);

    case 68:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4095 (insn, operands);

    case 69:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4096 (insn, operands);

    case 70:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4097 (insn, operands);

    case 71:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4098 (insn, operands);

    case 72:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4099 (insn, operands);

    case 73:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4100 (insn, operands);

    case 74:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4101 (insn, operands);

    case 75:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4102 (insn, operands);

    case 76:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4103 (insn, operands);

    case 77:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4104 (insn, operands);

    case 78:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4105 (insn, operands);

    case 79:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4106 (insn, operands);

    case 80:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4107 (insn, operands);

    case 81:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4108 (insn, operands);

    case 82:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4109 (insn, operands);

    case 83:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4110 (insn, operands);

    case 84:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4111 (insn, operands);

    case 85:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4112 (insn, operands);

    case 86:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4113 (insn, operands);

    case 87:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4114 (insn, operands);

    case 88:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4115 (insn, operands);

    case 89:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4116 (insn, operands);

    case 90:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4117 (insn, operands);

    case 91:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4118 (insn, operands);

    case 92:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4119 (insn, operands);

    case 93:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4120 (insn, operands);

    case 94:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4121 (insn, operands);

    case 95:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4122 (insn, operands);

    case 96:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4123 (insn, operands);

    case 97:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4124 (insn, operands);

    case 98:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4125 (insn, operands);

    case 99:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4126 (insn, operands);

    case 100:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4127 (insn, operands);

    case 101:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4128 (insn, operands);

    case 102:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4129 (insn, operands);

    case 103:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4130 (insn, operands);

    case 104:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4131 (insn, operands);

    case 105:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4132 (insn, operands);

    case 106:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4133 (insn, operands);

    case 107:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4134 (insn, operands);

    case 108:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 291 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4135 (insn, operands);

    case 109:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 292 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4136 (insn, operands);

    case 110:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 293 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4137 (insn, operands);

    case 111:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 294 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4138 (insn, operands);

    case 112:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 295 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4139 (insn, operands);

    case 113:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 296 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4140 (insn, operands);

    case 114:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 297 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4141 (insn, operands);

    case 115:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 298 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4142 (insn, operands);

    case 116:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 299 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4143 (insn, operands);

    case 117:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 300 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4144 (insn, operands);

    case 118:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 301 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4145 (insn, operands);

    case 119:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 302 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4146 (insn, operands);

    case 120:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4147 (insn, operands);

    case 121:
      if (!((
#line 611 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 304 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 613 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4148 (insn, operands);

    case 122:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6314 (insn, operands);

    case 123:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6315 (insn, operands);

    case 124:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6316 (insn, operands);

    case 125:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6317 (insn, operands);

    case 126:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6318 (insn, operands);

    case 127:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6319 (insn, operands);

    case 128:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6320 (insn, operands);

    case 129:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6321 (insn, operands);

    case 130:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6322 (insn, operands);

    case 131:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6323 (insn, operands);

    case 132:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6324 (insn, operands);

    case 133:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6325 (insn, operands);

    case 134:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6326 (insn, operands);

    case 135:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6327 (insn, operands);

    case 136:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6328 (insn, operands);

    case 137:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6329 (insn, operands);

    case 138:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6330 (insn, operands);

    case 139:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6331 (insn, operands);

    case 140:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6332 (insn, operands);

    case 141:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6333 (insn, operands);

    case 142:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6334 (insn, operands);

    case 143:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6335 (insn, operands);

    case 144:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6336 (insn, operands);

    case 145:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6337 (insn, operands);

    case 146:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6338 (insn, operands);

    case 147:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6339 (insn, operands);

    case 148:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6340 (insn, operands);

    case 149:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6341 (insn, operands);

    case 150:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6342 (insn, operands);

    case 151:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6343 (insn, operands);

    case 152:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6344 (insn, operands);

    case 153:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6345 (insn, operands);

    case 154:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6346 (insn, operands);

    case 155:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6347 (insn, operands);

    case 156:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6348 (insn, operands);

    case 157:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6349 (insn, operands);

    case 158:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6350 (insn, operands);

    case 159:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6351 (insn, operands);

    case 160:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6352 (insn, operands);

    case 161:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6353 (insn, operands);

    case 162:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6354 (insn, operands);

    case 163:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6355 (insn, operands);

    case 164:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6356 (insn, operands);

    case 165:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6357 (insn, operands);

    case 166:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6358 (insn, operands);

    case 167:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6359 (insn, operands);

    case 168:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6360 (insn, operands);

    case 169:
      if (!((
#line 107 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6361 (insn, operands);

    case 170:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6362 (insn, operands);

    case 171:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6363 (insn, operands);

    case 172:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6364 (insn, operands);

    case 173:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6365 (insn, operands);

    case 174:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6366 (insn, operands);

    case 175:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6367 (insn, operands);

    case 176:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6368 (insn, operands);

    case 177:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6369 (insn, operands);

    case 178:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6370 (insn, operands);

    case 179:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6371 (insn, operands);

    case 180:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6372 (insn, operands);

    case 181:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6373 (insn, operands);

    case 182:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6374 (insn, operands);

    case 183:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6375 (insn, operands);

    case 184:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6376 (insn, operands);

    case 185:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6377 (insn, operands);

    case 186:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6378 (insn, operands);

    case 187:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6379 (insn, operands);

    case 188:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6380 (insn, operands);

    case 189:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6381 (insn, operands);

    case 190:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6382 (insn, operands);

    case 191:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6383 (insn, operands);

    case 192:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6384 (insn, operands);

    case 193:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6385 (insn, operands);

    case 194:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6386 (insn, operands);

    case 195:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6387 (insn, operands);

    case 196:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6388 (insn, operands);

    case 197:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6389 (insn, operands);

    case 198:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6390 (insn, operands);

    case 199:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6391 (insn, operands);

    case 200:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6392 (insn, operands);

    case 201:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6393 (insn, operands);

    case 202:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6394 (insn, operands);

    case 203:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6395 (insn, operands);

    case 204:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6396 (insn, operands);

    case 205:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6397 (insn, operands);

    case 206:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6398 (insn, operands);

    case 207:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6399 (insn, operands);

    case 208:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6400 (insn, operands);

    case 209:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6401 (insn, operands);

    case 210:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6402 (insn, operands);

    case 211:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6403 (insn, operands);

    case 212:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6404 (insn, operands);

    case 213:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6405 (insn, operands);

    case 214:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6406 (insn, operands);

    case 215:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6407 (insn, operands);

    case 216:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6408 (insn, operands);

    case 217:
      if (!((
#line 126 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6409 (insn, operands);

    case 218:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6410 (insn, operands);

    case 219:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6412 (insn, operands);

    case 220:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6414 (insn, operands);

    case 221:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6416 (insn, operands);

    case 222:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6418 (insn, operands);

    case 223:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6420 (insn, operands);

    case 224:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6422 (insn, operands);

    case 225:
      if (!(
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6506 (insn, operands);

    case 226:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6424 (insn, operands);

    case 227:
      if (!(
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6508 (insn, operands);

    case 228:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6426 (insn, operands);

    case 229:
      if (!(
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6510 (insn, operands);

    case 230:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6428 (insn, operands);

    case 231:
      if (!(
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6512 (insn, operands);

    case 232:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6430 (insn, operands);

    case 233:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6514 (insn, operands);

    case 234:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6432 (insn, operands);

    case 235:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6516 (insn, operands);

    case 236:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6566 (insn, operands);

    case 237:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6434 (insn, operands);

    case 238:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6518 (insn, operands);

    case 239:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6568 (insn, operands);

    case 240:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6436 (insn, operands);

    case 241:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6520 (insn, operands);

    case 242:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6570 (insn, operands);

    case 243:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6438 (insn, operands);

    case 244:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6522 (insn, operands);

    case 245:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6572 (insn, operands);

    case 246:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6440 (insn, operands);

    case 247:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6442 (insn, operands);

    case 248:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6444 (insn, operands);

    case 249:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6446 (insn, operands);

    case 250:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6448 (insn, operands);

    case 251:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6450 (insn, operands);

    case 252:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6452 (insn, operands);

    case 253:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6454 (insn, operands);

    case 254:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6456 (insn, operands);

    case 255:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6458 (insn, operands);

    case 256:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6460 (insn, operands);

    case 257:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6462 (insn, operands);

    case 258:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6464 (insn, operands);

    case 259:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6524 (insn, operands);

    case 260:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6466 (insn, operands);

    case 261:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6526 (insn, operands);

    case 262:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6468 (insn, operands);

    case 263:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6528 (insn, operands);

    case 264:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6470 (insn, operands);

    case 265:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6530 (insn, operands);

    case 266:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6472 (insn, operands);

    case 267:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6532 (insn, operands);

    case 268:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6474 (insn, operands);

    case 269:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6534 (insn, operands);

    case 270:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6476 (insn, operands);

    case 271:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6536 (insn, operands);

    case 272:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6478 (insn, operands);

    case 273:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6538 (insn, operands);

    case 274:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6480 (insn, operands);

    case 275:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6540 (insn, operands);

    case 276:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6482 (insn, operands);

    case 277:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6542 (insn, operands);

    case 278:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6484 (insn, operands);

    case 279:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6544 (insn, operands);

    case 280:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6486 (insn, operands);

    case 281:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6546 (insn, operands);

    case 282:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6574 (insn, operands);

    case 283:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6488 (insn, operands);

    case 284:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6548 (insn, operands);

    case 285:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6576 (insn, operands);

    case 286:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6490 (insn, operands);

    case 287:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6550 (insn, operands);

    case 288:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6578 (insn, operands);

    case 289:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6492 (insn, operands);

    case 290:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6552 (insn, operands);

    case 291:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6580 (insn, operands);

    case 292:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6494 (insn, operands);

    case 293:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6554 (insn, operands);

    case 294:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6582 (insn, operands);

    case 295:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6496 (insn, operands);

    case 296:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6556 (insn, operands);

    case 297:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6584 (insn, operands);

    case 298:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6498 (insn, operands);

    case 299:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6558 (insn, operands);

    case 300:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6586 (insn, operands);

    case 301:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6500 (insn, operands);

    case 302:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6560 (insn, operands);

    case 303:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6588 (insn, operands);

    case 304:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6502 (insn, operands);

    case 305:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6562 (insn, operands);

    case 306:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6590 (insn, operands);

    case 307:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6504 (insn, operands);

    case 308:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6564 (insn, operands);

    case 309:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6592 (insn, operands);

    case 310:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6411 (insn, operands);

    case 311:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6413 (insn, operands);

    case 312:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6415 (insn, operands);

    case 313:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6417 (insn, operands);

    case 314:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6419 (insn, operands);

    case 315:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6421 (insn, operands);

    case 316:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6423 (insn, operands);

    case 317:
      if (!(
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6507 (insn, operands);

    case 318:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6425 (insn, operands);

    case 319:
      if (!(
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6509 (insn, operands);

    case 320:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6427 (insn, operands);

    case 321:
      if (!(
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6511 (insn, operands);

    case 322:
      if (!(
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6429 (insn, operands);

    case 323:
      if (!(
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6513 (insn, operands);

    case 324:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6431 (insn, operands);

    case 325:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6515 (insn, operands);

    case 326:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6433 (insn, operands);

    case 327:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6517 (insn, operands);

    case 328:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6567 (insn, operands);

    case 329:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6435 (insn, operands);

    case 330:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6519 (insn, operands);

    case 331:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6569 (insn, operands);

    case 332:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6437 (insn, operands);

    case 333:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6521 (insn, operands);

    case 334:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6571 (insn, operands);

    case 335:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6439 (insn, operands);

    case 336:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6523 (insn, operands);

    case 337:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6573 (insn, operands);

    case 338:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6441 (insn, operands);

    case 339:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6443 (insn, operands);

    case 340:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6445 (insn, operands);

    case 341:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6447 (insn, operands);

    case 342:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6449 (insn, operands);

    case 343:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6451 (insn, operands);

    case 344:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6453 (insn, operands);

    case 345:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6455 (insn, operands);

    case 346:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6457 (insn, operands);

    case 347:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6459 (insn, operands);

    case 348:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6461 (insn, operands);

    case 349:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6463 (insn, operands);

    case 350:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6465 (insn, operands);

    case 351:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6525 (insn, operands);

    case 352:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6467 (insn, operands);

    case 353:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6527 (insn, operands);

    case 354:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6469 (insn, operands);

    case 355:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6529 (insn, operands);

    case 356:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6471 (insn, operands);

    case 357:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6531 (insn, operands);

    case 358:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6473 (insn, operands);

    case 359:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6533 (insn, operands);

    case 360:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6475 (insn, operands);

    case 361:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6535 (insn, operands);

    case 362:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6477 (insn, operands);

    case 363:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6537 (insn, operands);

    case 364:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6479 (insn, operands);

    case 365:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6539 (insn, operands);

    case 366:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6481 (insn, operands);

    case 367:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6541 (insn, operands);

    case 368:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6483 (insn, operands);

    case 369:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6543 (insn, operands);

    case 370:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6485 (insn, operands);

    case 371:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6545 (insn, operands);

    case 372:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6487 (insn, operands);

    case 373:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6547 (insn, operands);

    case 374:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6575 (insn, operands);

    case 375:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6489 (insn, operands);

    case 376:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6549 (insn, operands);

    case 377:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6577 (insn, operands);

    case 378:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6491 (insn, operands);

    case 379:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6551 (insn, operands);

    case 380:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6579 (insn, operands);

    case 381:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6493 (insn, operands);

    case 382:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6553 (insn, operands);

    case 383:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6581 (insn, operands);

    case 384:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6495 (insn, operands);

    case 385:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6555 (insn, operands);

    case 386:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6583 (insn, operands);

    case 387:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6497 (insn, operands);

    case 388:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6557 (insn, operands);

    case 389:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6585 (insn, operands);

    case 390:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6499 (insn, operands);

    case 391:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6559 (insn, operands);

    case 392:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6587 (insn, operands);

    case 393:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6501 (insn, operands);

    case 394:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6561 (insn, operands);

    case 395:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6589 (insn, operands);

    case 396:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6503 (insn, operands);

    case 397:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6563 (insn, operands);

    case 398:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6591 (insn, operands);

    case 399:
      if (!((
#line 144 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6505 (insn, operands);

    case 400:
      if (!((
#line 164 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6565 (insn, operands);

    case 401:
      if (!((
#line 184 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 186 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6593 (insn, operands);

    case 402:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6778 (insn, operands);

    case 403:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6779 (insn, operands);

    case 404:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6780 (insn, operands);

    case 405:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6781 (insn, operands);

    case 406:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6782 (insn, operands);

    case 407:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6783 (insn, operands);

    case 408:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6784 (insn, operands);

    case 409:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6785 (insn, operands);

    case 410:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6786 (insn, operands);

    case 411:
      if (!(
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6787 (insn, operands);

    case 412:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6788 (insn, operands);

    case 413:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6789 (insn, operands);

    case 414:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6790 (insn, operands);

    case 415:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6791 (insn, operands);

    case 416:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6792 (insn, operands);

    case 417:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6793 (insn, operands);

    case 418:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6794 (insn, operands);

    case 419:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6795 (insn, operands);

    case 420:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6796 (insn, operands);

    case 421:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6797 (insn, operands);

    case 422:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6798 (insn, operands);

    case 423:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6799 (insn, operands);

    case 424:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6800 (insn, operands);

    case 425:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6801 (insn, operands);

    case 426:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6802 (insn, operands);

    case 427:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6803 (insn, operands);

    case 428:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6804 (insn, operands);

    case 429:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6805 (insn, operands);

    case 430:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6806 (insn, operands);

    case 431:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6807 (insn, operands);

    case 432:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6808 (insn, operands);

    case 433:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6809 (insn, operands);

    case 434:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6810 (insn, operands);

    case 435:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6811 (insn, operands);

    case 436:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6812 (insn, operands);

    case 437:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6813 (insn, operands);

    case 438:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6814 (insn, operands);

    case 439:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6815 (insn, operands);

    case 440:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6816 (insn, operands);

    case 441:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6817 (insn, operands);

    case 442:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6818 (insn, operands);

    case 443:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6819 (insn, operands);

    case 444:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6820 (insn, operands);

    case 445:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6821 (insn, operands);

    case 446:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6822 (insn, operands);

    case 447:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6823 (insn, operands);

    case 448:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6824 (insn, operands);

    case 449:
      if (!((
#line 283 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6825 (insn, operands);

    case 450:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7420 (insn, operands);

    case 451:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7424 (insn, operands);

    case 452:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7428 (insn, operands);

    case 453:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7432 (insn, operands);

    case 454:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7436 (insn, operands);

    case 455:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7440 (insn, operands);

    case 456:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7444 (insn, operands);

    case 457:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7448 (insn, operands);

    case 458:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7452 (insn, operands);

    case 459:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7456 (insn, operands);

    case 460:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7460 (insn, operands);

    case 461:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7464 (insn, operands);

    case 462:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7468 (insn, operands);

    case 463:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7472 (insn, operands);

    case 464:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7476 (insn, operands);

    case 465:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7480 (insn, operands);

    case 466:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7484 (insn, operands);

    case 467:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7488 (insn, operands);

    case 468:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7492 (insn, operands);

    case 469:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7496 (insn, operands);

    case 470:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7500 (insn, operands);

    case 471:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7504 (insn, operands);

    case 472:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7508 (insn, operands);

    case 473:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7512 (insn, operands);

    case 474:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7516 (insn, operands);

    case 475:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7520 (insn, operands);

    case 476:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7524 (insn, operands);

    case 477:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7528 (insn, operands);

    case 478:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7532 (insn, operands);

    case 479:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7536 (insn, operands);

    case 480:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7540 (insn, operands);

    case 481:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7544 (insn, operands);

    case 482:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7548 (insn, operands);

    case 483:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7552 (insn, operands);

    case 484:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7556 (insn, operands);

    case 485:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7560 (insn, operands);

    case 486:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7564 (insn, operands);

    case 487:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7568 (insn, operands);

    case 488:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7572 (insn, operands);

    case 489:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7576 (insn, operands);

    case 490:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7580 (insn, operands);

    case 491:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7584 (insn, operands);

    case 492:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7588 (insn, operands);

    case 493:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7592 (insn, operands);

    case 494:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7596 (insn, operands);

    case 495:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7600 (insn, operands);

    case 496:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7604 (insn, operands);

    case 497:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7608 (insn, operands);

    case 498:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7422 (insn, operands);

    case 499:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7426 (insn, operands);

    case 500:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7430 (insn, operands);

    case 501:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7434 (insn, operands);

    case 502:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7438 (insn, operands);

    case 503:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7442 (insn, operands);

    case 504:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7446 (insn, operands);

    case 505:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7450 (insn, operands);

    case 506:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7454 (insn, operands);

    case 507:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7458 (insn, operands);

    case 508:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7462 (insn, operands);

    case 509:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7466 (insn, operands);

    case 510:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7470 (insn, operands);

    case 511:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7474 (insn, operands);

    case 512:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7478 (insn, operands);

    case 513:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7482 (insn, operands);

    case 514:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7486 (insn, operands);

    case 515:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7490 (insn, operands);

    case 516:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7494 (insn, operands);

    case 517:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7498 (insn, operands);

    case 518:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7502 (insn, operands);

    case 519:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7506 (insn, operands);

    case 520:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7510 (insn, operands);

    case 521:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7514 (insn, operands);

    case 522:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7518 (insn, operands);

    case 523:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7522 (insn, operands);

    case 524:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7526 (insn, operands);

    case 525:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7530 (insn, operands);

    case 526:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7534 (insn, operands);

    case 527:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7538 (insn, operands);

    case 528:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7542 (insn, operands);

    case 529:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7546 (insn, operands);

    case 530:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7550 (insn, operands);

    case 531:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7554 (insn, operands);

    case 532:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7558 (insn, operands);

    case 533:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7562 (insn, operands);

    case 534:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7566 (insn, operands);

    case 535:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7570 (insn, operands);

    case 536:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7574 (insn, operands);

    case 537:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7578 (insn, operands);

    case 538:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7582 (insn, operands);

    case 539:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7586 (insn, operands);

    case 540:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7590 (insn, operands);

    case 541:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7594 (insn, operands);

    case 542:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7598 (insn, operands);

    case 543:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7602 (insn, operands);

    case 544:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7606 (insn, operands);

    case 545:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7610 (insn, operands);

    case 546:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7612 (insn, operands);

    case 547:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7614 (insn, operands);

    case 548:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7616 (insn, operands);

    case 549:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7618 (insn, operands);

    case 550:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7620 (insn, operands);

    case 551:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7622 (insn, operands);

    case 552:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7624 (insn, operands);

    case 553:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7626 (insn, operands);

    case 554:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7628 (insn, operands);

    case 555:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7630 (insn, operands);

    case 556:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7632 (insn, operands);

    case 557:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7634 (insn, operands);

    case 558:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7636 (insn, operands);

    case 559:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7638 (insn, operands);

    case 560:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7640 (insn, operands);

    case 561:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7642 (insn, operands);

    case 562:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7644 (insn, operands);

    case 563:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7646 (insn, operands);

    case 564:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7648 (insn, operands);

    case 565:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7650 (insn, operands);

    case 566:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7652 (insn, operands);

    case 567:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7654 (insn, operands);

    case 568:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7656 (insn, operands);

    case 569:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7658 (insn, operands);

    case 570:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7660 (insn, operands);

    case 571:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7662 (insn, operands);

    case 572:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7664 (insn, operands);

    case 573:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7666 (insn, operands);

    case 574:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7668 (insn, operands);

    case 575:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7670 (insn, operands);

    case 576:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7672 (insn, operands);

    case 577:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7674 (insn, operands);

    case 578:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7676 (insn, operands);

    case 579:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7678 (insn, operands);

    case 580:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7680 (insn, operands);

    case 581:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7682 (insn, operands);

    case 582:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7684 (insn, operands);

    case 583:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7686 (insn, operands);

    case 584:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7688 (insn, operands);

    case 585:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7690 (insn, operands);

    case 586:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7692 (insn, operands);

    case 587:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7694 (insn, operands);

    case 588:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7696 (insn, operands);

    case 589:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7698 (insn, operands);

    case 590:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7700 (insn, operands);

    case 591:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7702 (insn, operands);

    case 592:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7704 (insn, operands);

    case 593:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7706 (insn, operands);

    case 594:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7421 (insn, operands);

    case 595:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7425 (insn, operands);

    case 596:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7429 (insn, operands);

    case 597:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7433 (insn, operands);

    case 598:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7437 (insn, operands);

    case 599:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7441 (insn, operands);

    case 600:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7445 (insn, operands);

    case 601:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7449 (insn, operands);

    case 602:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7453 (insn, operands);

    case 603:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7457 (insn, operands);

    case 604:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7461 (insn, operands);

    case 605:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7465 (insn, operands);

    case 606:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7469 (insn, operands);

    case 607:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7473 (insn, operands);

    case 608:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7477 (insn, operands);

    case 609:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7481 (insn, operands);

    case 610:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7485 (insn, operands);

    case 611:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7489 (insn, operands);

    case 612:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7493 (insn, operands);

    case 613:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7497 (insn, operands);

    case 614:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7501 (insn, operands);

    case 615:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7505 (insn, operands);

    case 616:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7509 (insn, operands);

    case 617:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7513 (insn, operands);

    case 618:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7517 (insn, operands);

    case 619:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7521 (insn, operands);

    case 620:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7525 (insn, operands);

    case 621:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7529 (insn, operands);

    case 622:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7533 (insn, operands);

    case 623:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7537 (insn, operands);

    case 624:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7541 (insn, operands);

    case 625:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7545 (insn, operands);

    case 626:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7549 (insn, operands);

    case 627:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7553 (insn, operands);

    case 628:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7557 (insn, operands);

    case 629:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7561 (insn, operands);

    case 630:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7565 (insn, operands);

    case 631:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7569 (insn, operands);

    case 632:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7573 (insn, operands);

    case 633:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7577 (insn, operands);

    case 634:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7581 (insn, operands);

    case 635:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7585 (insn, operands);

    case 636:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7589 (insn, operands);

    case 637:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7593 (insn, operands);

    case 638:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7597 (insn, operands);

    case 639:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7601 (insn, operands);

    case 640:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7605 (insn, operands);

    case 641:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7609 (insn, operands);

    case 642:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7423 (insn, operands);

    case 643:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7427 (insn, operands);

    case 644:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7431 (insn, operands);

    case 645:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7435 (insn, operands);

    case 646:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7439 (insn, operands);

    case 647:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7443 (insn, operands);

    case 648:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7447 (insn, operands);

    case 649:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7451 (insn, operands);

    case 650:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7455 (insn, operands);

    case 651:
      if (!(
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7459 (insn, operands);

    case 652:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7463 (insn, operands);

    case 653:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7467 (insn, operands);

    case 654:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7471 (insn, operands);

    case 655:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7475 (insn, operands);

    case 656:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7479 (insn, operands);

    case 657:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7483 (insn, operands);

    case 658:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7487 (insn, operands);

    case 659:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7491 (insn, operands);

    case 660:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7495 (insn, operands);

    case 661:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7499 (insn, operands);

    case 662:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7503 (insn, operands);

    case 663:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7507 (insn, operands);

    case 664:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7511 (insn, operands);

    case 665:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7515 (insn, operands);

    case 666:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7519 (insn, operands);

    case 667:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7523 (insn, operands);

    case 668:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7527 (insn, operands);

    case 669:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7531 (insn, operands);

    case 670:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7535 (insn, operands);

    case 671:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7539 (insn, operands);

    case 672:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7543 (insn, operands);

    case 673:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7547 (insn, operands);

    case 674:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7551 (insn, operands);

    case 675:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7555 (insn, operands);

    case 676:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7559 (insn, operands);

    case 677:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7563 (insn, operands);

    case 678:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7567 (insn, operands);

    case 679:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7571 (insn, operands);

    case 680:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7575 (insn, operands);

    case 681:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7579 (insn, operands);

    case 682:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7583 (insn, operands);

    case 683:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7587 (insn, operands);

    case 684:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7591 (insn, operands);

    case 685:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7595 (insn, operands);

    case 686:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7599 (insn, operands);

    case 687:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7603 (insn, operands);

    case 688:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7607 (insn, operands);

    case 689:
      if (!((
#line 500 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7611 (insn, operands);

    case 690:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7613 (insn, operands);

    case 691:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7615 (insn, operands);

    case 692:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7617 (insn, operands);

    case 693:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7619 (insn, operands);

    case 694:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7621 (insn, operands);

    case 695:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7623 (insn, operands);

    case 696:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7625 (insn, operands);

    case 697:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7627 (insn, operands);

    case 698:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7629 (insn, operands);

    case 699:
      if (!(
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7631 (insn, operands);

    case 700:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7633 (insn, operands);

    case 701:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7635 (insn, operands);

    case 702:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7637 (insn, operands);

    case 703:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7639 (insn, operands);

    case 704:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7641 (insn, operands);

    case 705:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7643 (insn, operands);

    case 706:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7645 (insn, operands);

    case 707:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7647 (insn, operands);

    case 708:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7649 (insn, operands);

    case 709:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7651 (insn, operands);

    case 710:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7653 (insn, operands);

    case 711:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7655 (insn, operands);

    case 712:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7657 (insn, operands);

    case 713:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7659 (insn, operands);

    case 714:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7661 (insn, operands);

    case 715:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7663 (insn, operands);

    case 716:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7665 (insn, operands);

    case 717:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7667 (insn, operands);

    case 718:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7669 (insn, operands);

    case 719:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7671 (insn, operands);

    case 720:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7673 (insn, operands);

    case 721:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7675 (insn, operands);

    case 722:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7677 (insn, operands);

    case 723:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7679 (insn, operands);

    case 724:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7681 (insn, operands);

    case 725:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7683 (insn, operands);

    case 726:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7685 (insn, operands);

    case 727:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7687 (insn, operands);

    case 728:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7689 (insn, operands);

    case 729:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7691 (insn, operands);

    case 730:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7693 (insn, operands);

    case 731:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7695 (insn, operands);

    case 732:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7697 (insn, operands);

    case 733:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7699 (insn, operands);

    case 734:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7701 (insn, operands);

    case 735:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7703 (insn, operands);

    case 736:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7705 (insn, operands);

    case 737:
      if (!((
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7707 (insn, operands);

    case 738:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6826 (insn, operands);

    case 739:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6827 (insn, operands);

    case 740:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6828 (insn, operands);

    case 741:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6829 (insn, operands);

    case 742:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6830 (insn, operands);

    case 743:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6831 (insn, operands);

    case 744:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6832 (insn, operands);

    case 745:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6833 (insn, operands);

    case 746:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6834 (insn, operands);

    case 747:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6835 (insn, operands);

    case 748:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6836 (insn, operands);

    case 749:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6837 (insn, operands);

    case 750:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6838 (insn, operands);

    case 751:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6839 (insn, operands);

    case 752:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6840 (insn, operands);

    case 753:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6841 (insn, operands);

    case 754:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6842 (insn, operands);

    case 755:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6843 (insn, operands);

    case 756:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6844 (insn, operands);

    case 757:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6845 (insn, operands);

    case 758:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6846 (insn, operands);

    case 759:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6847 (insn, operands);

    case 760:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6848 (insn, operands);

    case 761:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6849 (insn, operands);

    case 762:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6850 (insn, operands);

    case 763:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6851 (insn, operands);

    case 764:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6852 (insn, operands);

    case 765:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6853 (insn, operands);

    case 766:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6854 (insn, operands);

    case 767:
      if (!((
#line 303 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 305 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6855 (insn, operands);

    case 768:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6886 (insn, operands);

    case 769:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6887 (insn, operands);

    case 770:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6888 (insn, operands);

    case 771:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6889 (insn, operands);

    case 772:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6890 (insn, operands);

    case 773:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6891 (insn, operands);

    case 774:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6892 (insn, operands);

    case 775:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6893 (insn, operands);

    case 776:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6894 (insn, operands);

    case 777:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6895 (insn, operands);

    case 778:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6896 (insn, operands);

    case 779:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6897 (insn, operands);

    case 780:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6898 (insn, operands);

    case 781:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6899 (insn, operands);

    case 782:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6900 (insn, operands);

    case 783:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6901 (insn, operands);

    case 784:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6902 (insn, operands);

    case 785:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6903 (insn, operands);

    case 786:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6904 (insn, operands);

    case 787:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6905 (insn, operands);

    case 788:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6906 (insn, operands);

    case 789:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6907 (insn, operands);

    case 790:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6908 (insn, operands);

    case 791:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6909 (insn, operands);

    case 792:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6910 (insn, operands);

    case 793:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6911 (insn, operands);

    case 794:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6912 (insn, operands);

    case 795:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6913 (insn, operands);

    case 796:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6914 (insn, operands);

    case 797:
      if (!((
#line 350 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 352 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6915 (insn, operands);

    case 798:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6916 (insn, operands);

    case 799:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6918 (insn, operands);

    case 800:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7276 (insn, operands);

    case 801:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6920 (insn, operands);

    case 802:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7278 (insn, operands);

    case 803:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6922 (insn, operands);

    case 804:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7280 (insn, operands);

    case 805:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6924 (insn, operands);

    case 806:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7282 (insn, operands);

    case 807:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6926 (insn, operands);

    case 808:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7284 (insn, operands);

    case 809:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6928 (insn, operands);

    case 810:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7108 (insn, operands);

    case 811:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6930 (insn, operands);

    case 812:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7110 (insn, operands);

    case 813:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7286 (insn, operands);

    case 814:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6932 (insn, operands);

    case 815:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7112 (insn, operands);

    case 816:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7288 (insn, operands);

    case 817:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6934 (insn, operands);

    case 818:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7114 (insn, operands);

    case 819:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7290 (insn, operands);

    case 820:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6936 (insn, operands);

    case 821:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7116 (insn, operands);

    case 822:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7292 (insn, operands);

    case 823:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6938 (insn, operands);

    case 824:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7118 (insn, operands);

    case 825:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6940 (insn, operands);

    case 826:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7120 (insn, operands);

    case 827:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6942 (insn, operands);

    case 828:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7122 (insn, operands);

    case 829:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6944 (insn, operands);

    case 830:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7124 (insn, operands);

    case 831:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6946 (insn, operands);

    case 832:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7318 (insn, operands);

    case 833:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6948 (insn, operands);

    case 834:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7320 (insn, operands);

    case 835:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6950 (insn, operands);

    case 836:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7322 (insn, operands);

    case 837:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6952 (insn, operands);

    case 838:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7324 (insn, operands);

    case 839:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6954 (insn, operands);

    case 840:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7326 (insn, operands);

    case 841:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6956 (insn, operands);

    case 842:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7328 (insn, operands);

    case 843:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6958 (insn, operands);

    case 844:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7330 (insn, operands);

    case 845:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6960 (insn, operands);

    case 846:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7332 (insn, operands);

    case 847:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6962 (insn, operands);

    case 848:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7334 (insn, operands);

    case 849:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6964 (insn, operands);

    case 850:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7336 (insn, operands);

    case 851:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6966 (insn, operands);

    case 852:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7338 (insn, operands);

    case 853:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6968 (insn, operands);

    case 854:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6970 (insn, operands);

    case 855:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7126 (insn, operands);

    case 856:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7340 (insn, operands);

    case 857:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6972 (insn, operands);

    case 858:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7128 (insn, operands);

    case 859:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7342 (insn, operands);

    case 860:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6974 (insn, operands);

    case 861:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7130 (insn, operands);

    case 862:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7344 (insn, operands);

    case 863:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6976 (insn, operands);

    case 864:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7132 (insn, operands);

    case 865:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7346 (insn, operands);

    case 866:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6978 (insn, operands);

    case 867:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7134 (insn, operands);

    case 868:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7348 (insn, operands);

    case 869:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6980 (insn, operands);

    case 870:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7136 (insn, operands);

    case 871:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7350 (insn, operands);

    case 872:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6982 (insn, operands);

    case 873:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7138 (insn, operands);

    case 874:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7352 (insn, operands);

    case 875:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6984 (insn, operands);

    case 876:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7140 (insn, operands);

    case 877:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7354 (insn, operands);

    case 878:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6986 (insn, operands);

    case 879:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7142 (insn, operands);

    case 880:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7356 (insn, operands);

    case 881:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6988 (insn, operands);

    case 882:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7144 (insn, operands);

    case 883:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7358 (insn, operands);

    case 884:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6990 (insn, operands);

    case 885:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7146 (insn, operands);

    case 886:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6992 (insn, operands);

    case 887:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7148 (insn, operands);

    case 888:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6994 (insn, operands);

    case 889:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7150 (insn, operands);

    case 890:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6996 (insn, operands);

    case 891:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7152 (insn, operands);

    case 892:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6998 (insn, operands);

    case 893:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7154 (insn, operands);

    case 894:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7000 (insn, operands);

    case 895:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7156 (insn, operands);

    case 896:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7002 (insn, operands);

    case 897:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7158 (insn, operands);

    case 898:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7004 (insn, operands);

    case 899:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7160 (insn, operands);

    case 900:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7006 (insn, operands);

    case 901:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7162 (insn, operands);

    case 902:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7008 (insn, operands);

    case 903:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7164 (insn, operands);

    case 904:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7010 (insn, operands);

    case 905:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7166 (insn, operands);

    case 906:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7264 (insn, operands);

    case 907:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7266 (insn, operands);

    case 908:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7268 (insn, operands);

    case 909:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7270 (insn, operands);

    case 910:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7272 (insn, operands);

    case 911:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7274 (insn, operands);

    case 912:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7294 (insn, operands);

    case 913:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7296 (insn, operands);

    case 914:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7298 (insn, operands);

    case 915:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7300 (insn, operands);

    case 916:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7302 (insn, operands);

    case 917:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7304 (insn, operands);

    case 918:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7306 (insn, operands);

    case 919:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7308 (insn, operands);

    case 920:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7310 (insn, operands);

    case 921:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7312 (insn, operands);

    case 922:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7314 (insn, operands);

    case 923:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7316 (insn, operands);

    case 924:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6917 (insn, operands);

    case 925:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6919 (insn, operands);

    case 926:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7277 (insn, operands);

    case 927:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6921 (insn, operands);

    case 928:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7279 (insn, operands);

    case 929:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6923 (insn, operands);

    case 930:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7281 (insn, operands);

    case 931:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6925 (insn, operands);

    case 932:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7283 (insn, operands);

    case 933:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6927 (insn, operands);

    case 934:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7285 (insn, operands);

    case 935:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6929 (insn, operands);

    case 936:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7109 (insn, operands);

    case 937:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6931 (insn, operands);

    case 938:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7111 (insn, operands);

    case 939:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7287 (insn, operands);

    case 940:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6933 (insn, operands);

    case 941:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7113 (insn, operands);

    case 942:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7289 (insn, operands);

    case 943:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6935 (insn, operands);

    case 944:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7115 (insn, operands);

    case 945:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7291 (insn, operands);

    case 946:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6937 (insn, operands);

    case 947:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7117 (insn, operands);

    case 948:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7293 (insn, operands);

    case 949:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6939 (insn, operands);

    case 950:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7119 (insn, operands);

    case 951:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6941 (insn, operands);

    case 952:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7121 (insn, operands);

    case 953:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6943 (insn, operands);

    case 954:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7123 (insn, operands);

    case 955:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6945 (insn, operands);

    case 956:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7125 (insn, operands);

    case 957:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6947 (insn, operands);

    case 958:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7319 (insn, operands);

    case 959:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6949 (insn, operands);

    case 960:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7321 (insn, operands);

    case 961:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6951 (insn, operands);

    case 962:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7323 (insn, operands);

    case 963:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6953 (insn, operands);

    case 964:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7325 (insn, operands);

    case 965:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6955 (insn, operands);

    case 966:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7327 (insn, operands);

    case 967:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6957 (insn, operands);

    case 968:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7329 (insn, operands);

    case 969:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6959 (insn, operands);

    case 970:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7331 (insn, operands);

    case 971:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6961 (insn, operands);

    case 972:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7333 (insn, operands);

    case 973:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6963 (insn, operands);

    case 974:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7335 (insn, operands);

    case 975:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6965 (insn, operands);

    case 976:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7337 (insn, operands);

    case 977:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6967 (insn, operands);

    case 978:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7339 (insn, operands);

    case 979:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6969 (insn, operands);

    case 980:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6971 (insn, operands);

    case 981:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7127 (insn, operands);

    case 982:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7341 (insn, operands);

    case 983:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6973 (insn, operands);

    case 984:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7129 (insn, operands);

    case 985:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7343 (insn, operands);

    case 986:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6975 (insn, operands);

    case 987:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7131 (insn, operands);

    case 988:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7345 (insn, operands);

    case 989:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6977 (insn, operands);

    case 990:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7133 (insn, operands);

    case 991:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7347 (insn, operands);

    case 992:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6979 (insn, operands);

    case 993:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7135 (insn, operands);

    case 994:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7349 (insn, operands);

    case 995:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6981 (insn, operands);

    case 996:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7137 (insn, operands);

    case 997:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7351 (insn, operands);

    case 998:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6983 (insn, operands);

    case 999:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7139 (insn, operands);

    case 1000:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7353 (insn, operands);

    case 1001:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6985 (insn, operands);

    case 1002:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7141 (insn, operands);

    case 1003:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7355 (insn, operands);

    case 1004:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6987 (insn, operands);

    case 1005:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7143 (insn, operands);

    case 1006:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7357 (insn, operands);

    case 1007:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6989 (insn, operands);

    case 1008:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7145 (insn, operands);

    case 1009:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7359 (insn, operands);

    case 1010:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6991 (insn, operands);

    case 1011:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7147 (insn, operands);

    case 1012:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6993 (insn, operands);

    case 1013:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7149 (insn, operands);

    case 1014:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6995 (insn, operands);

    case 1015:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7151 (insn, operands);

    case 1016:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6997 (insn, operands);

    case 1017:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7153 (insn, operands);

    case 1018:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6999 (insn, operands);

    case 1019:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7155 (insn, operands);

    case 1020:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7001 (insn, operands);

    case 1021:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7157 (insn, operands);

    case 1022:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7003 (insn, operands);

    case 1023:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7159 (insn, operands);

    case 1024:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7005 (insn, operands);

    case 1025:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7161 (insn, operands);

    case 1026:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7007 (insn, operands);

    case 1027:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7163 (insn, operands);

    case 1028:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7009 (insn, operands);

    case 1029:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7165 (insn, operands);

    case 1030:
      if (!((
#line 371 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7011 (insn, operands);

    case 1031:
      if (!((
#line 413 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7167 (insn, operands);

    case 1032:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7265 (insn, operands);

    case 1033:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7267 (insn, operands);

    case 1034:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7269 (insn, operands);

    case 1035:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7271 (insn, operands);

    case 1036:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7273 (insn, operands);

    case 1037:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7275 (insn, operands);

    case 1038:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7295 (insn, operands);

    case 1039:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7297 (insn, operands);

    case 1040:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7299 (insn, operands);

    case 1041:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7301 (insn, operands);

    case 1042:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7303 (insn, operands);

    case 1043:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7305 (insn, operands);

    case 1044:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7307 (insn, operands);

    case 1045:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7309 (insn, operands);

    case 1046:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7311 (insn, operands);

    case 1047:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7313 (insn, operands);

    case 1048:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7315 (insn, operands);

    case 1049:
      if (!((
#line 455 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7317 (insn, operands);

    case 1050:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7012 (insn, operands);

    case 1051:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7168 (insn, operands);

    case 1052:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7014 (insn, operands);

    case 1053:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7170 (insn, operands);

    case 1054:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7360 (insn, operands);

    case 1055:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7016 (insn, operands);

    case 1056:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7172 (insn, operands);

    case 1057:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7362 (insn, operands);

    case 1058:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7018 (insn, operands);

    case 1059:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7174 (insn, operands);

    case 1060:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7364 (insn, operands);

    case 1061:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7020 (insn, operands);

    case 1062:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7176 (insn, operands);

    case 1063:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7366 (insn, operands);

    case 1064:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7022 (insn, operands);

    case 1065:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7178 (insn, operands);

    case 1066:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7368 (insn, operands);

    case 1067:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7024 (insn, operands);

    case 1068:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7180 (insn, operands);

    case 1069:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7026 (insn, operands);

    case 1070:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7182 (insn, operands);

    case 1071:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7370 (insn, operands);

    case 1072:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7028 (insn, operands);

    case 1073:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7184 (insn, operands);

    case 1074:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7372 (insn, operands);

    case 1075:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7030 (insn, operands);

    case 1076:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7186 (insn, operands);

    case 1077:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7374 (insn, operands);

    case 1078:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7032 (insn, operands);

    case 1079:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7188 (insn, operands);

    case 1080:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7376 (insn, operands);

    case 1081:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7034 (insn, operands);

    case 1082:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7190 (insn, operands);

    case 1083:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7036 (insn, operands);

    case 1084:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7192 (insn, operands);

    case 1085:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7038 (insn, operands);

    case 1086:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7194 (insn, operands);

    case 1087:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7040 (insn, operands);

    case 1088:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7196 (insn, operands);

    case 1089:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7042 (insn, operands);

    case 1090:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7198 (insn, operands);

    case 1091:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7378 (insn, operands);

    case 1092:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7044 (insn, operands);

    case 1093:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7200 (insn, operands);

    case 1094:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7380 (insn, operands);

    case 1095:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7046 (insn, operands);

    case 1096:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7202 (insn, operands);

    case 1097:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7382 (insn, operands);

    case 1098:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7048 (insn, operands);

    case 1099:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7204 (insn, operands);

    case 1100:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7384 (insn, operands);

    case 1101:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7050 (insn, operands);

    case 1102:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7206 (insn, operands);

    case 1103:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7386 (insn, operands);

    case 1104:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7052 (insn, operands);

    case 1105:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7208 (insn, operands);

    case 1106:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7388 (insn, operands);

    case 1107:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7054 (insn, operands);

    case 1108:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7210 (insn, operands);

    case 1109:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7390 (insn, operands);

    case 1110:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7056 (insn, operands);

    case 1111:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7212 (insn, operands);

    case 1112:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7392 (insn, operands);

    case 1113:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7058 (insn, operands);

    case 1114:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7214 (insn, operands);

    case 1115:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7394 (insn, operands);

    case 1116:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7060 (insn, operands);

    case 1117:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7216 (insn, operands);

    case 1118:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7396 (insn, operands);

    case 1119:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7062 (insn, operands);

    case 1120:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7218 (insn, operands);

    case 1121:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7398 (insn, operands);

    case 1122:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7064 (insn, operands);

    case 1123:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7220 (insn, operands);

    case 1124:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7066 (insn, operands);

    case 1125:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7222 (insn, operands);

    case 1126:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7400 (insn, operands);

    case 1127:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7068 (insn, operands);

    case 1128:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7224 (insn, operands);

    case 1129:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7402 (insn, operands);

    case 1130:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7070 (insn, operands);

    case 1131:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7226 (insn, operands);

    case 1132:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7404 (insn, operands);

    case 1133:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7072 (insn, operands);

    case 1134:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7228 (insn, operands);

    case 1135:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7406 (insn, operands);

    case 1136:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7074 (insn, operands);

    case 1137:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7230 (insn, operands);

    case 1138:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7408 (insn, operands);

    case 1139:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7076 (insn, operands);

    case 1140:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7232 (insn, operands);

    case 1141:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7410 (insn, operands);

    case 1142:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7078 (insn, operands);

    case 1143:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7234 (insn, operands);

    case 1144:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7412 (insn, operands);

    case 1145:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7080 (insn, operands);

    case 1146:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7236 (insn, operands);

    case 1147:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7414 (insn, operands);

    case 1148:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7082 (insn, operands);

    case 1149:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7238 (insn, operands);

    case 1150:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7416 (insn, operands);

    case 1151:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7084 (insn, operands);

    case 1152:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7240 (insn, operands);

    case 1153:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7418 (insn, operands);

    case 1154:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7086 (insn, operands);

    case 1155:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7242 (insn, operands);

    case 1156:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7088 (insn, operands);

    case 1157:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7244 (insn, operands);

    case 1158:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7090 (insn, operands);

    case 1159:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7246 (insn, operands);

    case 1160:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7092 (insn, operands);

    case 1161:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7248 (insn, operands);

    case 1162:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7094 (insn, operands);

    case 1163:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7250 (insn, operands);

    case 1164:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7096 (insn, operands);

    case 1165:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7252 (insn, operands);

    case 1166:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7098 (insn, operands);

    case 1167:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7254 (insn, operands);

    case 1168:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7100 (insn, operands);

    case 1169:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7256 (insn, operands);

    case 1170:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7102 (insn, operands);

    case 1171:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7258 (insn, operands);

    case 1172:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7104 (insn, operands);

    case 1173:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7260 (insn, operands);

    case 1174:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7106 (insn, operands);

    case 1175:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7262 (insn, operands);

    case 1176:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7013 (insn, operands);

    case 1177:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7169 (insn, operands);

    case 1178:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7015 (insn, operands);

    case 1179:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7171 (insn, operands);

    case 1180:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7361 (insn, operands);

    case 1181:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7017 (insn, operands);

    case 1182:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7173 (insn, operands);

    case 1183:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7363 (insn, operands);

    case 1184:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7019 (insn, operands);

    case 1185:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7175 (insn, operands);

    case 1186:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7365 (insn, operands);

    case 1187:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7021 (insn, operands);

    case 1188:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7177 (insn, operands);

    case 1189:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7367 (insn, operands);

    case 1190:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7023 (insn, operands);

    case 1191:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7179 (insn, operands);

    case 1192:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7369 (insn, operands);

    case 1193:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7025 (insn, operands);

    case 1194:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7181 (insn, operands);

    case 1195:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7027 (insn, operands);

    case 1196:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7183 (insn, operands);

    case 1197:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7371 (insn, operands);

    case 1198:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7029 (insn, operands);

    case 1199:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7185 (insn, operands);

    case 1200:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7373 (insn, operands);

    case 1201:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7031 (insn, operands);

    case 1202:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7187 (insn, operands);

    case 1203:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7375 (insn, operands);

    case 1204:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7033 (insn, operands);

    case 1205:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7189 (insn, operands);

    case 1206:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7377 (insn, operands);

    case 1207:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7035 (insn, operands);

    case 1208:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7191 (insn, operands);

    case 1209:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7037 (insn, operands);

    case 1210:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7193 (insn, operands);

    case 1211:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7039 (insn, operands);

    case 1212:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7195 (insn, operands);

    case 1213:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7041 (insn, operands);

    case 1214:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7197 (insn, operands);

    case 1215:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7043 (insn, operands);

    case 1216:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7199 (insn, operands);

    case 1217:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7379 (insn, operands);

    case 1218:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7045 (insn, operands);

    case 1219:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7201 (insn, operands);

    case 1220:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7381 (insn, operands);

    case 1221:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7047 (insn, operands);

    case 1222:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7203 (insn, operands);

    case 1223:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7383 (insn, operands);

    case 1224:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7049 (insn, operands);

    case 1225:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7205 (insn, operands);

    case 1226:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7385 (insn, operands);

    case 1227:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7051 (insn, operands);

    case 1228:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7207 (insn, operands);

    case 1229:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7387 (insn, operands);

    case 1230:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7053 (insn, operands);

    case 1231:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7209 (insn, operands);

    case 1232:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7389 (insn, operands);

    case 1233:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7055 (insn, operands);

    case 1234:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7211 (insn, operands);

    case 1235:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7391 (insn, operands);

    case 1236:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7057 (insn, operands);

    case 1237:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7213 (insn, operands);

    case 1238:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7393 (insn, operands);

    case 1239:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7059 (insn, operands);

    case 1240:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7215 (insn, operands);

    case 1241:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7395 (insn, operands);

    case 1242:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7061 (insn, operands);

    case 1243:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7217 (insn, operands);

    case 1244:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7397 (insn, operands);

    case 1245:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7063 (insn, operands);

    case 1246:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7219 (insn, operands);

    case 1247:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7399 (insn, operands);

    case 1248:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7065 (insn, operands);

    case 1249:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7221 (insn, operands);

    case 1250:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7067 (insn, operands);

    case 1251:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7223 (insn, operands);

    case 1252:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7401 (insn, operands);

    case 1253:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7069 (insn, operands);

    case 1254:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7225 (insn, operands);

    case 1255:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7403 (insn, operands);

    case 1256:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7071 (insn, operands);

    case 1257:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7227 (insn, operands);

    case 1258:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7405 (insn, operands);

    case 1259:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7073 (insn, operands);

    case 1260:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7229 (insn, operands);

    case 1261:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7407 (insn, operands);

    case 1262:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7075 (insn, operands);

    case 1263:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7231 (insn, operands);

    case 1264:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7409 (insn, operands);

    case 1265:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7077 (insn, operands);

    case 1266:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7233 (insn, operands);

    case 1267:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7411 (insn, operands);

    case 1268:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7079 (insn, operands);

    case 1269:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7235 (insn, operands);

    case 1270:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7413 (insn, operands);

    case 1271:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7081 (insn, operands);

    case 1272:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7237 (insn, operands);

    case 1273:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7415 (insn, operands);

    case 1274:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7083 (insn, operands);

    case 1275:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7239 (insn, operands);

    case 1276:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7417 (insn, operands);

    case 1277:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7085 (insn, operands);

    case 1278:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7241 (insn, operands);

    case 1279:
      if (!((
#line 476 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7419 (insn, operands);

    case 1280:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7087 (insn, operands);

    case 1281:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7243 (insn, operands);

    case 1282:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7089 (insn, operands);

    case 1283:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7245 (insn, operands);

    case 1284:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7091 (insn, operands);

    case 1285:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7247 (insn, operands);

    case 1286:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7093 (insn, operands);

    case 1287:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7249 (insn, operands);

    case 1288:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7095 (insn, operands);

    case 1289:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7251 (insn, operands);

    case 1290:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7097 (insn, operands);

    case 1291:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7253 (insn, operands);

    case 1292:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7099 (insn, operands);

    case 1293:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7255 (insn, operands);

    case 1294:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7101 (insn, operands);

    case 1295:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7257 (insn, operands);

    case 1296:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7103 (insn, operands);

    case 1297:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7259 (insn, operands);

    case 1298:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7105 (insn, operands);

    case 1299:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7261 (insn, operands);

    case 1300:
      if (!((
#line 392 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7107 (insn, operands);

    case 1301:
      if (!((
#line 434 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7263 (insn, operands);

    case 1302:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7708 (insn, operands);

    case 1303:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7710 (insn, operands);

    case 1304:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7712 (insn, operands);

    case 1305:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7714 (insn, operands);

    case 1306:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7716 (insn, operands);

    case 1307:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7718 (insn, operands);

    case 1308:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7720 (insn, operands);

    case 1309:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7722 (insn, operands);

    case 1310:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7724 (insn, operands);

    case 1311:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7726 (insn, operands);

    case 1312:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7728 (insn, operands);

    case 1313:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7730 (insn, operands);

    case 1314:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7732 (insn, operands);

    case 1315:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7734 (insn, operands);

    case 1316:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7736 (insn, operands);

    case 1317:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7738 (insn, operands);

    case 1318:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7740 (insn, operands);

    case 1319:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7742 (insn, operands);

    case 1320:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7744 (insn, operands);

    case 1321:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7746 (insn, operands);

    case 1322:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7748 (insn, operands);

    case 1323:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7750 (insn, operands);

    case 1324:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7752 (insn, operands);

    case 1325:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7754 (insn, operands);

    case 1326:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7756 (insn, operands);

    case 1327:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7758 (insn, operands);

    case 1328:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7760 (insn, operands);

    case 1329:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7762 (insn, operands);

    case 1330:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7764 (insn, operands);

    case 1331:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7766 (insn, operands);

    case 1332:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7768 (insn, operands);

    case 1333:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7770 (insn, operands);

    case 1334:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7772 (insn, operands);

    case 1335:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7774 (insn, operands);

    case 1336:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7776 (insn, operands);

    case 1337:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7778 (insn, operands);

    case 1338:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7780 (insn, operands);

    case 1339:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7782 (insn, operands);

    case 1340:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7784 (insn, operands);

    case 1341:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7786 (insn, operands);

    case 1342:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7788 (insn, operands);

    case 1343:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7790 (insn, operands);

    case 1344:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7792 (insn, operands);

    case 1345:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7794 (insn, operands);

    case 1346:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7796 (insn, operands);

    case 1347:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7798 (insn, operands);

    case 1348:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7800 (insn, operands);

    case 1349:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7802 (insn, operands);

    case 1350:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7804 (insn, operands);

    case 1351:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7806 (insn, operands);

    case 1352:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7808 (insn, operands);

    case 1353:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7810 (insn, operands);

    case 1354:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7812 (insn, operands);

    case 1355:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7814 (insn, operands);

    case 1356:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7816 (insn, operands);

    case 1357:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7818 (insn, operands);

    case 1358:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7820 (insn, operands);

    case 1359:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7822 (insn, operands);

    case 1360:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7824 (insn, operands);

    case 1361:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7826 (insn, operands);

    case 1362:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7828 (insn, operands);

    case 1363:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7830 (insn, operands);

    case 1364:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7832 (insn, operands);

    case 1365:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7834 (insn, operands);

    case 1366:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7836 (insn, operands);

    case 1367:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7838 (insn, operands);

    case 1368:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7840 (insn, operands);

    case 1369:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7842 (insn, operands);

    case 1370:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7709 (insn, operands);

    case 1371:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7711 (insn, operands);

    case 1372:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7713 (insn, operands);

    case 1373:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7715 (insn, operands);

    case 1374:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7717 (insn, operands);

    case 1375:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7719 (insn, operands);

    case 1376:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7721 (insn, operands);

    case 1377:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7723 (insn, operands);

    case 1378:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7725 (insn, operands);

    case 1379:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7727 (insn, operands);

    case 1380:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7729 (insn, operands);

    case 1381:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7731 (insn, operands);

    case 1382:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7733 (insn, operands);

    case 1383:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7735 (insn, operands);

    case 1384:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7737 (insn, operands);

    case 1385:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7739 (insn, operands);

    case 1386:
      if (!(
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7741 (insn, operands);

    case 1387:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7743 (insn, operands);

    case 1388:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7745 (insn, operands);

    case 1389:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7747 (insn, operands);

    case 1390:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7749 (insn, operands);

    case 1391:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7751 (insn, operands);

    case 1392:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7753 (insn, operands);

    case 1393:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7755 (insn, operands);

    case 1394:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7757 (insn, operands);

    case 1395:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7759 (insn, operands);

    case 1396:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7761 (insn, operands);

    case 1397:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7763 (insn, operands);

    case 1398:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7765 (insn, operands);

    case 1399:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7767 (insn, operands);

    case 1400:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7769 (insn, operands);

    case 1401:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7771 (insn, operands);

    case 1402:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7773 (insn, operands);

    case 1403:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7775 (insn, operands);

    case 1404:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7777 (insn, operands);

    case 1405:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7779 (insn, operands);

    case 1406:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7781 (insn, operands);

    case 1407:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7783 (insn, operands);

    case 1408:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7785 (insn, operands);

    case 1409:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7787 (insn, operands);

    case 1410:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7789 (insn, operands);

    case 1411:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7791 (insn, operands);

    case 1412:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7793 (insn, operands);

    case 1413:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7795 (insn, operands);

    case 1414:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7797 (insn, operands);

    case 1415:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7799 (insn, operands);

    case 1416:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7801 (insn, operands);

    case 1417:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7803 (insn, operands);

    case 1418:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7805 (insn, operands);

    case 1419:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7807 (insn, operands);

    case 1420:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7809 (insn, operands);

    case 1421:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7811 (insn, operands);

    case 1422:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7813 (insn, operands);

    case 1423:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7815 (insn, operands);

    case 1424:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7817 (insn, operands);

    case 1425:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7819 (insn, operands);

    case 1426:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7821 (insn, operands);

    case 1427:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7823 (insn, operands);

    case 1428:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7825 (insn, operands);

    case 1429:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7827 (insn, operands);

    case 1430:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7829 (insn, operands);

    case 1431:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7831 (insn, operands);

    case 1432:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7833 (insn, operands);

    case 1433:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7835 (insn, operands);

    case 1434:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7837 (insn, operands);

    case 1435:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7839 (insn, operands);

    case 1436:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7841 (insn, operands);

    case 1437:
      if (!((
#line 544 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.1.1-20250425/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.1.1-20250425/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7843 (insn, operands);

    default:
      return NULL;
    }
}
